/*
FileName:AdminManageEmployeetaskPending.js
Version:1.0.0
Purpose:Shows the list of maintask list
Devloper:Rishitha,Harsha
*/
import React, { Component } from 'react';
import { Platform, StyleSheet, Text, View, Dimensions, TouchableOpacity, FlatList, Image, Alert } from 'react-native';
import { Left, Button, Container, Header, Content, Item, Input } from 'native-base';
import AsyncStorage from '@react-native-community/async-storage';
import { widthPercentageToDP as wp, heightPercentageToDP as hp } from 'react-native-responsive-screen';
import { Collapse, CollapseHeader, CollapseBody } from "accordion-collapse-react-native";
import { API } from "../WebServices/RestClient";
import NetInfo from '@react-native-community/netinfo';
import Snackbar from 'react-native-snackbar';
import log from '../LogFile/Log';
import Icon from 'react-native-vector-icons/FontAwesome';
import {
  BallIndicator,
  BarIndicator,
  DotIndicator,
  MaterialIndicator,
  PacmanIndicator,
  PulseIndicator,
  SkypeIndicator,
  UIActivityIndicator
} from 'react-native-indicators';
class ListItem extends React.Component {
  render() {
    const { item } = this.props;

    // Getting current date and time
    var currentdate = new Date();
    var datetime = currentdate.getFullYear() + "-"
      + (currentdate.getMonth() + 1) + "-"
      + currentdate.getDate() + "  "
      + currentdate.getHours() + ":"
      + currentdate.getMinutes() + ":"
      + currentdate.getSeconds();
    let Dependency = <View style={styles.box1}>
      <View style={{ flexDirection: 'row', width: wp('50%') }}>
        <Text style={styles.signUpText000} >Dependency:</Text>
        <Text style={styles.signUpText111} >{item.dependencyTitle}</Text>
      </View>
      <View style={{ width: wp('40%'), paddingRight: 20 }}>
        <Text style={styles.signUpText002} >Dependent:{item.dependencyUser}</Text>
      </View>
    </View>
    return (

      <View>
        <Collapse style={[item.status == 'pending' ? [item.cDate >= item.targetDate ? styles.container : styles.container1] : styles.container1]}>
          <CollapseHeader style={styles.boxheader}>

            <View style={{ flexDirection: 'row', width: wp('90%') }}>
              <View style={{ flexDirection: 'row', width: wp('80%') }}>
                <Text style={styles.signUpText0} >Task:</Text>
                <Text style={styles.signUpText1} >  {item.subTaskId} -  {item.mainTaskTitle}</Text>
              </View>
              <View>
                <Text style={styles.signUpText02} >{item.status}  </Text>
              </View>

            </View>


            <View style={styles.box1}>
              <View style={{ flexDirection: 'row', width: wp('90%') }}>
                <Text style={styles.signUpText00} >Title:</Text>
                <Text style={styles.signUpText11} >{item.taskTitle}</Text>
              </View>
              {/* <View style={{paddingLeft:'25%'}}>
    {item.activeStatus === 1 ? radio2 : radio1}


  </View> */}
            </View>

          </CollapseHeader>
          <CollapseBody>
            <View style={{ flexDirection: 'row', paddingRight: 25, width: wp('80%') }}>
              <Text style={styles.signUpText44} >Description : </Text>
              <Text style={styles.signUpText33} >{item.subTaskDesc}</Text>
            </View>
            <View style={styles.box1}>
              <View style={{ flexDirection: 'row', paddingRight: '3%' }}>
                <Text style={styles.signUpText000} >Target Time:</Text>
                <Text style={styles.signUpText111} >{item.targetDate}</Text>
              </View>
              <View style={{ flexDirection: 'row', }}>
                <Text stylse={styles.signUpText002} >Task Status:{item.taskStatus}%Completed</Text>
              </View>
            </View>
            <View style={styles.box1}>
              <View style={{ flexDirection: 'row' }}>
                <Text style={styles.signUpText000} >Assigned on :</Text>
                <Text style={styles.signUpText1101} >{item.assignedDate}</Text>
              </View>
            </View>
            <View style={{ flexDirection: 'row', paddingRight: 25, width: wp('80%') }}>
              <Text style={styles.signUpText44} >Assigned By :</Text>
              <Text style={styles.signUpText33} >{item.assignedBy}</Text>
            </View>
            <View style={{ flexDirection: 'row', paddingRight: 25, }}>
              <Text style={styles.signUpText44} >Status:</Text>
              <Text style={styles.signUpText33} >{item.taskStatusDesc}</Text>
            </View>
            <View style={styles.box1}>
              <View style={{ flexDirection: 'row' }}>
                <Text style={styles.signUpText000} >TimeLeft:</Text>
                <Text style={styles.signUpText1101} >{item.timeLeft}</Text>
              </View>
            </View>
            {item.dependencyUser == 'NA' ? null : Dependency}
            <View style={{ flexDirection: 'row', justifyContent: 'flex-end', alignItems: 'center' }}>
              <Icon size={22} style={{ paddingLeft: 10, paddingTop: 4 }} name="comments" onPress={() => { this.props.TaskChat() }}></Icon>
            </View>
            <View
              style={{
                borderBottomColor: '#C0C0C0',
                marginBottom: 10,
              }}
            />
          </CollapseBody>

        </Collapse>
        <View style={{ backgroundColor: '#fff', height: 3 }}>

        </View>
      </View>
    )
  }
}
export default class Pending extends Component {
  constructor(props) {

    super(props);
    this.state = {
      isLoading: true,
      dataSource: [],
      isFetching: false,
      result: '',
      empid: ''
    }
    this.arrayholder = [];
  }


  componentDidMount() {
    log("Debug", "Admin Manageemployee view pendingtasks screen is loaded");
    this.getEmployeesPendingTaskList()
  }
  //This is for refreshing the data
  onRefresh() {
    this.getEmployeesPendingTaskList();
  }

  //Navigates to TaskChat Screen
  TaskChat(item, index) {
    log("Info", "AdminManageEmployeeTaskPending:TaskChat(item, index) method is used to naviagate to chat");
    this.props.navigation.navigate("TaskChat", { taskid: item.subTaskId, action: "subtask" });
  }


  componentWillReceiveProps(nextProps) {
    this.getEmployeesPendingTaskList();
  }
  //Getting the employee pending maintask list start
  getEmployeesPendingTaskList() {
    log("Info", "AdminManageEmployeeTaskPending:getEmployeesPendingTaskList() used to get employee pending tasks");
    AsyncStorage.getItem("cropcode", (err, res) => {
      const cropcode = res;

      AsyncStorage.getItem("empId", (err, res) => {
        const empId = res;


        AsyncStorage.getItem("emp_role", (err, res) => {
          const emp_role = res;


          NetInfo.fetch().then(state => {
            if (state.type == "none") {
              console.log(state.type);
              Snackbar.show({
                title: 'No Internet Connection',
                backgroundColor: 'red',
                duration: Snackbar.LENGTH_LONG,
              });
            } else {
              fetch(API + 'getSubtasks.php',
                {
                  method: 'POST',
                  headers: {
                    Accept: 'application/json',
                    'Content-Type': 'application/json',
                  },
                  body: JSON.stringify({
                    crop: cropcode,
                    action: "pending",
                    userType: emp_role,
                    empId: this.props.navigation.state.params.empId
                  })
                })
                .then((response) => response.json())
                .then((responseJson) => {
                  console.log(responseJson);
                  console.log(JSON.stringify(responseJson))
                  if (responseJson.dbconnect === 'dbconnected') {
                  if (responseJson.status === 'True') {
                    this.setState({
                      isLoading: false,
                      dataSource: responseJson.data,
                      isFetching: false
                    }, function () {
                    });
                    this.arrayholder = responseJson.data;
                  } else {
                    this.arrayholder = [];
                    this.setState({
                      isLoading: false,
                    })
                    Snackbar.show({
                      title: 'No Pending Subtasks',
                      backgroundColor: '#3BB9FF',
                      duration: Snackbar.LENGTH_LONG,
                    });
                  }}
                  else{
                    this.props.navigation.navigate('Maintenance');
                  }
                })
                .catch((error) => {
                  console.error(error);
                  log("Error", "Error in getting employee pending tasks at admin side");
                });
            }
          });
        });

      });

    });



  }
  //Getting the employee pending maintask list end

  FlatListItemSeparator = () => {
    return (
      <View
        style={{
          //  height: .5,
          width: "100%",
          backgroundColor: "#000",
        }}
      />
    );
  }



  //if data is empty in flatlist we will use _listEmptyComponent method

  _listEmptyComponent = () => {
    return (
      <View>
        <Text></Text>
        {/* <Image
          style={{ width: '100%', height: 200 }}
          source={{ uri: 'https://cdn.dribbble.com/users/2370289/screenshots/6150406/no_items_found.jpg' }} /> */}

      </View>
    )
  }
  //to filter the search data in search area
  SearchFilterFunction(text) {
    log("Info", "UserPendingMyTask:SearchFilterFunction(text) for search functionality");
    console.log(text);
    try {
      const newData = this.arrayholder.filter(function (item) {
        const subTaskId = item.subTaskId.toUpperCase()
        const subTaskId1 = text.toUpperCase()
        const mainTaskTitle = item.mainTaskTitle.toUpperCase()
        const mainTaskTitle1 = text.toUpperCase()
        const taskTitle = item.taskTitle.toUpperCase()
        const taskTitle1 = text.toUpperCase()
        const subTaskDesc = item.subTaskDesc.toUpperCase()
        const subTaskDesc1 = text.toUpperCase()
        const targetDate = item.targetDate.toUpperCase()
        const targetDate1 = text.toUpperCase()
        const taskStatus = item.taskStatus.toUpperCase()
        const taskStatus1 = text.toUpperCase()
        const assignedDate = item.assignedDate.toUpperCase()
        const assignedDate1 = text.toUpperCase()
        const assignedBy = item.assignedBy.toUpperCase()
        const assignedBy1 = text.toUpperCase()
        const timeLeft = item.timeLeft.toUpperCase()
        const timeLeft1 = text.toUpperCase()
        const dependencyId = item.dependencyId.toUpperCase()
        const dependencyId1 = text.toUpperCase()
        // const dependencyTitle = item.dependencyTitle.toUpperCase()
        // const dependencyTitle1 = text.toUpperCase()

        return subTaskId.indexOf(subTaskId1) > -1 ||
          mainTaskTitle.indexOf(mainTaskTitle1) > -1 ||
          taskTitle.indexOf(taskTitle1) > -1 ||
          subTaskDesc.indexOf(subTaskDesc1) > -1 ||
          targetDate.indexOf(targetDate1) > -1 ||
          taskStatus.indexOf(taskStatus1) > -1 ||
          assignedDate.indexOf(assignedDate1) > -1 ||
          assignedBy.indexOf(assignedBy1) > -1 ||
          timeLeft.indexOf(timeLeft1) > -1 ||
          dependencyId.indexOf(dependencyId1) > -1
        //   dependencyTitle.indexOf(dependencyTitle1) > -1

      })

      this.setState({
        dataSource: newData,
        text: text
      })
    }
    catch (error) {
      this.refs.toast.showBottom('No Results Found');
    }
  }

  render() {

    return (
      <Container style={{ height: Dimensions.get('window').height }}>
        <Item>
          {/* <Icon name="ios-search" /> */}
          <Input placeholder="Search"
            onChangeText={(text) => this.SearchFilterFunction(text)} />
               <Icon style={{ marginRight: 10, color: 'black' }} size={20} name="search" />

        </Item>
        <Content>


          <View style={styles.Container}>
            <View></View>
            <View >

            </View>
            <View style={styles.end1}>

              <FlatList
                // data={this.props.data}
                extraData={this.state}
                keyExtractor={this._keyExtractor}
                renderItem={this._renderItem}
                style={{ flex: 1, }}
                data={this.state.dataSource}

                onRefresh={() => this.onRefresh()}
                refreshing={this.state.isFetching}

                ItemSeparatorComponent={this.FlatListItemSeparator}
                renderItem={({ item, index }) =>
                  <View style={styles.container2} >
                    <ListItem
                      item={item}
                      TaskChat={() => this.TaskChat(item, index)}//For Chat

                    />
                  </View>
                }
                keyExtractor={item => item.id}
                ListEmptyComponent={this._listEmptyComponent}
              />
            </View>
          </View>


        </Content>



      </Container>
    );
  }
}
//Styles for UI
const styles = StyleSheet.create({
  container: {
    backgroundColor: '#ffcccc',
    paddingTop: 5,
    paddingRight: 20,
  },
  container1: {
    backgroundColor: '#f8f8f8',
    // backgroundColor: '#ffffff',
    paddingTop: 5,
    paddingRight: 20,
  },
  buttonContainer: {
    width: wp('95%'),
    alignSelf: 'baseline',
    marginBottom: 10,
    color: '#d2691e',
    backgroundColor: '#fadbd8',
    // justifyContent:'center',
    // alignItems:'center',
    // borderWidth: 0.4,
    // borderRadius: 15,
    marginLeft: 4,
    // shadowOffset : { width: 50, height: 50 },
    // shadowColor: Platform.OS ==='ios' ? null: 'black',
    // shadowOpacity: 9,
    //elevation: 7,

  },
  signupButton: {
    //shadowOpacity: 13,
    //  backgroundColor: '#ffffff',

    // shadowColor: '#141615',

  },
  subcontainer: {
    flex: 2,
    flexDirection: 'row',
    // paddingTop: 40
  },
  signUpText0: {
    fontSize: 14,

    // fontWeight: 'bold',
    color: 'green',
    paddingLeft: 10,
  },
  signUpText1: {
    fontSize: 14,
    // paddingTop: 20,
    // fontWeight: 'bold',
    color: 'green',
    paddingLeft: 10,
  },

  signUpText00: {
    fontSize: 14,
    paddingLeft: 10,
    color: 'black'
  },
  signUpText11: {
    fontSize: 14,
    // paddingBottom: 10,
    color: 'black',
    width: '60%',
    // fontWeight: 'bold',
    paddingLeft: 2,
  },
  signUpText000: {
    fontSize: 14,
    // paddingTop: 20,
    // fontWeight: 'bold',
    color: 'black',
    // paddingBottom: 10,
    paddingLeft: 10,
  },
  signUpText111: {
    fontSize: 14,
    //width: '60%',
    color: 'black',
  },
  signUpText111task: {
    fontSize: 14,
    //paddingBottom: 10,
    // width: '60%',
    color: 'black',
  },
  end: {

    alignItems: 'flex-end',

  },
  end1: {
    flex: 1,
    //  paddingTop: 20,
    justifyContent: 'space-between',

    flexDirection: 'row',
  },
  s: {
    justifyContent: 'center',

    backgroundColor: '#ed7070',
    shadowOffset: { width: 50, height: 50 },
    alignItems: 'center',
    width: wp('40%'),
    height: hp('12%'),
    borderTopLeftRadius: 10,
    borderBottomLeftRadius: 10,

  },
  signUpText2: {
    fontSize: 14,
    paddingRight: 10,
    //  paddingTop: 20,
    paddingLeft: 23,
    color: 'black',

    // fontWeight: 'bold',
    justifyContent: 'center',

  },
  signUpText02: {
    fontSize: 14,
    paddingRight: 10,
    // paddingTop: 20,
    paddingLeft: 23,
    color: 'red',
    // paddingBottom: 10,
    // fontWeight: 'bold',
    justifyContent: 'center',

  },
  signUpText022: {
    fontSize: 14,
    paddingLeft: 23,
    color: 'green',
    justifyContent: 'center',
    // fontWeight: 'bold'

  },
  signUpText002: {
    fontSize: 14,
    //paddingRight: 35,
    // paddingTop: 20,
    paddingLeft: 23,
    // color: 'red',
    // paddingBottom: 10,
    // fontWeight: 'bold',
    justifyContent: 'center',

  },
  signUpText0002: {
    fontSize: 14,
    paddingRight: 45,
    // paddingTop: 20,
    paddingLeft: 23,
    // color: 'red',
    // paddingBottom: 10,
    // fontWeight: 'bold',
    justifyContent: 'center',

  },
  signUpText3: {

    // paddingBottom: 10,
    paddingLeft: 23,
    fontSize: 14,
    // paddingRight:hp('-10%'),
    paddingRight: 13,
    // fontWeight: 'bold',
    alignItems: 'center',
  },
  signUpText4: {
    // paddingBottom: 10,
    paddingLeft: 20,
    // fontWeight: 'bold',
    //color: 'black',
    fontSize: 14,
    alignItems: 'center',
  },


  signUpText33: {

    // paddingBottom: 10,
    fontSize: 14,


    alignItems: 'center',
  },
  signUpText44: {

    paddingLeft: 10,
    // fontWeight: 'bold',
    paddingTop: -10,
    color: 'black',
    fontSize: 14,
    alignItems: 'center',
  },

  signup: {
    //paddingTop:20,
    color: "#FFF",
  },
  boxone: {
    flex: 1,
    marginTop: 5,

  },
  boxtwo: {
    flex: 1,

  },
  boxthree: {
    flex: 1,

  },
  box: {
    justifyContent: 'space-between',
    flexDirection: 'row',
    position: 'relative',
    // marginBottom: 10,

  },
  box1: {
    flexDirection: 'row',
    paddingRight: 25,
  },
  signUpText: {
    fontSize: 14,
    justifyContent: 'center',


    color: 'white',
    alignSelf: 'center',
  },
  boxheader: {
    justifyContent: 'space-between',
    flexDirection: 'column',
    position: 'relative',
    marginBottom: 5,

  },
});