/*
FileName:UserProfile.js
Version:1.0.4
Purpose:Edit and update the profile Description
Devloper:Mahesh
*/
import React, { Component } from 'react';
import { Platform, StyleSheet, Text, View, Image, StatusBar, Dimensions, TextInput, Alert } from 'react-native';
import { Title, Button, Container, Content, Header, Right, Left, Body, Tab, Tabs, TabHeading, Footer, Item, Input, FooterTab } from 'native-base';
import { widthPercentageToDP as wp, heightPercentageToDP as hp } from 'react-native-responsive-screen';
import { TouchableOpacity } from 'react-native-gesture-handler';
import AsyncStorage from '@react-native-community/async-storage';
import { API } from "../WebServices/RestClient";
import NetInfo from '@react-native-community/netinfo';
import Snackbar from 'react-native-snackbar';
// import { Dropdown } from 'react-native-material-dropdown';
import log from '../LogFile/Log';
import Icon from 'react-native-vector-icons/FontAwesome';
import {CHANGEPASSWORD,SUBMIT,OLDPASSWORD,NEWPASSWORD,CPASSWORD,MATCHPASSWORD} from '../CommonComponents/Header';

import {
    BallIndicator,
    BarIndicator,
    DotIndicator,
    MaterialIndicator,
    PacmanIndicator,
    PulseIndicator,
    SkypeIndicator,
    UIActivityIndicator
} from 'react-native-indicators';
export default class AdminPassword extends Component {

    constructor(props) {
        super(props);

        this.state = {
            isLoading: true,

            newPassword: '',
            oldPassword: '',
            confirmPassword: ''
        }
    }

    // componentDidMount(){
    //     this.UpdatePassword();
    // }

    //validation For Mobile Number
    isValid() {
        const { oldPassword, newPassword, confirmPassword } = this.state;
        let valid = false;
        if (oldPassword.length === 0) {
            alert(OLDPASSWORD);

        }
        else if (newPassword.length === 0) {
            alert(NEWPASSWORD);

        }

        else if (newPassword !== confirmPassword) {
            alert(MATCHPASSWORD);

        }

        else {
            valid = true;
        }
        return valid;
    }
    mobilevalidate(mobile) {
        const reg = /^[0]?[6789]\d{9}$/;
        return reg.test(mobile);
    }

    //Update employe profile data
    UpdatePassword() {
        if (this.isValid()) {
            log("Info", " getRequestedIdeas(cropcode,empId,name,email,username,mobile,designation,workingStatus,team,role) is used to get all details of user");
            AsyncStorage.getItem("cropcode", (err, res) => {

                const cropcode = res;
                AsyncStorage.getItem("empId", (err, res) => {

                    const empId = res;

                    const { oldPassword, newPassword } = this.state;


                    //checking the network connection
                    NetInfo.fetch().then(state => {
                        if (state.type == "none") {
                            console.log(state.type);
                            log("Warn", "No internet connection");
                            Snackbar.show({
                                title: 'No Internet Connection',
                                backgroundColor: 'red',
                                duration: Snackbar.LENGTH_LONG,
                            });
                        } else {


                            fetch(API + 'changePassword.php', {
                                method: 'POST',
                                headers: {
                                    'Accept': 'application/json',
                                    'Content-Type': 'application/json',
                                },
                                body: JSON.stringify({
                                    empId: empId,
                                    oldPassword: oldPassword,
                                    newPassword: newPassword,
                                    crop: cropcode
                                })

                            }).then((response) => response.json())
                                // console.warn(responseJson)
                                .then((responseJson) => {
                                    console.warn(responseJson)
                                    if (responseJson.status === 'True') {
                                        // Showing response message coming from server after inserting records.

                                        alert(responseJson.message);
                                        // alert(" Password updated successfully");
                                        this.setState({
                                            oldPassword: '',
                                            newPassword: '',

                                        });

                                        this.props.navigation.navigate("AdminManageProjects")
                                        // alert(JSON.stringify(responseJson));
                                    }
                                    else {
                                        alert(responseJson.message);
                                    }



                                }).catch((error) => {
                                    console.error(error);
                                    log("Error", " Error in Update employe profile data");
                                });
                        }
                    });
                });
            });
        }
    }



    render() {

        // let data2 = [{ value: 'commericial', }, { value: 'residencial', }];
        return (
            <Container>
                <Header
                    androidStatusBarColor="#00A2C1"
                    style={{
                        backgroundColor: '#00A2C1',
                        height: 60,
                        width: Dimensions.get('window').width,
                        borderBottomColor: '#ffffff',
                        justifyContent: 'space-between',
                    }}>
                    <Left>
                        <Icon name="bars" size={25} style={{ color: '#fff', }} onPress={() =>
                            this.props.navigation.toggleDrawer()} />
                    </Left>
                    <Body>
                        <Title style={{ color: '#fff', fontWeight: '600' }}>{CHANGEPASSWORD}</Title>
                    </Body>
                    <Right></Right>
                </Header>
                <Content style={{ paddingTop: 50 }}>
                    {/* <Text>Hello</Text> */}


                    <View style={{ paddingLeft: 10, }}>

                        <TextInput style={{ width: wp('95%'), height: 45, borderBottomWidth: 1, }}
                            placeholder={OLDPASSWORD}
                            underlineColorAndroid='transparent'
                            //  selectionColor='white'
                            onChangeText={(oldPassword) => this.setState({ oldPassword })}

                        />
                    </View>
                    <View style={{ paddingLeft: 10, }}>

                        <TextInput style={{ width: wp('95%'), height: 45, borderBottomWidth: 1, }}
                            placeholder={NEWPASSWORD}
                            underlineColorAndroid='transparent'
                            //  selectionColor='white'
                            onChangeText={(newPassword) => this.setState({ newPassword })}

                        />
                    </View>

                    <View style={{ paddingLeft: 10, }}>

                        <TextInput style={{ width: wp('95%'), height: 45, borderBottomWidth: 1, }}
                            placeholder={CPASSWORD}
                            underlineColorAndroid='transparent'
                            //  selectionColor='white'
                            onChangeText={(confirmPassword) => this.setState({ confirmPassword })}

                        />
                    </View>
                    <View style={{ paddingTop: 20, }}>

                        <View style={{ flexDirection: 'row', justifyContent: 'center', alignItems: 'center', paddingTop: 40 }}>
                            <TouchableOpacity onPress={this.UpdatePassword.bind(this)} style={styles.next}>
                                <Text style={{ color: 'white', fontSize: 15 }}>{SUBMIT}</Text>
                            </TouchableOpacity>

                        </View>

                    </View>
                </Content>

            </Container>
        );
    }
}

const styles = StyleSheet.create({
    submit: {
        flex: 1,
        ...Platform.select({
            ios: {
                color: 'white', paddingTop: 3, fontSize: 15, width: 100,
                height: 30, backgroundColor: '#00A2C1',
                textAlign: 'center', borderRadius: 10
            },
            android: {
                color: 'white', paddingTop: 3, fontSize: 15, width: 100,
                height: 30, backgroundColor: '#00A2C1',
                textAlign: 'center', borderRadius: 70
            },
        }),
    },
    next: {
        flex: 1,
        ...Platform.select({
            ios: {
                backgroundColor: '#00A2C1', borderRadius: 5, marginLeft: 130, marginRight: 130,
                width: '30%', height: 40, alignItems: "center", justifyContent: 'center'
            },
            android: {
                backgroundColor: '#00A2C1', borderRadius: 5, marginLeft: 130, marginRight: 130,
                width: '30%', height: 40, alignItems: "center", justifyContent: 'center'
            },
        }),
    },


    mobile: {
        flex: 1,
        ...Platform.select({
            ios: {
                marginTop: 12
            },
            android: {

            },
        }),
    },
    role: {
        flex: 1,
        ...Platform.select({
            ios: {
                flexDirection: 'row', marginTop: 10
            },
            android: {
                flexDirection: 'row', marginTop: 10

            },
        }),
    },

});