import React, { Component } from 'react';
import {
  Platform, StyleSheet, TextPropTypes, Picker, Text, Button, View, Image, StatusBar, Dimensions, TextInput, Alert,
  KeyboardAvoidingView,
  TouchableWithoutFeedback,
  FlatList,
  Keyboard
} from 'react-native';
// import { Chart, VerticalAxis, HorizontalAxis, Line } from 'react-native-responsive-linechart'
import { Icon, Title, Container, Content, Header, Right, Left, Body } from 'native-base';
import { widthPercentageToDP as wp, heightPercentageToDP as hp } from 'react-native-responsive-screen';
import { TouchableOpacity } from 'react-native-gesture-handler';
import AsyncStorage from '@react-native-community/async-storage';
import { ReportsAPI } from "../WebServices/RestClient";
import { API } from "../WebServices/RestClient";
import NetInfo from '@react-native-community/netinfo';
import Snackbar from 'react-native-snackbar';
import log from '../LogFile/Log';
import ProffileOffline from '../OfflineDB/Profile';
const db = new ProffileOffline();
import Main from '../Maintenance/Main';
import jwt_decode from "jwt-decode";
import ModalSelector from 'react-native-modal-selector';
const check = new Main()
import {
  DotIndicator,
} from 'react-native-indicators';
// import { LineChart, BarChart } from "react-native-chart-kit";
import { ScrollView } from 'react-native-gesture-handler';
import { PROFILE, CHANGEPASSWORD, EMPLOYEEID, USERNAME, EMAIL, MOBILE, FULLNAME1, DESIGNATION, TEAM, ROLE, FMANAGER, RMANAGER, STATUS1 } from '../CommonComponents/Header';
import SearchableDropdown from 'react-native-searchable-dropdown';
import PureChart from 'react-native-pure-chart';
import moment from "moment";
import DateRangePicker from "react-native-daterange-picker";

class ListItem extends React.Component {
  constructor(props) {
    super(props);
    this.state = {
      isLoading: true,
      // roledata: '',
    }

  }


  render() {
    const { item } = this.props;
    // alert("Setting")
    AsyncStorage.getItem("emp_role", (err, res) => {
      this.setState({
        roledata: res
      })

    });


    return (
      <View style={styles.container}>
        {/* <TouchableOpacity onPress={this.props.Module}> */}
        <View style={styles.signup}>
         
          <View style={[styles.buttonContainer, styles.signupButton]} >
            <View style={styles.box}>

              <View style={{ flexDirection: 'row', width: '50%' }}>
                <Text style={styles.signUpText0} >Project Name:</Text>
                <Text style={styles.signUpText1} >{item.result.project_name}</Text>
              </View>
              <Text style={styles.signUpText2} >{item.result.sprint}</Text>
            </View>
            <View
              style={{
                borderBottomColor: '#C0C0C0',
                borderBottomWidth: 0.3,
              }}
            />

            <View style={{ flexDirection: 'row', paddingRight: 25, }}>
              <View style={{ width: wp('70%'), flexDirection: 'row' }}>
                <Text style={styles.signUpText4} >Completed:</Text>
                <Text style={styles.signUpText3} >{item.result.completed}</Text>
              </View>

            </View>

            <View style={{ flexDirection: 'row', paddingRight: 25 }}>
              <Text style={styles.signUpText4} >Pending:</Text>
              <Text style={styles.signUpText3} >{item.result.pending}</Text>
            </View>

            <View style={{ flexDirection: 'row', paddingRight: 25 }}>
              <Text style={styles.signUpText4} >Description:</Text>
              <Text style={styles.signUpText3} >{item.result.sprint_desc}</Text>
            </View>

          </View>

        </View>
        {/* </TouchableOpacity> */}
      </View>

    )
  }
}

export default class AdminReports extends Component {

  constructor(props) {
    super(props);

    this.state = {
      isLoading: false,
      isVisibleB: false,
      sprintName: 'Select User',
      epicName: 'Select Epic',
      resource: [],
      resource1: [],
      startDate: null,
      endDate: null,
      displayedDate: moment(),
      minDate: moment().set("date", 1),
      maxDate: moment().set("date", 31),
    }

    AsyncStorage.getItem("cropcode", (err, res) => {
      this.setState({ squadName: res });
      console.warn("squadname" + this.state.squadName);
    });
  }

  setDates = (dates) => {
    this.setState({
      ...dates,
    });
  };



  componentDidMount() {
    this.getUsers();
    // this.Reports();
  }



  getUsers() {
    // alert("test")
    NetInfo.fetch().then(state => {
      if (state.type == "none") {
        Snackbar.show({
          title: 'No Internet Connection',
          backgroundColor: 'red',
          duration: Snackbar.LENGTH_LONG,
        });
      } else {

        fetch('https://apiv2reporting.agile24x7.com/getUsersData', {
          method: 'GET',
          headers: {
            'Accept': 'application/json',
            'Content-Type': 'application/json',
          },

        }).then((response) => response.json())
          .then((responseJson) => {
            // alert("data" + JSON.stringify(responseJson))

            var sprintList = [];
            responseJson.map((sprints) => {
              return (
                sprintList.push({
                  'id': sprints.emp_id, 'name': sprints.fullname
                })
              );
            })

            this.setState({
              resource1: sprintList
            },
              function () {

              }
            );

          }).catch((error) => {
            check.Maintenance();
            console.error(error);
            log("Error", "Error in getting profile data");

          });
      }


    });
  }



  Reports() {
    const { assignedto, sprintName, startDate, endDate } = this.state;
    // alert("value:"+assignedto+"label:"+sprintName)
    // alert("startDate :"+moment(this.state.startDate).format('YYYY-MM-DD[T]hh:mm:ss.SSS[Z]')+"endDate :"+moment(this.state.startDate).format('YYYY-MM-DD[T]hh:mm:ss.SSS[Z]'))

    const data = {
      "selectedOption":
      {
        "value": assignedto,
        "label": sprintName
      }
    }
    const filter = [{
      "startDate": moment(this.state.startDate).format('YYYY-MM-DD[T]hh:mm:ss.SSS[Z]'),
      "endDate": moment(this.state.endDate).format('YYYY-MM-DD[T]hh:mm:ss.SSS[Z]'),
      "key": "selection"
    }]
    // alert(JSON.stringify({data,filter}))
    // {"data":{"selectedOption":
    // {"value":"6b2218ba7636d07530aa63b3848656ba",
    // "label":"Naveen Gade"}},"
    // filter":[{"startDate":"2021-06-30T18:30:00.000Z",
    // "endDate":"2021-07-30T18:30:00.000Z","key":"selection"}]}

    NetInfo.fetch().then(state => {
      if (state.type == "none") {
        Snackbar.show({
          title: 'No Internet Connection',
          backgroundColor: 'red',
          duration: Snackbar.LENGTH_LONG,
        });
      } else {

        fetch('https://apiv2reporting.agile24x7.com/getDataV1', {
          method: 'POST',
          headers: {
            'Accept': 'application/json',
            'Content-Type': 'application/json',
          },

          body: JSON.stringify({
            data, filter
          })

        }).then((response) => response.json())
          .then((responseJson) => {
            // alert("data" + JSON.stringify(responseJson))

            // var sprintList = [];
            // responseJson.map((sprints) => {
            //   return (
            //     sprintList.push({
            //       'id': sprints.emp_id, 'name': sprints.fullname
            //     })
            //   );
            // })

            this.setState({
              userReports: responseJson.projectData,
              projectCount:responseJson.projectCount,
            },
              function () {

              }
            );

          }).catch((error) => {
            check.Maintenance();
            console.error(error);
            log("Error", "Error in getting profile data");

          });
      }


    });
  }







  //get project list dropdown data
  GetStatus() {
    log("Info", "UserProfile:GetStatus() method is used to get status of employee");
    AsyncStorage.getItem("userToken", (err, res) => {
      const empId = res;
      NetInfo.fetch().then(state => {
        if (state.type == "none" || state.type == 'unknown' || state.type == 'undefined') {
          // console.log(state.type);
          Snackbar.show({
            title: 'No Internet Connection',
            backgroundColor: 'red',
            duration: Snackbar.LENGTH_LONG,
          });
          this.getAgileProjects()//For Getting Project List in Offline
        } else {

          fetch(API + 'squads.php', {
            method: 'POST',
            headers: {
              Accept: 'application/json',
              'Content-Type': 'application/json',
            },
            body: JSON.stringify({

              empId: empId,
              action: 'get_squads',


            })
          })
            .then((response) => response.json())
            .then((responseJson) => {
              console.warn(responseJson)
              // alert(JSON.stringify(responseJson))
              if (responseJson.status == 'True') {
                // this.addAgileProjects(responseJson.data) //Project list store in offline
                // this.setState({
                //     isLoading: false,
                //     dataSource: [...responseJson.data],
                // }, function () {
                //     // In this block you can do something with new state.
                // });


                var dataSource = [];
                responseJson.data.map((epics) => {
                  return (
                    dataSource.push({
                      'key': epics.value, 'label': epics.value
                    })
                  );
                })

                this.setState({
                  dataSource: dataSource
                });

                // const data2 = [];

                // responseJson.data.map(x => {
                //     data2.push({ label: x.value, value: x.value })
                // })
                // this.setState({
                //     data2: data2,
                // })
                // console.warn("Hello" + JSON.stringify(data2))

                // this.setState({
                //     data2: responseJson.data
                // });
                // console.warn(this.state.data2);
              } else {
                this.setState({
                  dataSource: dataSource
                });
                log("Warn", "status of employee is not available");
              }
            })
            .catch((error) => {
              console.error(error);
              log("Error", "error in  getting status of employee");
            });
        }
      });
    });

  }

  // Update Status of Employee
  UpdateStatus(squadName) {
    // const { squadName } = this.state;
    log("Info", "UserProfile:UpdateStatus(status) method is used to update status of employee");
    console.warn("Hello" + squadName);

    AsyncStorage.getItem("userName", (err, res) => {
      const userName = res;
      console.log(res);



      // console.log(cropcode);
      NetInfo.fetch().then(state => {
        if (state.type == "none" || state.type == 'unknown' || state.type == 'undefined') {
          console.log(state.type);
          Snackbar.show({
            title: 'No Internet Connection',
            backgroundColor: 'red',
            duration: Snackbar.LENGTH_LONG,
          });
          //for offline project switching start
          this.setState({
            squadName: squadName
          });
          AsyncStorage.setItem('cropcode', squadName);
          this.getOfflineSprints()//Getting the List of offline Sprints
          this.getOfflineActiveSprints("currentsprint") //Getting Current Sprint Backlogs in offline
          //for offline project switching end
        } else {

          fetch(API + 'squadLogin.php', {
            method: 'POST',
            headers: {
              Accept: 'application/json',
              'Content-Type': 'application/json',
            },
            body: JSON.stringify({
              username: userName,
              crop: squadName,

            })
          })
            .then((response) => response.json())
            .then((responseJson) => {
              console.warn(JSON.stringify(responseJson))

              if (responseJson.status == 'TRUE') {
                AsyncStorage.setItem('auth', responseJson.jwt) //store the token information  with exp
                const tokenDetails = jwt_decode(responseJson.jwt);
                console.log(tokenDetails.data)
                AsyncStorage.setItem('roleCount', tokenDetails.data.roleCount)
                // dispatch(setCurrentUser(tokenDetails.data)); //store the user information
                AsyncStorage.setItem('status', tokenDetails.data.empStatus)


                AsyncStorage.setItem('userToken', tokenDetails.data.empId);
                AsyncStorage.setItem('userName', tokenDetails.data.userName);
                AsyncStorage.setItem('emp_role', tokenDetails.data.role);
                AsyncStorage.setItem('cropcode', tokenDetails.data.corp);

                // alert("project changed")
                // this.props.navigation.navigate('UserProfile');
                // console.warn("HI" + empstatus)
                this.setState({

                  squadName: squadName
                });
                this.Network();
                this.getEmployees();
                this.getSprints();
                //  alert("Project Changed Successfully")


              } else {
                //    alert("user already exist");
                log("Warn", "status of employee is not able to update");
              }

            })
            .catch((error) => {
              console.warn(error);
              log("Error", "error in updating status of employee");
            });
        }
      });
    });

  }



  render() {

    const { startDate, endDate, displayedDate, minDate, maxDate } = this.state;


    if (this.state.isLoading) {
      return (
        <View style={{ flex: 1, alignItems: 'center', justifyContent: 'center' }}>
          <DotIndicator color='#00A2C1' />
        </View>
      );

    }

    return (
      <KeyboardAvoidingView
        style={{ flex: 1 }}
        behavior={Platform.OS === "ios" ? "padding" : "height"}
      >
        <Container>
          {/* <Header
          androidStatusBarColor="#00A2C1"
          style={{
            backgroundColor: '#00A2C1',
            height: 60,
            width: Dimensions.get('window').width,
            borderBottomColor: '#ffffff',
            justifyContent: 'space-between',
          }}>
          <Left>
            <Icon name="md-menu" style={{ color: '#fff' }} onPress={() =>
              this.props.navigation.toggleDrawer()} />
          </Left>
          <Body>
            <Title style={{ color: '#fff', fontWeight: '600' }}>REPORTS</Title>
          </Body>


        </Header> */}

          <Header
            androidStatusBarColor="#00A2C1"
            style={{
              backgroundColor: '#00A2C1',
              height: 60,
              width: Dimensions.get('window').width,
              borderBottomColor: '#ffffff',
              justifyContent: 'space-between',
            }}>
            <View style={{ marginTop: 20 }}>
              <Icon name="md-menu" size={25} style={{ color: 'white', }} onPress={() =>
                this.props.navigation.toggleDrawer()} />
            </View>

            {/* <View style={{ width: 300, borderRadius: 20, height: 45, marginTop: 5, flexDirection: 'row' }}>


              <ModalSelector
                style={{ width: 260, backgroundColor: 'transparent', borderColor: 'transparent', marginLeft: 60 }}
                data={this.state.dataSource}
                initValue={this.state.squadName}
                optionContainerStyle={{ backgroundColor: 'white' }}
                onChange={(itemValue) => { this.UpdateStatus(itemValue.label) }} >
                <View style={{ width: 300, borderRadius: 20, height: 45, marginTop: 5, flexDirection: 'row' }}>
                  <Text style={{ marginTop: 15, color: 'white', width: 80 }}>PROJECT : </Text>

                  <Text style={{ marginTop: 15, color: 'white', width: 120, }}>{this.state.squadName}</Text>

                  <Icon name="md-chevron-down-outline" size={25} style={{ color: 'white', marginTop: 10, }}
                  />
                </View>

              </ModalSelector>


            </View> */}

          </Header>
          <Content>






            <View style={styles.top}>



              <View style={{ paddingTop: 20, flexDirection: 'row',position:'absolute' }}>
                <SearchableDropdown
                  placeholder={this.state.sprintName}
                  onTextChange={text => console.log(text)}
                  // onItemSelect={item => item.name}
                  onItemSelect={(item) => this.setState({ assignedto: item.id, sprintName: item.name })}
                  // onItemSelect={(item) => { this.Network2(item.id), this.setState({ sprintName: item.name }) }}
                  // onItemSelect={(item) => { this.NetworkData(item.id) }}
                  placeholderTextColor='black'
                  containerStyle={{
                    paddingLeft: "2%",
                    width: '70%'

                  }}
                  placeholderTextColor='black'
                  textInputStyle={{
                    padding: 12,
                    borderWidth: 1,
                    borderColor: '#ccc',
                    backgroundColor: '#fff',
                    borderRadius: 20
                  }}
                  itemStyle={{
                    padding: 10,
                    marginTop: 2,
                    backgroundColor: '#FAF9F8',
                    borderColor: '#bbb',
                    borderWidth: 1,
                    borderRadius: 20
                  }}
                  itemTextStyle={{
                    color: '#222',
                  }}
                  items={this.state.resource1}
                  defaultIndex={2}
                  resetValue={false}
                  underlineColorAndroid="transparent"
                />
                <Text style={{ color: 'red' }}>{this.state.error3}</Text>

                <DateRangePicker
                style={{zIndex:1,position:'absolute'}}
                  onChange={this.setDates}
                  startDate={startDate}
                  endDate={endDate}
                  // minDate={minDate}
                  // maxDate={maxDate}
                  presetButtons={true}
                  completed
                  range
                  displayedDate={displayedDate}
                  moment={moment}
                >
                  {/* <Text style={{ color: 'white', fontSize: 14,height: 30, padding: 5,backgroundColor:"#00A2C1" }}>Date</Text> */}
                  <Image style={{ width: wp('8%'), height: hp('4%'), margin: 5 }} source={require('../Images/calendar.png')} />

                </DateRangePicker>
                <TouchableOpacity style={styles.opensave} onPress={() => { this.Reports() }}>
                  <Text style={{ color: 'white', padding: 5 }}>Show</Text>
                </TouchableOpacity>
              </View>

             

              <View style={{marginTop:100}}>
                {/* {
                this.state.projectCount ==''? <Text style={{marginLeft:'70%'}}>Project Count:{this.state.projectCount}</Text>:<Text></Text>
 
                } */}
                
                {this.state.projectCount && (
                <View>
              <Text style={{marginLeft:'70%'}}>Project Count:{this.state.projectCount}</Text>
              <Text style={{marginLeft:'60%'}}>Start Date:{moment(this.state.startDate).format('YYYY-MM-DD')}</Text>
              <Text style={{marginLeft:'60%'}}>End Date:{moment(this.state.endDate).format('YYYY-MM-DD')}</Text>
                </View>)}
                
                <FlatList

                  extraData={this.state}
                  keyExtractor={this._keyExtractor}
                  renderItem={this._renderItem}

                  data={this.state.userReports}

                  // onRefresh={() => this.onRefresh()}
                  refreshing={this.state.isFetching}

                  ItemSeparatorComponent={this.FlatListItemSeparator}
                  renderItem={({ item, index }) =>
                    <View>

                      <ListItem navigation={this.props.navigation}
                        item={item}
                        ReOpenProjectAction={() => this.ReOpenProjectAction(item, index)}//For ReOpen Project
                      />
                    </View>
                  }
                  keyExtractor={item => item.id}
                  ListEmptyComponent={this._listEmptyComponent}
                />
              </View>
            </View>








          </Content>

        </Container>
      </KeyboardAvoidingView >
    );
  }
}

// const styles = StyleSheet.create({
//   submit: {
//     flex: 1,
//     ...Platform.select({
//       ios: {
//         color: 'white', paddingTop: 3, fontSize: 15, width: 100,
//         height: 30, backgroundColor: '#00A2C1',
//         textAlign: 'center', borderRadius: 10
//       },
//       android: {
//         color: 'white', paddingTop: 3, fontSize: 15, width: 100,
//         height: 30, backgroundColor: '#00A2C1',
//         textAlign: 'center', borderRadius: 70
//       },
//     }),
//   },
//   opensave: {
//     // flex: 1,
//     ...Platform.select({
//       ios: {
//         backgroundColor: 'green', margin: 20, height: 30, alignItems:
//           "center", justifyContent: 'center'
//       },
//       android: {
//         backgroundColor: 'green', margin: 20, height: 30, alignItems:
//           "center", justifyContent: 'center'
//       },
//     }),
//   },
//   mobile: {
//     flex: 1,
//     ...Platform.select({
//       ios: {
//         marginTop: 12
//       },
//       android: {

//       },
//     }),
//   },
//   role: {
//     flex: 1,
//     ...Platform.select({
//       ios: {
//         flexDirection: 'row', marginTop: 10
//       },
//       android: {
//         flexDirection: 'row',
//         paddingTop: 10,

//       },
//     }),
//   },

// });
// const pickerSelectStyles = StyleSheet.create({
//   inputIOS: {
//     fontSize: 2,
//     paddingVertical: 12,
//     paddingHorizontal: 10,
//     borderWidth: 1,
//     borderColor: 'blue',
//     borderRadius: 4,
//     color: 'black',
//     paddingRight: 30, // to ensure the text is never behind the icon
//   },
//   inputAndroid: {
//     fontSize: 3,
//     paddingHorizontal: 10,
//     paddingVertical: 8,
//     borderWidth: 0.5,
//     borderColor: 'purple',
//     borderRadius: 8,
//     color: 'black',
//     paddingRight: 30, // to ensure the text is never behind the icon
//   },
// });
const styles = StyleSheet.create({
  container: {
    flex: 1,
    width: '90%',
    paddingLeft: hp('2%'),
  },
  footer: {
    position: 'absolute',
    flex: 0.1,
    left: 0,
    right: 0,
    bottom: -10,
    backgroundColor: 'green',
    flexDirection: 'row',
    height: 80,
    alignItems: 'center',
  },
  bottomButtons: {
    alignItems: 'center',
    justifyContent: 'center',
    flex: 1,
  },
  footerText: {
    color: 'white',
    fontWeight: 'bold',
    alignItems: 'center',
    fontSize: 18,
  },
  buttonContainer: {
    width: wp('90%'),
    alignSelf: 'baseline',
    marginBottom: 10,
    color: '#d2691e',
    marginLeft: 4,



  },
  signupButton: {

    backgroundColor: '#ffffff',
  },
  subcontainer: {
    flex: 2,
    flexDirection: 'row',
    paddingTop: 40
  },
  signUpText0: {
    fontSize: 13,
    color: 'green',
    paddingTop: 10,

  },
  signUpText1: {
    fontSize: 13,
    color: 'green',
    paddingTop: 10,

    paddingLeft: 10,
  },
  end: {

    alignItems: 'flex-end',

  },
  end1: {
    flex: 2,
    height: '50%',
    paddingTop: 20,
    justifyContent: 'space-between',

    flexDirection: 'row',
  },
  s: {
    justifyContent: 'center',

    backgroundColor: '#ed7070',
    shadowOffset: { width: 50, height: 50 },
    alignItems: 'center',
    width: wp('40%'),
    height: hp('12%'),

  },
  signUpText2: {
    fontSize: 13,
    marginLeft: 20,

    color: 'green',
    paddingTop: 10,
  },
  signUpText3: {

    fontSize: 13,
    paddingTop: 10,
    paddingLeft: 10,

    alignItems: 'center',
  },
  signUpText4: {
    fontSize: 13,
    paddingTop: 10,


    alignItems: 'center',
  },
  signup: {
    color: "#FFF",

  },
  boxone: {
    flex: 1,
    marginTop: 5,

  },
  boxtwo: {
    flex: 1,

  },
  boxthree: {
    flex: 1,

  },
  box: {
    flexDirection: 'row',
    position: 'relative',
    marginBottom: 10,


  },
  opensave: {
    // flex: 1,
    ...Platform.select({
      ios: {
        backgroundColor: 'green', height: 30, margin: 5, alignItems:
          "center", justifyContent: 'center'
      },
      android: {
        backgroundColor: 'green', height: 30, margin: 5, alignItems:
          "center", justifyContent: 'center'
      },
    }),
  },

  top: {
    // flex: 1,
    ...Platform.select({
      ios: {
        flex: 1, marginTop: 10, marginBottom: 10,
      },
      android: {
        flex: 1, marginTop: 10, marginBottom: 10, height: 800
      },
    }),
  },
  signUpText: {
    fontSize: 13,
    justifyContent: 'center',


    color: 'white',
    alignSelf: 'center',
  },
});


const pickerSelectStyles = StyleSheet.create({
  inputIOS: {
    fontSize: 2,
    paddingVertical: 12,
    paddingHorizontal: 10,
    borderWidth: 1,
    borderColor: 'blue',
    borderRadius: 4,
    color: 'black',
    paddingRight: 30, // to ensure the text is never behind the icon
  },
  inputAndroid: {
    fontSize: 3,
    paddingHorizontal: 10,
    paddingVertical: 8,
    borderWidth: 0.5,
    borderColor: 'black',
    borderRadius: 8,
    color: 'black',
    paddingRight: 30, // to ensure the text is never behind the icon
    // backgroundColor:'pink'
  },
});