/*
FileName:TaskAdd.js
Version:1.0.0
Purpose:Adding Task
Devloper:Mahesh
*/
import React, { Component } from 'react';
import Requesteddata from '../AdminComponets/AdminRequestedDataProjects';
import { Platform, StyleSheet, Text, View, Dimensions, FlatList, Picker, TouchableHighlight, Image, TouchableOpacity, TextInput, Alert } from 'react-native';
import { Left, Button, Container, Header, Content, Item, Input } from 'native-base';
import AsyncStorage from '@react-native-community/async-storage';
import { widthPercentageToDP as wp, heightPercentageToDP as hp } from 'react-native-responsive-screen';
import Modal from "react-native-simple-modal";
import { API } from "../WebServices/RestClient";
import NetInfo from '@react-native-community/netinfo';
import Snackbar from 'react-native-snackbar';
import DatePicker from 'react-native-datepicker';

// import {
//   Dropdown,
//   GroupDropdown,
//   MultiselectDropdown,
// } from 'sharingan-rn-modal-dropdown';
// import { Dropdown } from 'react-native-material-dropdown';

import Toast from 'react-native-simple-toast';
import log from '../LogFile/Log';

export default class TaskAdd extends React.Component {

    constructor(props) {
        super(props);
        this.state = {
            isLoading: true,
            dataSource: [],
            isFetching: false,
            open: false,
            ProjectTitle: "",
            ProjectDescription: "",
            role: '',
            userToken: '',
            empData: [],
            dependencyData: [],
            subTask: '',
            description: '',
            days: '',
            time: '',
            modifyTask: 'modify',
            dependencyid: '',
            person: '',
            prioritySelected: '',
            severitySelected: '',
            itemPressedDisabled: false,
            error1: '', error2: '', error3: '', error4: '', error5: '',
            moduleId: this.props.navigation.state.params.moduleId,

            // action: this.props.navigation.state.params.action,//getting action
            //subTask: this.props.navigation.state.params.subTask,//idea id
            subTaskId: this.props.navigation.state.params.subTaskId,
            roadblockId: this.props.navigation.state.params.roadblockId,
            subTaskName: this.props.navigation.state.params.subTaskName,
            description: this.props.navigation.state.params.description,
            tasktitle: this.props.navigation.state.params.tasktitle,
            id: this.props.navigation.state.params.taskid,
            sprintDate: this.props.navigation.state.params.sprintDate,
            assignedTo: this.props.navigation.state.params.assignedTo,
        };

    }
    //open Modal
    modalDidOpen = () => console.log("Modal did open.");
    //close Modal
    modalDidClose = () => {
        this.props.navigation.goBack();

        this.setState({ open: false }); this.setState({ open: false });
        console.log("Modal did close.");

    };

    //Dialog actions start
    moveUp = () => this.setState({ offset: -100 });

    resetPosition = () => {
        this.setState({ offset: 0 });
        this.props.navigation.goBack();
    }

    //open the dialog 
    openModal = () => {
        this.setState({ open: true })

    };
    //close Dialog
    closeModal = () => {
        this.setState({
            open: false,
            error1: '', error2: '', error3: '', error4: '', error5: '',
        });
        this.props.navigation.goBack();


    }
    //Dialog actions end
    componentDidMount() {
        log("Debug", "Add Sub Task Modal screen is loaded");
        // this.empSearch();
        // this.dependencySearch();
        this.openModal();


    }

    //Refresh data
    // onRefresh() {
    //   this.setState({ isFetching: true }, function () { this.add() });
    // }
    //Refresh the maintask list
    onRefresh() {
        this.setState({
            // dataSource: [],
        })
        this.add();
    }
    //Text Field Validation method
    isValid() {
        const { description, } = this.state;
        let valid = false;

        // if (subTask.length === 0) {
        //   log("Warn", "subTask should not be empty");
        //   this.setState({ error1: 'Enter sub Task ' });
        // }
        // else if (description.length === 0) {
        //   log("Warn", "description should not be empty");
        //   this.setState({ error2: 'Enter Description ' });
        // }
        if (description.length === 0) {
            log("Warn", "Enter  Description ");
            this.setState({ error3: 'Enter Description ' });
        }




        else {
            valid = true;
        }
        return valid;
    }//isValid method end


    isAdedSucess() {
        taskTitlehow("Task Added", Toast.LONG);
    }

    //Add the subtask start
    addSubTask = () => {
        // alert(this.state.taskTitle)
    const { id } = this.state;
    // alert(id)
  


        log("Info", " addSubTask() is used to add sub task");
        const { item, subTask, description, days, time, tasktitle,moduleId,assignedTo } = this.state;
        // alert(this.state.id)
        // alert(description)

        // const message = "User story moved to roadblock" + roadBlockDescription;
        // console.log(this.state.subTaskId);
        // alert(this.state.description)
        // console.log(prioritySelected);
        // console.log(severitySelected);

        AsyncStorage.getItem("userToken", (err, res) => {
            const empId = res;
            AsyncStorage.getItem("cropcode", (err, res) => {
                const cropcode = res;
                AsyncStorage.getItem("projectId", (err, res) => {
                    const projectId = res;

                NetInfo.fetch().then(state => {
                    if (state.type == "none") {
                        console.log(state.type);
                        log("Warn", "No internet connection");
                        Snackbar.show({
                            title: 'No Internet Connection',
                            backgroundColor: 'red',
                            duration: Snackbar.LENGTH_LONG,
                        });
                    } 
                    // else {
                    //     if (this.state.sprintDate > this.state.targetDate) {
                    //         Alert("Target date should not exceed User story target date")
                    //     }

                        else if (this.isValid()) {
                            fetch(API + 'manage_tasks.php', {
                                method: 'POST',
                                headers: {
                                    'Accept': 'application/json',
                                    'Content-Type': 'application/json',
                                },
                                body: JSON.stringify({


                                    crop: cropcode,

                                    assignedBy: empId,
                                    maintaskId: this.state.id,
                                      assignedTo: assignedTo,

                                    action: "add",
                                    // subTaskId: this.state.subTaskId,
                                    title: tasktitle,
                                    moduleId: moduleId,


                                    description: description,
                                    // prioritySelected: this.state.prioritySelected,
                                    // severitySelected: this.state.severitySelected,
                                    targetDate:this.state.targetDate,
                                    projectId:projectId
                                    



                                })
                            }).then((response) => response.json())
                                .then((responseJson) => {
                                    //   alert(JSON.stringify(responseJson));
                                    console.log(JSON.stringify(responseJson));
                                    console.log(responseJson);
                                    if (responseJson.status === 'true') {
                                        alert("Sucess")
                                        console.log("done")
                                        // this.props.navigation.goBack();
                                        this.setState({ open: false })
                                    }
                                }).catch((error) => {
                                    console.error(error);
                                    log("Error", "addSubTask  error");
                                });
                            this.closeModal();
                            this.isAdedSucess();

                        }
                    // }
                });
            });
        });
    });

    };


    // if dependency not exit this method will executes
    addCommentUserStory = (message, subtaskid, cardId) => {
        //   alert("message" + message)
        //   alert("subtaskid" + subtaskid)
        //   alert("cardId" + cardId)
        console.warn("message" + message)
        console.warn("subtaskid" + subtaskid)
        console.warn("cardId" + cardId)

        log("Info", "updateActiveTaskStatus() method is used to make subtask as active");
        // const { subtaskid, taskStatus, description, taskcompleteStatus, } = this.props;
        // const message="User story in progress";
        //Time();
        NetInfo.fetch().then(state => {
            if (state.type == "none" || state.type == "undefined" || state.type == "unknown") {
                console.log(state.type);
                Snackbar.show({
                    title: 'No Internet Connection',
                    backgroundColor: 'red',
                    duration: Snackbar.LENGTH_LONG,
                });
            } else {
                AsyncStorage.getItem("cropcode", (err, res) => {
                    const cropcode = res;
                    AsyncStorage.getItem("userToken", (err, res) => {
                        const empId = res;
                        console.warn("empId" + empId)
                        fetch(API + 'storyComments.php',
                            {
                                method: 'POST',
                                headers: {
                                    Accept: 'application/json',
                                    'Content-Type': 'application/json',
                                },
                                body: JSON.stringify({
                                    corp: cropcode,
                                    action: "addStoryComment",
                                    storyId: subtaskid,
                                    userId: empId,
                                    message: message,
                                    cardId: cardId
                                })
                            })
                            .then((response) => response.json())
                            .then((responseJson) => {
                                console.warn(responseJson)
                                if (responseJson.status === 'True') {
                                    // this.props.navigation.navigate('Pending');
                                    //   this.onRefresh();
                                    // this.getSubtaskListPending();
                                    alert("Success");
                                } else {

                                    //   new Pending().onRefresh();

                                    alert("You not able active this task untill complete your activated task");

                                    log("Warn", "You not able active this task untill complete your activated task");
                                }
                            })
                            .catch((error) => {
                                console.error(error);
                                log("Error", "Error in making subtask as active");
                            });
                    });
                });
            }
        });
    }

    //Getting the Employee List for Adding subtask
    empSearch() {
        log("Info", "empSearch(cropcode) method is used to employee's data");
        AsyncStorage.getItem("cropcode", (err, res) => {
            const crop = res;
            NetInfo.fetch().then(state => {
                if (state.type == "none") {
                    console.log(state.type);
                    log("Warn", "No internet connection");
                    Snackbar.show({
                        title: 'No Internet Connection',
                        backgroundColor: 'red',
                        duration: Snackbar.LENGTH_LONG,
                    });
                } else {
                    this.setState({ itemPressedDisabled: false })
                    fetch(API + 'getEmployees.php', {
                        method: 'POST',
                        headers: {
                            'Accept': 'application/json',
                            'Content-Type': 'application/json',
                        },
                        body: JSON.stringify({
                            action: "add",
                            crop: crop //Async
                        })
                    })
                        .then((response) => response.json())
                        .then((responseJson) => {
                            this.setState({ itemPressedDisabled: false })
                            this.setState({
                                empData: [...responseJson.data],
                            });
                        }
                        )
                        .catch((error) => {
                            console.error(error);
                            log("Error", "error in geting employees details");
                        });
                }
            });
        });
    }
    //Getting Employees List end

    //Getting dependency task list start
    dependencySearch() {
        console.warn(this.props.navigation.state.params.IdeaId)
        AsyncStorage.getItem("cropcode", (err, res) => {
            const crop = res;
            NetInfo.fetch().then(state => {
                if (state.type == "none") {
                    console.log(state.type);
                    log("Warn", "No internet connection");
                    Snackbar.show({
                        title: 'No Internet Connection',
                        backgroundColor: 'red',
                        duration: Snackbar.LENGTH_LONG,
                    });
                } else {
                    fetch(API + 'getSubtasks.php', {
                        method: 'POST',
                        headers: {
                            'Accept': 'application/json',
                            'Content-Type': 'application/json',
                        },
                        body: JSON.stringify({
                            action: "setdependency",
                            crop: crop, //Async
                            ideaId: this.state.ideaId
                        })
                    })
                        .then((response) => response.json())
                        .then((responseJson) => {
                            console.warn(responseJson)
                            if (responseJson.status === 'true') {
                                // alert("Your Task is Updated Successfully");
                                // this.getdata();//to get the user pending my task list

                                this.setState({
                                    isLoading: false,
                                    dependencyData: [...responseJson.data],
                                    isFetching: false
                                }, function () {
                                });

                            } else {
                                Alert.alert("No depencency is available")
                                // log("Info", "no pending my tasks at user side");
                            }
                            // if (responseJson.status === 'TRUE') {
                            // this.setState({
                            //   dependencyData: [...responseJson.data],
                            // });
                            //   }
                            // else{
                            //   dependencyData:[]
                            // }
                            // this.setState({
                            //   dependencyData: [...responseJson.data],
                            // });
                        }
                        )
                        .catch((error) => {
                            console.error(error);
                            log("Error", "error in geting employees depencey ");
                        });
                }
            });
        });
    }
    //Getting dependency task list end

    render() {




        return (
            <Modal
                visible={this.state.modalVisible}
                transparent={true}
                animationType='fade'
                open={this.state.open}
                modalDidOpen={this.modalDidOpen}
                modalDidClose={this.modalDidClose}
                style={{ alignItems: "center", backgroundColor: 'white' }} >


                <View style={{ alignItems: "center", backgroundColor: 'white' }}>
                    <Text style={{ fontSize: 18, justifyContent: 'center', alignSelf: 'center', justifyContent: 'center' }}>UserStory {this.state.tasktitle}</Text>

                    <View style={{ marginLeft: 10, width: '100%', }}>

                        <Text style={{ color: 'red' }}>{this.state.error2}</Text>
                        <TextInput placeholder="Task Title" style={{ width: '90%', borderBottomWidth: 0.5, borderBottomColor: 'black' }}
                            value={this.state.taskTitle}
                            onChangeText={(text) => this.setState({ taskTitle: text })}></TextInput>

                    </View>

                    <View style={{ marginLeft: 10, width: '100%', }}>

                        <Text style={{ color: 'red' }}>{this.state.error2}</Text>
                        <TextInput placeholder="Description" style={{ width: '90%', borderBottomWidth: 0.5, borderBottomColor: 'black' }}
                            value={this.state.description}
                            onChangeText={(text) => this.setState({ description: text })}></TextInput>

                    </View>






                    <View style={{ paddingTop: 20, width: '100%', marginLeft: '2%' }}>

                        <DatePicker
                            style={{ textAlign: 'left', marginLeft: 10, borderColor: '#b6b6b6', borderWidth: 1, width: '90%', height: 40, borderRadius: 10, marginTop: 5 }}
                            date={this.state.targetDate}
                            mode="date"
                            placeholder="Target Date"
                            format="MM-DD-YYYY"
                            minDate="01-01-2020"
                            maxDate="12-31-2080"
                            // minDate="01-01-2019"
                            // maxDate="01-06-2075"
                            confirmBtnText="From"
                            cancelBtnText="To"
                            showIcon={false}
                            customStyles={{
                                dateInput: { borderWidth: 0, borderBottomWidth: 2 },
                                placeholderText: { fontSize: 15, color: "#9a73ef" },
                                dateText: { textAlign: 'left', fontSize: 15, }
                            }}
                            onDateChange={(text) => this.setState({ targetDate: text })} />
                    </View>




                    <View style={{ flexDirection: 'row', }}>
                        <TouchableOpacity style={styles.opensave} onPress={this.addSubTask} disabled={this.state.itemPressedDisabled}>
                            <Text style={{ color: 'white' }}>SAVE</Text>

                        </TouchableOpacity>
                        <TouchableOpacity style={styles.opencancel} onPress={this.closeModal}>
                            <Text style={{ color: 'white' }}>CANCEL</Text>
                        </TouchableOpacity>

                    </View>


                </View>

            </Modal>



        );

    }

}
//Styles for UI

const styles = StyleSheet.create(
    {
        MainContainer:
        {
            flex: 1,
            width: Dimensions.get('window').width,
            height: Dimensions.get('window').height
        },
        bottomView: {
            flexDirection: 'row',
            justifyContent: 'center',
            position: 'absolute',
            height: FOOTER_MAX_HEIGHT,
            bottom: 0,
            left: 0,
            right: 0,
            // backgroundColor: 'black',
            alignItems: 'center'
        },

        textStyle: {
            color: '#fff',
            fontSize: 18
        },
        container: {
            flex: 1,
            width: '90%',
            paddingLeft: hp('2%'),
        },
        footer: {
            position: 'absolute',
            flex: 0.1,
            left: 0,
            right: 0,
            bottom: -10,
            backgroundColor: 'green',
            flexDirection: 'row',
            height: 80,
            alignItems: 'center',
        },
        bottomButtons: {
            alignItems: 'center',
            justifyContent: 'center',
            flex: 1,
        },
        footerText: {
            color: 'white',

            alignItems: 'center',
            fontSize: 18,
        },
        buttonContainer: {
            width: wp('90%'),
            alignSelf: 'baseline',
            marginBottom: 25,
            // color: '#d2691e',
            marginLeft: 4,



        },
        signupButton: {

            backgroundColor: '#ffffff',
        },
        subcontainer: {
            flex: 2,
            flexDirection: 'row',
            paddingTop: 40
        },
        signUpText0: {
            fontSize: 13,
            color: 'green',
            paddingTop: 10,

        },
        signUpText1: {
            fontSize: 13,
            color: 'green',
            paddingTop: 10,

            paddingLeft: 10,
        },
        end: {

            alignItems: 'flex-end',

        },
        end1: {
            flex: 2,
            height: '50%',
            paddingTop: 20,
            justifyContent: 'space-between',

            flexDirection: 'row',
        },
        s: {
            justifyContent: 'center',

            // backgroundColor: '#ed7070',
            shadowOffset: { width: 50, height: 50 },
            alignItems: 'center',
            width: wp('40%'),
            height: hp('12%'),

        },
        signUpText2: {
            fontSize: 10,
            marginLeft: 200,
            fontSize: 13,
            color: 'green',
            paddingTop: 10,

            //  marginRight: 10,
            //textAlign: "right"

        },
        signUpText3: {

            fontSize: 12,
            paddingTop: 10,
            paddingLeft: 10,

            alignItems: 'center',
        },
        signUpText4: {
            fontSize: 12,
            paddingTop: 10,


            alignItems: 'center',
        },
        signup: {
            //paddingTop:20,
            color: "#FFF",

        },
        boxone: {
            flex: 1,
            marginTop: 5,

        },
        boxtwo: {
            flex: 1,

        },
        boxthree: {
            flex: 1,

        },
        box: {
            flexDirection: 'row',
            position: 'relative',
            marginBottom: 10,


        },
        signUpText: {
            fontSize: 20,
            justifyContent: 'center',


            color: 'white',
            alignSelf: 'center',
        },
        buttonView: {
            display: 'flex',
            justifyContent: 'center',
            flexDirection: 'row',
            marginTop: 10,
        },
        containerButton: {
            paddingTop: 30,
            marginLeft: 20,
            marginRight: 20,
            flex: 1,
        },
        opencancel: {
            flex: 1,
            ...Platform.select({
                ios: {
                    backgroundColor: 'red', margin: 20, height: 30, alignItems:
                        "center", justifyContent: 'center'
                },
                android: {
                    backgroundColor: 'red', margin: 20, height: 30, alignItems:
                        "center", justifyContent: 'center'
                },
            }),
        },
        opensave: {
            flex: 1,
            ...Platform.select({
                ios: {
                    backgroundColor: 'green', margin: 20, height: 30, alignItems:
                        "center", justifyContent: 'center'
                },
                android: {
                    backgroundColor: 'green', margin: 20, height: 30, alignItems:
                        "center", justifyContent: 'center'
                },
            }),
        },

    });



