/*
FileName:TaskChat.js
Version:1.0.0
Purpose:Getting the List of task messages with GroupName and List of Group Members and also send Message
Devloper:Rishitha,Naveen
*/

import React, { Component } from 'react';
import {
  StyleSheet,
  Text,
  View,
  TouchableOpacity,
  Image,
  Alert,
  ScrollView,
  TextInput,
  FlatList,
  Button,
  Dimensions,
  KeyboardAvoidingView,
  TouchableWithoutFeedback,
  Keyboard
} from 'react-native';
import Icon from 'react-native-vector-icons/FontAwesome';
import AsyncStorage from '@react-native-community/async-storage';

import { Title, Container, Content, Header, Right, Left, Body, Tab, Tabs, TabHeading, Footer, Item, Input, FooterTab, Subtitle } from 'native-base';

import NetInfo from '@react-native-community/netinfo';
import { API } from "../WebServices/RestClient";
import log from '../LogFile/Log';
import { EMPLOYEEID } from './Header';


export default class TaskChat extends Component {

  constructor(props) {
    super(props);
    this.state = {
      message: '',
      dataSource: [],
      itemPressedDisabled: false,
      subtaskId: this.props.navigation.state.params.id,
      action: this.props.navigation.state.params.action,
      sno: this.props.navigation.state.params.sno,
      userid: '',
      groupName: '',
      groupList: '',
    };
  }

  componentDidMount() {
    log("Debug", "Task Chat screen is loaded");
    this.groupMembersList();//Getting the List of GroupMembers
    this.getMessages();//Getting the List of Messages based pn Task
    this.updateMessages();//Update the chat count
    this.groupMembersEmail();//Getting the List of GroupMembers Emails
  }
  //getting task related group members added by naveen
  groupMembersList() {
    log("Info", " groupMembersList(role, userToken, cropcode) is used getting task related group members");
    // alert(this.state.action)
    const groupId = this.state.subtaskId;
    console.warn("taskid" + groupId)
    // alert(groupId)
    AsyncStorage.multiGet(["cropcode", "userToken"], (err, response) => {
      const cropcode = response[0][1];
      const userToken = response[1][1];


      this.setState({ userid: userToken });

      NetInfo.fetch().then(state => {
        if (state.type == "none") {
          log("Warn", "No internet connection");
          Snackbar.show({
            title: 'No Internet Connection',
            backgroundColor: 'red',
            duration: Snackbar.LENGTH_LONG,
          });
        }
        else {
          fetch(API + 'user_story_details.php',
            {
              method: 'POST',
              headers: {
                Accept: 'application/json',
                'Content-Type': 'application/json',
              },
              body: JSON.stringify({
                action: this.state.action,
                corp_code: cropcode,
                groupId: groupId

              })
            })
            .then((response) => response.json())
            .then((responseJson) => {
              console.warn("Hello" + JSON.stringify(responseJson))
              // alert("Hello" + JSON.stringify(responseJson))
              //Getting the Group details for Subtask start
              if (responseJson.status === 'True' && responseJson.task == 'subtask') {

                const al = [];
                al.push(responseJson.ideaByName);
                al.push(responseJson.acceptedByName);
                al.push(responseJson.ideaModfiedName);
                al.push(responseJson.releaseOwner);
                al.push(responseJson.rejectedByName);
                al.push(responseJson.moduleCreatedBy);
                al.push(responseJson.moduleModifiedBy);
                al.push(responseJson.mainAssignedBy);
                al.push(responseJson.mainAssignedTo);
                al.push(responseJson.mainModifiedBy);
                al.push(responseJson.subAssignedBy);
                al.push(responseJson.subAssignedTo);
                al.push(responseJson.subModifiedBy);
                // al.push('admin');
                al.push('Admin(admin)');
                this.setState({
                  groupName: responseJson.subTaskId
                })

                // const k = (al);
                // function getUnique(array) {

                //   var uniqueArray = [];

                //   // Loop through array values

                //   for (var value of array) {

                //     if (uniqueArray.indexOf(value) === -1) {

                //       uniqueArray.push(value);
                //     }
                //   }

                //   return uniqueArray;
                // }
                // console.warn(k);
                const k = (al);
                function getUnique(array) {
                  var uniqueArray = [];
                  // Loop through array values
                  for (var value of array) {
                    if (uniqueArray.indexOf(value) === -1) {
                      if (value !== "NA") {
                        uniqueArray.push(value);
                      }
                    }
                  }
                  return uniqueArray;
                }

                var uniqueNames = getUnique(k);
                console.warn(uniqueNames)
                var h = uniqueNames;

                // var details = "admin";
                var details = "Admin(admin)";
                // for (var i = 0; i < h.length - 1; i++) {//Checking the group list
                for (var i = 1; i <= h.length; i++) {//Checking the group list

                  // if (h[i] === "NA" || h[i] == "admin") { //Remove Duplicate list
                  //   h.splice(i, 2);
                  // }

                  if (h[i] === "Admin(admin)") { //Remove Duplicate list
                    h.splice(i, 1);
                  }

                  //Concat List of Group Members
                  details = details + "," + h[i - 1];
                  this.setState({
                    groupList: details
                  })
                  //alert(details);
                }

                this.setState({
                  groupName: responseJson.subTaskId,
                });

              }
              //Getting the Group details for Subtask end

              //Getting the Group details for Maintask start
              else if (responseJson.status === 'True' && responseJson.task == 'maintask') {
                const al = [];
                al.push(responseJson.ideaByName);
                al.push(responseJson.acceptedByName);
                al.push(responseJson.ideaModfiedName);
                al.push(responseJson.releaseOwner);
                al.push(responseJson.rejectedByName);
                al.push(responseJson.moduleCreatedBy);
                al.push(responseJson.moduleModifiedBy);
                al.push(responseJson.mainAssignedBy);
                al.push(responseJson.mainAssignedTo);
                al.push(responseJson.mainModifiedBy);
                al.push('Admin(admin)');
                this.setState({
                  groupName: responseJson.subTaskId
                })

                const k = (al);
                function getUnique(array) {

                  var uniqueArray = [];

                  // Loop through array values

                  for (var value of array) {

                    // if (uniqueArray.indexOf(value) === -1) {

                    //   uniqueArray.push(value);
                    // }
                    if (uniqueArray.indexOf(value) === -1) {
                      if (value !== "NA") {
                        uniqueArray.push(value);
                      }
                    }
                  }

                  return uniqueArray;
                }
                // console.warn("Naveen"+k);
                var uniqueNames = getUnique(k);
                console.warn(uniqueNames)
                var h = uniqueNames;
                console.warn(h.length)
                details = "Admin(admin)";
                for (var i = 1; i < h.length; i++) {//Checking the group list
                  if (h[i] === "Admin(admin)") { //Remove duplicate list
                    h.splice(i, 1);
                  }

                  //Concat List of Group Members
                  details = details + "," + h[i - 1];
                  console.warn("Details" + details)
                  this.setState({
                    groupList: details.replace("Admin(admin),", "")
                  })
                  // alert(details);
                }

                this.setState({
                  groupName: responseJson.subTaskId,

                });
              }//Getting the Group details for maintask end
              else {

              }
            })
            .catch((error) => {
              console.error(error);
              log("Error", "Task Chat maintask group Menbers error");
            });

        }
      });
    });

  }

  //getting task related group members emails added by mahesh
  groupMembersEmail() {
    log("Info", " groupMembersEmail(role, userToken, cropcode) is used getting task related group members emails");
    //alert(this.state.action)
    const groupId = this.state.subtaskId;
    console.warn("taskid" + groupId)
    AsyncStorage.multiGet(["cropcode", "userToken"], (err, response) => {
      const cropcode = response[0][1];
      const userToken = response[1][1];


      this.setState({ userid: userToken });

      NetInfo.fetch().then(state => {
        if (state.type == "none") {
          log("Warn", "No internet connection");
          Snackbar.show({
            title: 'No Internet Connection',
            backgroundColor: 'red',
            duration: Snackbar.LENGTH_LONG,
          });
        }
        else {
          fetch(API + 'user_story_details1.php',
            {
              method: 'POST',
              headers: {
                Accept: 'application/json',
                'Content-Type': 'application/json',
              },
              body: JSON.stringify({
                action: this.state.action,
                corp_code: cropcode,
                groupId: groupId

              })
            })
            .then((response) => response.json())
            .then((responseJson) => {
              console.warn("Hello" + JSON.stringify(responseJson))
              // alert("Hello"+JSON.stringify(responseJson))
              //Getting the Group details for Subtask start
              if (responseJson.status === 'True' && responseJson.task == 'subtask') {

                const al = [];
                al.push(responseJson.ideaByName);
                al.push(responseJson.acceptedByName);
                al.push(responseJson.ideaModfiedName);
                al.push(responseJson.releaseOwner);
                al.push(responseJson.rejectedByName);
                al.push(responseJson.moduleCreatedBy);
                al.push(responseJson.moduleModifiedBy);
                al.push(responseJson.mainAssignedBy);
                al.push(responseJson.mainAssignedTo);
                al.push(responseJson.mainModifiedBy);
                al.push(responseJson.subAssignedBy);
                al.push(responseJson.subAssignedTo);
                al.push(responseJson.subModifiedBy);
                // al.push('admin');
                al.push('Admin(admin)');
                this.setState({
                  groupName: responseJson.subTaskId
                })

                // const k = (al);
                // function getUnique(array) {

                //   var uniqueArray = [];

                //   // Loop through array values

                //   for (var value of array) {

                //     if (uniqueArray.indexOf(value) === -1) {

                //       uniqueArray.push(value);
                //     }
                //   }

                //   return uniqueArray;
                // }
                // console.warn(k);
                const k = (al);
                function getUnique(array) {
                  var uniqueArray = [];
                  // Loop through array values
                  for (var value of array) {
                    if (uniqueArray.indexOf(value) === -1) {
                      if (value !== "NA") {
                        uniqueArray.push(value);
                      }
                    }
                  }
                  return uniqueArray;
                }

                var uniqueNames = getUnique(k);
                console.warn(uniqueNames)
                var h = uniqueNames;

                // var details = "admin";
                var details = "Admin(admin)";
                // for (var i = 0; i < h.length - 1; i++) {//Checking the group list
                for (var i = 1; i <= h.length; i++) {//Checking the group list

                  // if (h[i] === "NA" || h[i] == "admin") { //Remove Duplicate list
                  //   h.splice(i, 2);
                  // }

                  if (h[i] === "Admin(admin)") { //Remove Duplicate list
                    h.splice(i, 1);
                  }

                  //Concat List of Group Members
                  details = details + "," + h[i - 1];
                  this.setState({
                    groupList: details
                  })
                  //alert(details);
                }

                this.setState({
                  groupName: responseJson.subTaskId,
                });

              }
              //Getting the Group details for Subtask end

              //Getting the Group details for Maintask start
              else if (responseJson.status === 'True' && responseJson.task == 'maintask') {
                const al = [];
                al.push(responseJson.ideaByName);
                al.push(responseJson.acceptedByName);
                al.push(responseJson.ideaModfiedName);
                al.push(responseJson.releaseOwner);
                al.push(responseJson.rejectedByName);
                al.push(responseJson.moduleCreatedBy);
                al.push(responseJson.moduleModifiedBy);
                al.push(responseJson.mainAssignedBy);
                al.push(responseJson.mainAssignedTo);
                al.push(responseJson.mainModifiedBy);
                al.push('Admin(admin)');
                this.setState({
                  groupName: responseJson.subTaskId
                })

                const k = (al);
                function getUnique(array) {

                  var uniqueArray = [];

                  // Loop through array values

                  for (var value of array) {

                    // if (uniqueArray.indexOf(value) === -1) {

                    //   uniqueArray.push(value);
                    // }
                    if (uniqueArray.indexOf(value) === -1) {
                      if (value !== "NA") {
                        uniqueArray.push(value);
                      }
                    }
                  }

                  return uniqueArray;
                }
                // console.warn("Naveen"+k);
                var uniqueNames = getUnique(k);
                console.warn(uniqueNames)
                var h = uniqueNames;
                console.warn(h.length)
                details = "Admin(admin)";
                for (var i = 1; i < h.length; i++) {//Checking the group list
                  if (h[i] === "Admin(admin)") { //Remove duplicate list
                    h.splice(i, 1);
                  }

                  //Concat List of Group Members
                  details = details + "," + h[i - 1];
                  console.warn("Details" + details)
                  this.setState({
                    // groupEmail: details.replace("Admin(admin),", "")
                    groupEmail: al
                  })
                  // alert(this.state.groupEmail);
                }

                // this.setState({
                //   groupEmail: responseJson.subTaskId,

                // });
                // alert(this.state.groupEmail)
              }//Getting the Group details for maintask end
              else {

              }
            })
            .catch((error) => {
              console.error(error);
              log("Error", "Task Chat maintask group Menbers error");
            });

        }
      });
    });

  }

  //getting task related messages
  getMessages() {
    log("Info", " getMessages(role, userToken, cropcode) is used getting task related messages");
    const groupId = this.state.subtaskId;
    console.warn("groupid" + groupId);

    AsyncStorage.multiGet(["cropcode", "userToken"], (err, response) => {
      const cropcode = response[0][1];
      const userToken = response[1][1];
      this.setState({ userid: userToken });

      NetInfo.fetch().then(state => {
        if (state.type == "none") {
          log("Warn", "No internet connection");
          Snackbar.show({
            title: 'No Internet Connection',
            backgroundColor: 'red',
            duration: Snackbar.LENGTH_LONG,
          });
        }
        else {
          fetch(API + 'user_story_chat.php',
            {
              method: 'POST',
              headers: {
                Accept: 'application/json',
                'Content-Type': 'application/json',
              },
              body: JSON.stringify({
                action: 'getmessages',
                corp_code: cropcode,
                groupId: groupId

              })
            })
            .then((response) => response.json())
            .then((responseJson) => {
              console.warn(responseJson)

              if (responseJson.status === 'True') {
                console.warn(responseJson);
                this.setState({
                  dataSource: responseJson.data,
                });
              } else {
                this.setState({
                  dataSource: '',
                });
              }
            })
            .catch((error) => {
              console.error(error);
              log("Error", "getting task related messages error");
            });

        }
      });
    });
  }


  //update task related messages
  updateMessages() {
    log("Info", " updateMessages(role, userToken, cropcode) is used to update task related messages");
    const groupId = this.state.subtaskId;
    const sno = this.state.sno;
    console.warn("sno" + sno)

    const msgId = sno ? sno.map((msgId, index) => {
      return msgId.sno
    }) : null
    // console.warn("Sno of the data"+this.props.navigation.state.params.sno)

    AsyncStorage.multiGet(["cropcode", "userToken"], (err, response) => {
      const cropcode = response[0][1];
      const userToken = response[1][1];
      this.setState({ userid: userToken });

      NetInfo.fetch().then(state => {
        if (state.type == "none") {
          log("Warn", "No internet connection");
          Snackbar.show({
            title: 'No Internet Connection',
            backgroundColor: 'red',
            duration: Snackbar.LENGTH_LONG,
          });
        }
        else {
          fetch(API + 'user_story_chat.php',
            {
              method: 'POST',
              headers: {
                Accept: 'application/json',
                'Content-Type': 'application/json',
              },
              body: JSON.stringify({
                action: 'updateChat',
                corp_code: cropcode,
                messagedBy: userToken,

                msgId: msgId ? msgId : " "
                // groupId: groupId

              })
            })
            .then((response) => response.json())
            .then((responseJson) => {
              console.warn("update chat" + JSON.stringify(responseJson))


            })
            .catch((error) => {
              console.error(error);
              log("Error", "getting task related messages error");
            });

        }
      });
    });
  }
  //Sending Message without empty data added by naveen on 11 Nov
  sendMessageText() {
    if (this.state.message == 0) {
      alert("please type message")
      log("Warn", "message should not be empty");
    }
    else {
      this.sendMessage()
    }
  }
  //send messages
  sendMessage() {
    // AsyncStorage.getItem("groupEmail", (err, res) => {
    //   this.setState({ groupEmail: res });
    log("Info", " sendMessage(role, userToken, cropcode) is used to send messages");
    const message = this.state.message;
    const groupId = this.state.subtaskId;
    const groupEmail = Array.from(new Set(this.state.groupEmail));
    // alert(groupEmail)
    // console.warn("emails"+groupEmail)
    // alert(this.state.groupName)

    AsyncStorage.multiGet(["cropcode", "userToken"], (err, response) => {
      const cropcode = response[0][1];
      const userToken = response[1][1];

      this.setState({ itemPressedDisabled: true })
      fetch(API + 'user_story_chat.php', {
        method: 'POST',
        headers: {
          'Accept': 'application/json',
          'Content-Type': 'application/json',
        },
        body: JSON.stringify({

          action: 'send',
          groupId: groupId,
          corp_code: cropcode,
          message: message,
          messagedBy: userToken,
          groupName: this.state.groupName,
          groupEmail: groupEmail,

        })
      }).then((response) => response.json())
        .then((responseJson) => {
          this.getMessages();
          this.setState({
            message: '',
             itemPressedDisabled: false ,
          });
          //message:this.state.message=''
        }).catch((error) => {
          console.error(error);
          log("Error", "send message error");
        });
    });
    // });
  }

  renderDate = (date) => {
    return (
      <Text style={styles.time}>
        {date}
      </Text>
    );
  }

  render() {

    return (
      <KeyboardAvoidingView
        behavior={Platform.OS === "ios" ? "padding" : "height"}
        style={styles.container}
      >
        <TouchableWithoutFeedback onPress={Keyboard.dismiss}>

          <Container>
            <Header
              androidStatusBarColor="#00A2C1"
              style={{
                backgroundColor: '#00A2C1',
                height: 60,
                width: Dimensions.get('window').width,
                borderBottomColor: '#ffffff',
                justifyContent: 'space-between',
              }}>

              <Icon name="arrow-left" size={20} style={{ color: '#fff', paddingTop: 15 }}
                onPress={() =>
                  this.props.navigation.goBack()} />
              <Body style={{ paddingLeft: 10, }}>
                <Title>{this.state.groupName}</Title>
                <Text style={{ fontSize: 10 }}>{this.state.groupList}</Text>
              </Body>

            </Header>
            {/* <KeyboardAvoidingView> */}
            <View style={styles.container}>
              <ScrollView ref="scrollView"
                onContentSizeChange={(width, height) => this.refs.scrollView.scrollTo({ y: height })}>



                <FlatList style={styles.list}


                  data={this.state.dataSource}
                  keyExtractor={(item) => {
                    return item.id;
                  }}
                  renderItem={(message) => {
                    const item = message.item;
                    let inMessage = item.messagedBy === this.state.userid;
                    let itemStyle = !inMessage ? styles.itemIn : styles.itemOut;
                    const left = <Text style={{ fontSize: 12, color: 'orange' }}>{item.username}</Text>
                    const right = <Text style={{ fontSize: 12, color: 'blue' }}>{item.username}</Text>
                    return (
                      <ScrollView>
                        <View style={[styles.item, itemStyle]}>
                          <View style={{ padding: 5, }}>
                            {itemStyle === styles.itemOut ? left : right}
                            <Text>{item.message}</Text>
                            {!inMessage && this.renderDate(item.messagedTime)}
                            {inMessage && this.renderDate(item.messagedTime)}
                          </View>
                        </View>
                      </ScrollView>
                    )
                  }} />
              </ScrollView>



              <View style={styles.footer}>
                <View style={styles.inputContainer}>
                  <TextInput style={styles.inputs}
                    placeholder="Write a message..."
                    underlineColorAndroid='transparent'
                    multiline={true}

                    onChangeText={(value) => this.setState({ message: value })}
                    value={this.state.message} />
                </View>

                <TouchableOpacity style={styles.btnSend} disabled={this.state.itemPressedDisabled} onPress={() => { this.sendMessageText() }}>
                  {/* <Image source={{uri:"https://png.icons8.com/small/75/ffffff/filled-sent.png"}} style={styles.iconSend}  /> */}
                  <Image source={require('../Images/sent.png')} style={styles.iconSend} />
                </TouchableOpacity>
              </View>

            </View>
            {/* </KeyboardAvoidingView> */}
          </Container>

        </TouchableWithoutFeedback>
      </KeyboardAvoidingView>

    );
  }
}
//Styles fro UI
const styles = StyleSheet.create({
  container: {
    flex: 1
  },
  list: {
    paddingHorizontal: 17,
  },
  footer: {
    flexDirection: 'row',
    height: 60,
    backgroundColor: '#eeeeee',
    paddingHorizontal: 10,
    padding: 5,
  },
  btnSend: {
    backgroundColor: "#00BFFF",
    width: 40,
    height: 40,
    borderRadius: 360,
    alignItems: 'center',
    justifyContent: 'center',
  },
  iconSend: {
    width: 30,
    height: 30,
    alignSelf: 'center',
  },
  inputContainer: {
    borderBottomColor: '#F5FCFF',
    backgroundColor: '#FFFFFF',
    borderRadius: 30,
    borderBottomWidth: 1,
    height: 40,
    flexDirection: 'row',
    alignItems: 'center',
    flex: 1,
    marginRight: 10,
    alignItems: 'baseline',

  },
  inputs: {
    height: 40,
    marginLeft: 16,
    borderBottomColor: '#FFFFFF',
    flex: 1,
    // position:'absolute',
    alignItems: 'baseline',
    paddingTop: 10
  },
  balloon: {
    maxWidth: 200,
    padding: 10,
    borderRadius: 20,

  },
  itemIn: {

    alignSelf: 'flex-start',
    maxWidth: '98%',
    //  flexDirection:'row'
  },
  itemOut: {
    alignSelf: 'flex-end',
    //paddingLeft:10,
    maxWidth: '98%',
    // flexDirection:'row'
  },
  time: {
    alignSelf: 'flex-end',
    // margin: 15,
    fontSize: 12,
    color: "#808080",
    paddingRight: 10
  },
  item: {
    marginVertical: 14,
    flex: 1,
    flexDirection: 'row',
    // paddingLeft:50,
    backgroundColor: "#eeeeee",
    borderRadius: 10,
    padding: 5,
  },
});