/*
Forgot.js-------------->/*
FileName:Forgot.js
Version:1.3
Purpose:Forgot password changing
Devloper:Mahesh
*/
import React, { Component } from 'react';
import { Text, View, TextInput, Image, StyleSheet, TouchableOpacity, ImageBackground, Alert } from 'react-native';
import Icon from 'react-native-vector-icons/FontAwesome';
import MyTask from '../UserComponents/UserMyTask';
import AsyncStorage from '@react-native-community/async-storage';
import RadioGroup from 'react-native-radio-button-group';
import { API } from "../WebServices/RestClient";
import log from '../LogFile/Log';
import NetInfo from '@react-native-community/netinfo';
import Snackbar from 'react-native-snackbar';
import { DotIndicator } from 'react-native-indicators';
import Database from '../OfflineDB/Database';
import { URL } from '../CommonComponents/Header';
const db = new Database();

export default class Forgot extends Component {

    constructor(props) {
        super(props);
        this.state = {
            isLoading: false,
            username: '',
            action: '',
            resetPassword: "resetPassword"

        };
    }



    componentDidMount() {
        db.initDB();
        log("Debug", "Login Screen is Loaded");
    }


    // //User or Admin Login 
    // onLogin() {
    //     const { username, action, } = this.state;
    //     if (this.isValid()) {
    //         // console.log(username+""+password);
    //         fetch(API + 'agileRegister.php', {
    //             method: 'POST',
    //             headers: {
    //                 'Accept': 'application/json',
    //                 'Content-Type': 'application/json',
    //             },
    //             body: JSON.stringify({
    //                 username: username,
    //                 action: 'forgotPassword',
    //                 // url: `https://www.agile24x7.com/resetPassword`
    //                 url:'${URL}resetPassword'

    //             })
    //         }).then((response) => response.json())
    //             .then((responseJson) => {
    //                 console.log(JSON.stringify(responseJson));

    //                 if (responseJson.status === 'true') {
    //                     alert("Password sent successfully")
    //                 }
    //                 else {
    //                     console.warn(JSON.stringify(responseJson));
    //                     alert("Invalid Email")

    //                 }

    //             }).catch((error) => {
    //                 console.error(error); s
    //                 log("Error", "Login Error");

    //             });

    //     };
    // }



    //User or Admin Login 
    onLogin() {
        const { username, action, resetPassword } = this.state;
        const url = URL + resetPassword;
        console.warn("Url" + url)
        // console.log(username+""+password);
        fetch(API + 'agileRegister.php', {
            method: 'POST',
            headers: {
                'Accept': 'application/json',
                'Content-Type': 'application/json',
            },
            body: JSON.stringify({
                username: username,
                action: 'forgotPassword',
                // url: `https://www.agile24x7.com/resetPassword`
                // url:'${URL}resetPassword'
                url: url,

            })
        }).then((response) => response.json())
            .then((responseJson) => {
                console.log(JSON.stringify(responseJson));

                if (responseJson.status === 'True') {
                    alert("Please check your email to reset password")
                    this.props.navigation.navigate('Login')
                }
                else {
                    console.warn(JSON.stringify(responseJson));
                    alert("Invalid Email")

                }

            }).catch((error) => {
                console.error(error);
                log("Error", "Login Error");

            });


    }


    render() {
        if (this.state.isLoading) {
            return (
                <View style={{ flex: 1, alignItems: 'center', justifyContent: 'center' }}>
                    <DotIndicator color='#283B53' />
                </View>
            );

        }


        return (
            <View style={styles.container}>
                <View style={styles.form}>
                    <View style={styles.logoView}>

                        <ImageBackground
                            style={styles.logoContainer}
                            source={require('../Images/agilecloud.png')}
                            imageStyle={{ width: 190, alignItems: 'center', }} >

                        </ImageBackground>
                    </View>

                    <View style={styles.inputContainer}>
                        <Icon style={styles.inputIcon}
                            name='envelope-open'
                            color='white'
                            type='MaterialCommunityIcons'
                            size={25}
                        />
                        <TextInput style={{ width: 265, height: 45, color: 'white' }}
                            selectionColor='white'
                            placeholder="Email *"
                            autoCapitalize='none'
                            placeholderTextColor={'rgba(255,255,255,0.3)'}
                            keyboardType="email-address"
                            underlineColorAndroid='transparent'
                            onChangeText={(username) => this.setState({ username })} />
                    </View>


                    <TouchableOpacity style={[styles.buttonContainer, styles.signupButton]}
                        onPress={() => NetInfo.fetch().then(state => {
                            // alert(state.type);
                            if (state.type == "none" || state.type == "unknown") {
                                console.log(state.type);
                                Snackbar.show({
                                    title: 'No Internet Connection',
                                    backgroundColor: 'red',
                                    duration: Snackbar.LENGTH_LONG,
                                });
                            }
                            else {
                                this.onLogin()
                            }
                        })
                        } >
                        <Text style={styles.signUpText}>Send</Text>
                    </TouchableOpacity>
                    <View >
                    </View>
                </View>

            </View>
        );
    }
}
//Styles for UI
const styles = StyleSheet.create({
    container: {
        flex: 1,
        justifyContent: 'center',
        alignItems: 'center',
    },
    logoContainer: {
        marginLeft: 95,
        height: 150,
        width: 150,

    },
    stretch: {
        width: 200,
        height: 200,
        marginLeft: 80
    },
    // logo: {
    //   top: 40,
    //   marginLeft: 38,
    //   height: 80,
    //   width: 100,
    // },
    logo: {
        top: 60,
        marginLeft: 30,
        height: 40,
        width: 100,
    },
    logoView: {
        position: 'absolute',
        top: -80,

    },
    form: {
        backgroundColor: '#00A2C1',
        // backgroundColor: '#36ea9f',
        padding: 25,
        paddingTop: 60,
        borderRadius: 15,
    },
    radioContainer: {
        marginTop: -4,
        marginBottom: 20,
        marginLeft: 3,
        width: 250,
    },
    inputContainer: {
        borderBottomColor: '#FFFFFF',
        // backgroundColor: '#36ea9f',
        backgroundColor: '#00A2C1',
        borderBottomWidth: 1.8,
        width: 290,
        height: 38,
        marginBottom: 40,
        flexDirection: 'row',
        alignItems: 'center',
    },
    inputs: {
        width: 235,
        height: 45,
        color: 'white',
    },
    eyeIcon: {

    },
    inputIcon: {
        width: 30,
        height: 30,
        marginLeft: 1,
        justifyContent: 'center'
    },

    buttonContainer: {
        height: 45,
        justifyContent: 'center',
        alignItems: 'center',
        marginBottom: 10,
        width: 290,
        borderRadius: 30,
    },
    signupButton: {
        backgroundColor: "#ffffff",
    },
    signUpText: {
        fontSize: 20,
        color: '#00A2C1',
    },
    TextComponentStyle: {
        fontSize: 20,
        color: "#000",
        textAlign: 'center',
        marginBottom: 15
    },
    types: {
        // marginHorizontal: 5,
        borderWidth: 1,
        borderColor: '#bbb',
        padding: 4,
        borderRadius: 3,
        flexDirection: 'column',
        marginVertical: 10,

        // backgroundColor: '#fff'
    }
});