/*
FileName:NavigationRouter.js
Version:1.0.0
Purpose:Navgate to all classes from Here
Devloper:Mahesh Reddy
*/
import React, { Component } from 'react';
import { ActivityIndicator, Button, StatusBar, StyleSheet, Text, View, Image, TouchableOpacity } from 'react-native';
import AsyncStorage from '@react-native-community/async-storage';
import { widthPercentageToDP } from 'react-native-responsive-screen';
// import Icon from 'react-native-vector-icons/FontAwesome5';
import { createAppContainer,createSwitchNavigator} from 'react-navigation';
import { createStackNavigator } from 'react-navigation-stack';
import { createDrawerNavigator } from 'react-navigation-drawer';
import { createBottomTabNavigator } from 'react-navigation-tabs';
import { HomeIcon, PaymentIcon, ScannerIcon,NotificationIcon } from '../CommonComponents/Icons';
import UserNotification from '../UserComponents/UserNotification';
// import { createStackNavigator, createSwitchNavigator, createAppContainer, createDrawerNavigator } from 'react-navigation';
import Login from '../LaunchScreens/Login';
import RegisterUser from '../LaunchScreens/RegisterUser';
import Forgot from '../LaunchScreens/Forgot';
import Maintenance from '../Maintenance/Maintenance';

// import drawerContentComponents from './UserDrawerComponents';

import AdminDrawerComponents from '../Navigation/AdminDrawerComponents';
import UserDrawerComponents from '../Navigation/UserDrawerComponents';
import AdminReports from '../AdminComponets/AdminReports';
import AdminAgileSquad from '../AdminComponets/AdminAgileSquad';
import Settings from '../AdminComponets/Settings';
import SettingsModify from '../AdminComponets/SettingsModify';

import AdminManageProjects from '../AdminComponets/AdminManageProjects';
import AdminManageTask from '../AdminComponets/AdminManageTask';
import AdminManageEmployees from '../AdminComponets/AdminManageEmployees';
import AdminUserPreference from '../AdminComponets/AdminUserPreference';
import AdminCompletedProjects from '../AdminComponets/AdminCompletedProjects';
import AdminViewModules from '../AdminComponets/AdminViewModules';
import AdminManageEmployeesTasks from '../AdminComponets/AdminManageEmployeesTasks';
import Updates1 from '../AdminComponets/Updates1';
import AdminProjectInfo from '../AdminComponets/AdminProjectInfo';
import AdminPassword from '../AdminComponets/AdminPassword';
import AdminModules from '../AdminComponets/AdminModules';
import AdminRoadblockList from '../AdminComponets/AdminRoadblockList';
import AdminRoadblock from '../AdminComponets/AdminRoadblock';


import MyTask from '../UserComponents/UserMyTask';
import Updates from '../UserComponents/Updates';

import UserManageProjects from '../UserComponents/UserManageProjects';
import UserProfile from '../UserComponents/UserProfile';
import UserManageEmployees from '../UserComponents/UserManageEmployees';
import UserManageTask from '../UserComponents/UserManageTask';
import UserPreference from '../UserComponents/UserPreference';
import UserCompletedProjects from '../UserComponents/UserCompletedProjects';
import CalendarAgenda from '../UserComponents/Calendar/Calendar';
import UserProjectInfo from '../UserComponents/UserProjectInfo';
import UserModules from '../UserComponents/UserModules';
import UserManageEmployeesTasks from '../UserComponents/UserManageEmployeesTasks';
import UserManageProjects1 from '../UserComponents/UserManageProjects1';
import UserRoadblock from '../UserComponents/UserRoadblocks';
import AddBlocked from '../CommonComponents/AddBlocked';
import UserRoadblockList from '../UserComponents/UserRoadblockList';
import UserTaskStatus from '../UserComponents/UserTaskStatus';
import UserPassword from '../UserComponents/UserPassword';
import UserProjects from '../UserComponents/UserProjects';
import UserModifyProject from '../UserComponents/UserModifyProject';
import UserTaskStatus1 from '../UserComponents/UserTaskStatus1';
import UserBacklog from '../UserComponents/UserBacklog';
import AddEpic from '../CommonComponents/AddEpic';
import AddSprint from '../CommonComponents/AddSprint';
import UserArchive from '../UserComponents/UserArchive';
import Reports from '../UserComponents/Reports';
import ReportUser from '../UserComponents/ReportUser';
import ManageEpic from '../CommonComponents/ManageEpic';

import AddModule from '../CommonComponents/AddModule';
import AddMainTask from '../CommonComponents/AddMainTask';
import AddMainTask1 from '../CommonComponents/AddMainTask1';
import AddTask from '../CommonComponents/AddTask';
import AddStory from '../CommonComponents/AddStory';
import AddUserStory from '../CommonComponents/AddUserStory';
import EditUser from '../CommonComponents/EditUser';
import AddUser from '../CommonComponents/AddUser';
import ViewSubTasks from '../CommonComponents/ViewSubTasks';
import UpdateEmployee from '../CommonComponents/UpdateEmployee';
import ModuleAdd from '../CommonComponents/ModuleAdd';
import ReleaseOwner from '../CommonComponents/ReleaseOwner';
import ModifySubTask from '../CommonComponents/ModifySubTask';
import AddSubTaskModal from '../CommonComponents/AddSubTaskModal';
import RoadBlocks from '../CommonComponents/RoadBlock';
import TaskChat from '../CommonComponents/TaskChat';
import UserChat from '../CommonComponents/UserChat';
import ModifyMaintask from '../CommonComponents/ModifyMaintask';
import ModifyUserStory from '../CommonComponents/ModifyUserStory';
import ReassignUserStory from '../CommonComponents/ReassignUserStory';




import RoadBlockList from '../CommonComponents/RoadBlockList';
import CriticalRoadBlockList from '../CommonComponents/CriticalRoadBlockList';
import SolvedRoadBlockList from '../CommonComponents/SolvedRoadBlockList';
import OfflineCheck from '../Maintenance/OfflineCheck';
import EmployeeInfo from '../CommonComponents/EmployeeInfo';
import { API } from "../WebServices/RestClient";
// import { nullLiteral } from '@babel/types';
import ManageProjects from "../EmployeeInfo/ManageProjects";
import ProjectInfo from "../EmployeeInfo/ProjectInfo";
import RequestedProjects from "../EmployeeInfo/RequestedProjects";
import ApprovedProjects from "../EmployeeInfo/ApprovedProjects";
import EmployeeModules from "../EmployeeInfo/EmployeeModules";
import EmployeeManageTask from "../EmployeeInfo/EmployeeManageTask";
import EmployeePendingManageTask from "../EmployeeInfo/EmployeePendingManageTask";
import EmployeeCompletedManageTask from "../EmployeeInfo/EmployeeCompletedManageTask";
import RoadBlockInfo from '../EmployeeInfo/RoadBlockInfo';

import AddRoadblock from '../CommonComponents/AddRoadblock';
import ModifyRoadblock from '../CommonComponents/ModifyRoadblock';
import Comments from '../CommonComponents/Comments';
import ChangeStatus from '../CommonComponents/ChangeStatus';
import ChangeStatusTask from '../CommonComponents/ChangeStatusTask';
import TaskAdd from '../CommonComponents/TaskAdd';
import TaskModify from '../CommonComponents/TaskModify';
import ViewTask from '../CommonComponents/ViewTask';



const TabNavigation = createBottomTabNavigator({
	MyTask: {
		screen: MyTask,
		navigationOptions: {
			tabBarLabel: 'HOME',

			tabBarIcon: ({ tintColor }) => (
				<HomeIcon />
			)
		}
	},


  // MyTask: {
	// 	screen: MyTask,
	// 	navigationOptions: {
	// 		tabBarLabel: 'HOME',

	// 		tabBarIcon: ({ tintColor }) => (
	// 			<HomeIcon />
	// 		)
	// 	}
	// },
	// Consignment: {
	// 	screen: Consignment,
	// 	navigationOptions: {
	// 		tabBarLabel: 'Booking',
	// 		// tabBarVisible:false,
	// 		tabBarIcon: ({ tintColor }) => (
	// 			<PaymentIcon />
	// 		)
	// 	}
	// },
	// Scan: {
	// 	screen: Scan,
	// 	navigationOptions: {
	// 		tabBarLabel: 'Scan & Track',
	// 		tabBarIcon: ({ tintColor }) => (
	// 			<ScannerIcon />
	// 		)
	// 	}
	// },
	UserNotification: {
		screen: UserNotification,
		navigationOptions: {
			tabBarLabel: 'Notification',
			tabBarIcon: ({ tintColor }) => (
				<NotificationIcon />
			)
		}
	},

}, {
	tabBarOptions: {
		activeTintColor: 'black',
		inactiveTintColor: 'white',
		style: {
			backgroundColor: '#00A2C1',
			borderTopWidth: 0,
			shadowOffset: { width: 5, height: 3 },
			shadowColor: 'black',
			shadowOpacity: 0.5,
			elevation: 5
		}
	}
});






class NavigationRouter extends Component {

  constructor() {
    super();
    this._bootstrapAsync();
  }

  //Maintanace Page for Checking the Heathcheck
  Maintenance = () => {

    fetch(API + "healthCheck.php")
      .then((response) => response.json())
      .then((responseJson) => {

        if (responseJson.status === 'True') {
          console.warn("Hello");

          this._bootstrapAsync();
        }
        else {
          console.warn("Hello111111111111111");
          this.props.navigation.navigate('Maintenance');
        }
      })
      .catch((error) => {

        console.log(error);

      });
  };

  // Fetch the token from storage then navigate to our appropriate place
  _bootstrapAsync = async () => {

    const userToken = await AsyncStorage.getItem('userToken');

    const role = await AsyncStorage.getItem('emp_role');



    console.log(userToken);
    // This will switch to the App screen or Auth screen and this loading
    // screen will be unmounted and thrown away.
    if (userToken) {
      if (role == "Admin") {
        this.props.navigation.navigate('AdminAppStack');
      }
      else {
        this.props.navigation.navigate('UserAppStack');
      }
    }
    else {
      this.props.navigation.navigate('Auth');
    }
  };

  // Render any loading content that you like here
  render() {
    return (
      <View><OfflineCheck /></View>
      // <AppContainer/>

    );
  }
}

//Admin Navigation 
const AdminDrawer = createDrawerNavigator(
  {
    AdminReports: { screen: AdminReports },
    AdminAgileSquad: { screen: AdminAgileSquad },
    Settings:{screen:Settings},
    // AdminManageTask: { screen: AdminManageTask },
    // AdminManageEmployees: { screen: AdminManageEmployees },
    // AdminUserPreference: { screen: AdminUserPreference},
    // AdminCompletedProjects: { screen: AdminCompletedProjects },
    // Updates1: { screen: Updates1 },
    // AdminRoadblock: {screen:AdminRoadblock},
    // AdminRoadblockList:{screen:AdminRoadblockList},
    // RoadBlockList: { screen: RoadBlockList },
    // AdminPassword:{screen:AdminPassword},
    // AdminModules:{screen:AdminModules},
    //EmployeeInfo: { screen: EmployeeInfo },
    //EmployeeManageTask: { screen: EmployeeManageTask },
    // AddModule : {screen: AddModule},
    Logout: { screen: Login },
  },
  {
    drawerWidth: widthPercentageToDP('65%'),
    contentComponent: AdminDrawerComponents
  }

);
//User Navigation 
const UserDrawer = createDrawerNavigator(
  {

    MyTask: { screen: TabNavigation },
    UserManageProjects: { screen: UserManageProjects },
    UserManageProjects1: {screen: UserManageProjects1},
    UserRoadblock:{screen:UserRoadblock},
    UserRoadblockList:{screen:UserRoadblockList},
    Reports:{screen:Reports},
    ReportUser:{screen:ReportUser},
    UserTaskStatus:{screen: UserTaskStatus},
    UserArchive:{screen:UserArchive},
    UserModules:{screen:UserModules},
    UserPassword:{screen:UserPassword},
    UserProjects:{screen:UserProjects},
    UserTaskStatus1:{screen:UserTaskStatus1},
    UserBacklog:{screen:UserBacklog},

    // Profile: {screen: Profile},
    UserProfile: { screen: UserProfile },
    UserManageTask: { screen: UserManageTask },
    //EmployeeInfo: { screen: EmployeeInfo },
    UserManageEmployees: { screen: UserManageEmployees },
    UserPreference: { screen: UserPreference },
    UserCompletedProjects: { screen: UserCompletedProjects },
    CalendarAgenda: { screen: CalendarAgenda },
    RoadBlockList: { screen: RoadBlockList },
    //EmployeeManageTask: { screen: EmployeeManageTask },
    // AddModule : {screen: AddModule},
    Updates: { screen: Updates },
    Logout: { screen: Login },

  }, {
  drawerWidth: widthPercentageToDP('65%'),
  contentComponent: UserDrawerComponents
}


);

//Admin Navigation classes 
const adminAppStack = createStackNavigator({

  // ManageTask1: {
  //   screen: AdminDrawer,
  //   navigationOptions: {
  //     header: null,
  //   },
  // },
  AdminReports:{
    screen:AdminDrawer,
    navigationOptions:{
      header:null,
    },
  },
  AdminAgileSquad:{
    screen:AdminAgileSquad,
    navigationOptions:{
      header:null,
    },
  },
  Settings:{
    screen:Settings,
    navigationOptions:{
      header:null,
    },
  },
  SettingsModify:{
    screen:SettingsModify,
    navigationOptions:{
      header:null,
    },
  },

  UserManageTask: {
    screen: UserManageTask,
    navigationOptions: {
      header: null,
    },
  },

  AddModule: {
    screen: AddModule,
    navigationOptions: {
      header: null,
    },
  },
  AddMainTask: {
    screen: AddMainTask,
    navigationOptions: {
      header: null,
    },
  },
  AddTask: {
    screen: AddTask,
    navigationOptions: {
      header: null,
    },
  },
  AddUserStory: {
    screen: AddUserStory,
    navigationOptions: {
      header: null,
    },
  },
  AddStory:{
    screen:AddStory,
    navigationOptions:{
      header:null,
    },
  },
  
  ViewSubTasks: {
    screen: ViewSubTasks,
    navigationOptions: {
      header: null,
    },
  },
  AdminProjectInfo: {
    screen: AdminProjectInfo,
    navigationOptions: {
      header: null,
    },
  },
  Maintenance: {
    screen: Maintenance,
    navigationOptions: {
      header: null,
    },
  },
  ChangeStatus:{
    screen:ChangeStatus,
    navigationOptions:{
      header:null,
    },
  },
  ChangeStatusTask:{
    screen:ChangeStatusTask,
    navigationOptions:{
      header:null,
    },
  },
  TaskAdd:{
    screen:TaskAdd,
    navigationOptions:{
      header:null,
    },
  },
  TaskModify:{
    screen:TaskModify,
    navigationOptions:{
      header:null,
    },
  },
  ViewTask:{
    screen:ViewTask,
    navigationOptions:{
      header:null,
    },
  },

  ModuleAdd: {
    screen: ModuleAdd,
    navigationOptions: {
      header: null,
    },
  },
  ReleaseOwner: {
    screen: ReleaseOwner,
    navigationOptions: {
      header: null,
    },
  },
  AdminManageEmployeesTasks: {
    screen: AdminManageEmployeesTasks,
    navigationOptions: {
      header: null,
    },
  },
  AddUser: {
    screen: AddUser,
    navigationOptions: {
      header: null,
    },
  },
  UpdateEmployee: {
    screen: UpdateEmployee,
    navigationOptions: {
      header: null,
    },
  },
  ModifySubTask: {
    screen: ModifySubTask,
    navigationOptions: {
      header: null,
    },
  },
  AddSubTaskModal: {
    screen: AddSubTaskModal,
    navigationOptions: {
      header: null,
    },
  },
  EditUser: {
    screen: EditUser,
    navigationOptions: {
      header: null,
    },
  },
  ModifyMaintask:{
    screen:ModifyMaintask,
    navigationOptions:{
      header:null,
    }
  },
  RoadBlocks: {
    screen: RoadBlocks,
    navigationOptions: {
      header: null,
    },
  },
  AddBlocked:{
    screen:AddBlocked,
    navigationOptions:{
      header:null,
    },
  },

  RoadBlockList: {
    screen: RoadBlockList,
    navigationOptions: {
      header: null,
    },

  },
  UserChat: {
    screen: UserChat,
    navigationOptions: {
      header: null,
    },
  },
  AddRoadblock:{
    screen:AddRoadblock,
    navigationOptions:{
      header:null,
    },
  },
  ModifyRoadblock:{
    screen:ModifyRoadblock,
    navigationOptions:{
      header:null,
    },
  },

  CriticalRoadBlockList: {
    screen: CriticalRoadBlockList,
    navigationOptions: {
      header: null,
    },

  },
  SolvedRoadBlockList: {
    screen: SolvedRoadBlockList,
    navigationOptions: {
      header: null,
    },

  },
  TaskChat: {
    screen: TaskChat,
    navigationOptions: {
      header: null,
    },
  },
  EmployeeInfo: {
    screen: EmployeeInfo,
    navigationOptions: {
      header: null,
    }
  },
  // Projects Information of Employees Start
  ManageProjects: {
    screen: ManageProjects,
    navigationOptions: {
      header: null,
    }
  },
  RequestedProjects: {
    screen: RequestedProjects,
    navigationOptions: {
      header: null,
    }
  },
  ApprovedProjects: {
    screen: ApprovedProjects,
    navigationOptions: {
      header: null,
    },
  },
  ProjectInfo: {
    screen: ProjectInfo,
    navigationOptions: {
      header: null,
    },
  },
  EmployeeModules: {
    screen: EmployeeModules,
    navigationOptions: {
      header: null,
    },
  },
  EmployeeManageTask: {
    screen: EmployeeManageTask,
    navigationOptions: {
      header: null,
    },
  },
  EmployeePendingManageTask: {
    screen: EmployeePendingManageTask,
    navigationOptions: {
      header: null,
    },
  },
  EmployeeCompletedManageTask: {
    screen: EmployeeCompletedManageTask,
    navigationOptions: {
      header: null,
    },
  },
  RoadBlockInfo: {
    screen: RoadBlockInfo,
    navigationOptions: {
      header: null,
    },
  },
  //Projects Information of Employees End
});

//User Navigation classes 
const userAppStack = createStackNavigator({

  MyTask: {
    screen: UserDrawer,
    navigationOptions: {
      header: null,
    },
  },
  AddEpic:{
    screen:AddEpic,
    navigationOptions:{
      header:null,
    },
  },
  AddModule: {
    screen: AddModule,
    navigationOptions: {
      header: null,
    },
  },
  AddMainTask: {
    screen: AddMainTask,
    navigationOptions: {
      header: null,
    },
  },
  AddMainTask1: {
    screen: AddMainTask1,
    navigationOptions: {
      header: null,
    },
  },
  AddTask: {
    screen: AddTask,
    navigationOptions: {
      header: null,
    },
  },
  Comments: {
    screen: Comments,
    navigationOptions: {
      header: null,
    },
  },
  AddSprint: {
    screen: AddSprint,
    navigationOptions: {
      header: null,
    },
  },
  AddStory:{
    screen:AddStory,
    navigationOptions:{
      header:null,
    },
  },
  AddUserStory: {
    screen: AddUserStory,
    navigationOptions: {
      header: null,
    },
  },
  ModifyUserStory:{
    screen:ModifyUserStory,
    navigationOptions:{
      header:null,
    },
  },
  ReassignUserStory:{
    screen:ReassignUserStory,
    navigationOptions:{
      header:null,
    },
  },

  UserModifyProject:{
    screen:UserModifyProject,
    navigationOptions:{
      header:null,
    },
  },
  ViewSubTasks: {
    screen: ViewSubTasks,
    navigationOptions: {
      header: null,
    },
  },
  UserModules:{
    screen:UserModules,
    navigationOptions:{
      header: null,
    },
  },
  UserRoadblock:{
    screen:UserRoadblock,
    navigationOptions:{
      header:null,
    },
  },
  UserRoadblockList:{
    screen:UserRoadblockList,
    navigationOptions:{
      header:null,
    },
  },
  EditUser: {
    screen: EditUser,
    navigationOptions: {
      header: null,
    },
  },
  AdminProjectInfo: {
    screen: AdminProjectInfo,
    navigationOptions: {
      header: null,
    },
  },
  UserProjectInfo: {
    screen: UserProjectInfo,
    navigationOptions: {
      header: null,
    },
  },
  ModuleAdd: {
    screen: ModuleAdd,
    navigationOptions: {
      header: null,
    },
  },
  UserTaskStatus1:{
    screen:UserTaskStatus1,
    navigationOptions:{
      header:null,
    },
  },
  UserBacklog:{
    screen:UserBacklog,
    navigationOptions:{
      header:null,
    },
  },
  
  UserNotification:{
    screen:UserNotification,
    navigationOptions:{
      header:null,
    },
  },
  // Maintenance: {
  //   screen: Maintenance,
  //   navigationOptions: {
  //     header: null,
  //   },
  // },
  ModifyMaintask:{
    screen:ModifyMaintask,
    navigationOptions:{
      header:null,
    }
  },

  UserArchive:{
    screen:UserArchive,
    navigationOptions:{
      header:null,
    },
  },
  UserPassword:{
    screen:UserPassword,
    navigationOptions:{
      header: null,
    },
  },
  UserProjects:{
    screen:UserProjects,
    navigationOptions:{
      header: null,
    },
  },
  UserChat: {
    screen: UserChat,
    navigationOptions: {
      header: null,
    },
  },
  ReleaseOwner: {
    screen: ReleaseOwner,
    navigationOptions: {
      header: null,
    },
  },
  AddUser: {
    screen: AddUser,
    navigationOptions: {
      header: null,
    },
  },
  ModifySubTask: {
    screen: ModifySubTask,
    navigationOptions: {
      header: null,
    },
  },
  AddSubTaskModal: {
    screen: AddSubTaskModal,
    navigationOptions: {
      header: null,
    },
  },

  EditUser: {
    screen: EditUser,
    navigationOptions: {
      header: null,
    },
  },
  UpdateEmployee: {
    screen: UpdateEmployee,
    navigationOptions: {
      header: null,
    },
  },
  AddBlocked:{
    screen:AddBlocked,
    navigationOptions:{
      header:null,
    },
  },
  RoadBlocks: {
    screen: RoadBlocks,
    navigationOptions: {
      header: null,
    },
  },
  TaskChat: {
    screen: TaskChat,
    navigationOptions: {
      header: null,
    },
  },
  UserManageEmployeesTasks: {
    screen: UserManageEmployeesTasks,
    navigationOptions: {
      header: null,
    },
  },
  AddRoadblock:{
    screen:AddRoadblock,
    navigationOptions:{
      header:null,
    },
  },
  ChangeStatus:{
    screen:ChangeStatus,
    navigationOptions:{
      header:null,
    },
  },
  ChangeStatusTask:{
    screen:ChangeStatusTask,
    navigationOptions:{
      header:null,
    },
  },
  TaskAdd:{
    screen:TaskAdd,
    navigationOptions:{
      header:null,
    },
  },
  TaskModify:{
    screen:TaskModify,
    navigationOptions:{
      header:null,
    },
  },
  ViewTask:{
    screen:ViewTask,
    navigationOptions:{
      header:null,
    },
  },
  ModifyRoadblock:{
    screen:ModifyRoadblock,
    navigationOptions:{
      header:null,
    },
  },
  RoadBlockList: {
    screen: RoadBlockList,
    navigationOptions: {
      header: null,
    },

  },
  CriticalRoadBlockList: {
    screen: CriticalRoadBlockList,
    navigationOptions: {
      header: null,
    },

  },
  SolvedRoadBlockList: {
    screen: SolvedRoadBlockList,
    navigationOptions: {
      header: null,
    },

  },
  EmployeeInfo: {
    screen: EmployeeInfo,
    navigationOptions: {
      header: null,
    }
  },
  // Projects Information of Employees Start
  ManageProjects: {
    screen: ManageProjects,
    navigationOptions: {
      header: null,
    },
  },
  ManageEpic:{
    screen:ManageEpic,
    navigationOptions:{
      header:null,
    },
  },
  UserManageProjects1:{
    screen: UserManageProjects1,
    navigationOptions:{
      header:null,
    },
  },
  RequestedProjects: {
    screen: RequestedProjects,
    navigationOptions: {
      header: null,
    },
  },
  ApprovedProjects: {
    screen: ApprovedProjects,
    navigationOptions: {
      header: null,
    },
  },
  ProjectInfo: {
    screen: ProjectInfo,
    navigationOptions: {
      header: null,
    },
  },
  EmployeeModules: {
    screen: EmployeeModules,
    navigationOptions: {
      header: null,
    },
  },
  EmployeeManageTask: {
    screen: EmployeeManageTask,
    navigationOptions: {
      header: null,
    },
  },
  EmployeePendingManageTask: {
    screen: EmployeePendingManageTask,
    navigationOptions: {
      header: null,
    },
  },
  EmployeeCompletedManageTask: {
    screen: EmployeeCompletedManageTask,
    navigationOptions: {
      header: null,
    },
  },
  RoadBlockInfo: {
    screen: RoadBlockInfo,
    navigationOptions: {
      header: null,
    },
  },
  //Projects Information of Employees End

});

//Authentication to Login Screen
const AuthStack = createStackNavigator({
  Login: {
    screen: Login,
    navigationOptions: {
      header: null,
    },
  },
  RegisterUser: {
    screen: RegisterUser,
    navigationOptions: {
      header: null,
    },
  },
  Forgot:{
    screen:Forgot,
    navigationOptions:{
      header:null,
    },
  },
  // Maintenance: {
  //   screen: Maintenance,
  //   navigationOptions: {
  //     header: null,
  //   },
  // },
});
//Navigation by Autherization and Authentication from here
export default createAppContainer(createSwitchNavigator(
  {
    AuthLoading: NavigationRouter,
    AdminAppStack: adminAppStack,
    UserAppStack: userAppStack,
    Auth: AuthStack,

  },
  {
    initialRouteName: 'AuthLoading',
  }
));

const styles = StyleSheet.create({
  container: {
    flex: 1,
    alignItems: 'center',
    justifyContent: 'center',
  },
  home: {
    paddingLeft: 20,
  }
});