/*
FileName:UserDrawerComponents.js
Version:1.0.0
Purpose:Navgate to all User classes from Here and also logout
Devloper:Rishitha,Naveen,Mahesh
*/
import React, { Component } from 'react';
import { NavigationActions } from 'react-navigation';
import { DrawerActions } from '@react-navigation/native';
import { Text, View, StyleSheet, ImageBackground, Dimensions, Image, TouchableOpacity, Alert } from 'react-native'
import { Title, Button, Container, Content, Header, Right, Left, Body, Tab, Tabs, TabHeading, Footer, FooterTab } from 'native-base';
import AsyncStorage from '@react-native-community/async-storage';
import Icon from 'react-native-vector-icons/FontAwesome';
import { ScrollView } from 'react-native-gesture-handler';

// import { white } from 'ansi-colors';
import { widthPercentageToDP as wp, heightPercentageToDP as hp } from 'react-native-responsive-screen';
// import AutoHeightImage from 'react-native-auto-height-image';
import UserDatabase from "../OfflineDB/UserDatabase";
const db = new UserDatabase();

import { MYTASK, MANAGEPROJECTS, MODULES, ARCHIVE, PENDINGSUBTASKS, USERROADBLOCKS, ROADBLOCKS, PROFILE, MANAGEEMPLOYEES, USERPREFERENCE, COMPLETEDPROJECTS, UPDATES, LOGOUT, ROADBLOCK, REPORTS } from '../CommonComponents/Header';

export default class drawerContentComponents extends Component {

    constructor(props) {
        super(props);
        this.state = {
            fullName: '',
            ptime: '0',
        }
    }

    componentDidMount() {

        AsyncStorage.getItem("fullName", (err, res) => {
            this.setState({ fullName: res });


        });
        AsyncStorage.getItem("emp_role", (err, res) => {
            this.setState({ emp_role: res });

            console.warn(this.state.emp_role)
        });

    }

    //this methos is used to ask the user about confirm about 
    logOutOption() {
        Alert.alert(
            'Alert',
            'Do you want to Logout',
            [
                {
                    text: 'Cancel',
                    onPress: () => console.log('Cancel Pressed'),
                    style: 'cancel',
                },
                { text: 'OK', onPress: () => this.logOut() },
            ],
            { cancelable: false },
        );
    }

    //this method is used for logout the application and also clear the asyncstorage .
    logOut() {
        AsyncStorage.clear();
        db.deleteUser();
        console.warn("result");
        this.props.navigation.navigate('Auth');
    }

    navigateToScreen = (route) => (
        () => {
            const navigateAction = NavigationActions.navigate({
                routeName: route
            });
            this.props.navigation.dispatch(navigateAction);
            // this.props.navigation.dispatch(DrawerActions.closeDrawer());
        })



    preferedDays = () => {
        // alert(this.state.nodays);
        const days = this.state.ptime;
        AsyncStorage.setItem('nodays', days);
        AsyncStorage.setItem("levelno", ''),
            this.props.navigation.navigate("UserManageTask");

    }

    render() {
        let button;
        if (this.state.emp_role === "Contributor") {

            // button = null;
            // button = <TouchableOpacity onPress={this.navigateToScreen('UserTaskStatus1')}>
            button = <TouchableOpacity onPress={this.navigateToScreen('UserBacklog')}>
                <View style={styles.screenStyle}>
                    {/* <View style={{ width: wp('8%') }}> */}
                    <Image style={{ width: wp('6%'), height: hp('3%') }} source={require('../Images/backlogs.png')} />
                    {/* <Icon size={25} name="lightbulb-o" style={{ color: '#000000', width: wp('8%') }} /> */}

                    {/* </View> */}
                    {/* <Icon size={25} name="lightbulb-o" style={{ color: '#000000', width: wp('8%') }} /> */}
                    <Text style={{ color: '#000000', marginLeft: 20 }}>{PENDINGSUBTASKS}</Text>
                </View>
            </TouchableOpacity>
        }
        else {

            // button = <TouchableOpacity onPress={this.navigateToScreen('UserTaskStatus1')}>
            button = <TouchableOpacity onPress={this.navigateToScreen('UserBacklog')}>
                <View style={styles.screenStyle}>
                    {/* <View style={{ width: wp('8%') }}> */}
                    <Image style={{ width: wp('6%'), height: hp('3%') }} source={require('../Images/activesprint.png')} />
                    {/* <Icon size={25} name="lightbulb-o" style={{ color: '#000000', width: wp('8%') }} /> */}

                    {/* </View> */}
                    {/* <Icon size={25} name="lightbulb-o" style={{ color: '#000000', width: wp('8%') }} /> */}
                    <Text style={{ color: '#000000', marginLeft: 20 }}>{PENDINGSUBTASKS}</Text>
                </View>
            </TouchableOpacity>
        }
        let button1;
        if (this.state.emp_role === "Contributor") {

            button1 = null;
        }
        else {

            button1 = <TouchableOpacity onPress={this.navigateToScreen('UserRoadblock')}>
                <View style={styles.screenStyle}>
                    {/* <View style={{ width: wp('8%') }}> */}
                    <Image style={{ width: wp('6%'), height: hp('3%') }} source={require('../Images/road.png')} />
                    {/* </View> */}
                    {/* <Icon size={25} name="lightbulb-o" style={{ color: '#000000', width: wp('8%') }} /> */}
                    <Text style={{ color: '#000000', marginLeft: 20 }}>{USERROADBLOCKS}</Text>
                </View>
            </TouchableOpacity>
        }


        let button2;
        if (this.state.emp_role === "Contributor") {

            button2 = <TouchableOpacity onPress={this.navigateToScreen('UserManageProjects1')}>
                <View style={styles.screenStyle}>

                    <Image style={{ width: wp('6%'), height: hp('3%') }} source={require('../Images/epics.png')} />
                    <Text style={{ color: '#000000', marginLeft: 20 }}>{MANAGEPROJECTS}</Text>
                </View>
            </TouchableOpacity>;
        }
        else {

            button2 = <TouchableOpacity onPress={this.navigateToScreen('UserManageProjects1')}>
                <View style={styles.screenStyle}>
                    <Image style={{ width: wp('6%'), height: hp('3%') }} source={require('../Images/epics.png')} />
                    <Text style={{ color: '#000000', marginLeft: 20 }}>{MANAGEPROJECTS}</Text>
                </View>
            </TouchableOpacity>
        }

        return (
            <ScrollView style={styles.container}>
                <View style={styles.headerContainer}>
                    <View style={{ alignItems: 'center', marginTop: 30, }}>
                    </View>
                    <View style={{ alignItems: 'center', marginTop: 10, }}>
                        <Image style={{ width: wp('60%'), height: hp('12%') }} source={require('../Images/agile2.png')} />

                        {/* <Image style={{ width: wp('37%'), height: hp('18%') }} source={require('../Images/drawer.png')} /> */}
                        <Text style={{ color: '#000000', paddingLeft: 10 }}>Welcome,{this.state.fullName}</Text>
                    </View>
                </View>

                <View style={styles.screenContainer}>

                    <TouchableOpacity onPress={this.navigateToScreen('MyTask')}>
                        <View style={styles.screenStyle}>
                            <Image style={{ width: wp('6%'), height: hp('3%') }} source={require('../Images/activesprint.png')} />
                            <Text style={{ color: '#000000', marginLeft: 20 }}>{MYTASK}</Text>
                        </View>
                    </TouchableOpacity>
                    {button2}
                    {/* <TouchableOpacity onPress={this.navigateToScreen('UserModules')}>
                        <View style={styles.screenStyle}>
                            <View style={{ width: wp('8%') }}>
                                <Image style={{ width: wp('6%'), height: hp('3%') }} source={require('../Images/module.jpeg')} />
                            </View>
                            <Text style={{ color: '#000000', marginLeft: 20 }}>{MODULES}</Text>
                        </View>
                    </TouchableOpacity> */}
                    <TouchableOpacity onPress={this.navigateToScreen('UserArchive')}>
                        <View style={styles.screenStyle}>
                            {/* <View style={{ width: wp('8%') }}> */}
                            {/* <Icon size={25} name="home" style={{ color: '#000000', width: wp('8%') }} /> */}
                            <Image style={{ width: wp('6%'), height: hp('3%') }} source={require('../Images/archive.png')} />
                            {/* </View> */}
                            {/* <Icon size={25} name="home" style={{ color: '#000000', width: wp('8%') }} /> */}
                            <Text style={{ color: '#000000', marginLeft: 20 }}>{ARCHIVE}</Text>
                        </View>
                    </TouchableOpacity>
                    {/* <TouchableOpacity onPress={this.navigateToScreen('UserManageProjects')}>
                        <View style={styles.screenStyle}>
                            <Icon size={25} name="home" style={{ color: '#000000', width: wp('8%') }} />
                            <Text style={{ color: '#000000', marginLeft: 20 }}>Manage Projects</Text>
                        </View>
                    </TouchableOpacity> */}

                    {/* <TouchableOpacity onPress={this.preferedDays}>
                        <View style={styles.screenStyle}>
                            <Icon size={25} name="id-badge" style={{ color: '#000000', width: wp('8%') }} />
                            <Text style={{ color: '#000000', marginLeft: 20 }}>{MAINTASKS}</Text>
                        </View>
                    </TouchableOpacity> */}
                    {button}
                    {button1}

                    {/* <TouchableOpacity onPress={this.navigateToScreen('UserRoadblockList')}>
                        <View style={styles.screenStyle}>
                            <Image style={{ width: wp('6%'), height: hp('3%') }} source={require('../Images/road.png')} />
                            <Text style={{ color: '#000000', marginLeft: 20 }}>{ROADBLOCKS}</Text>
                        </View>
                    </TouchableOpacity> */}


                    {/* <TouchableOpacity onPress={this.navigateToScreen('Reports')}>
                        <View style={styles.screenStyle}>
                            <Image style={{ width: wp('6%'), height: hp('3%') }} source={require('../Images/reports.png')} />
                            <Text style={{ color: '#000000', marginLeft: 20 }}>Reports</Text>
                        </View>
                    </TouchableOpacity> */}
                    <TouchableOpacity onPress={this.navigateToScreen('ReportUser')}>
                        <View style={styles.screenStyle}>
                            <Image style={{ width: wp('6%'), height: hp('3%') }} source={require('../Images/reports.png')} />
                            <Text style={{ color: '#000000', marginLeft: 20 }}>Reports</Text>
                        </View>
                    </TouchableOpacity>



                    {/* <TouchableOpacity onPress={this.navigateToScreen('RoadBlockList')}>
                        <View style={styles.screenStyle}>
                            <Icon size={25} name="bitbucket" style={{ color: '#000000', width: wp('8%') }} />
                            <Text style={{ color: '#000000', marginLeft: 20 }}>RoadBlocks</Text>
                        </View>
                    </TouchableOpacity> */}
                    <TouchableOpacity onPress={this.navigateToScreen('CalendarAgenda')}>
                        <View style={styles.screenStyle}>
                            <Image style={{ width: wp('6%'), height: hp('3%') }} source={require('../Images/completed.png')} />

                            <Text style={{ color: '#000000', marginLeft: 20 }}>Calendar</Text>
                        </View>
                    </TouchableOpacity>
                    <TouchableOpacity onPress={this.navigateToScreen('UserProfile')}>
                        <View style={styles.screenStyle}>
                            <Image style={{ width: wp('6%'), height: hp('3%') }} source={require('../Images/sideprofile.png')} />

                            <Text style={{ color: '#000000', marginLeft: 20 }}>{PROFILE}</Text>
                        </View>
                    </TouchableOpacity>

                    <TouchableOpacity onPress={this.navigateToScreen('UserManageEmployees')}>
                        <View style={styles.screenStyle}>
                            <Image style={{ width: wp('6%'), height: hp('3%') }} source={require('../Images/teams.png')} />
                            <Text style={{ color: '#000000', marginLeft: 20 }}>{MANAGEEMPLOYEES}</Text>
                        </View>
                    </TouchableOpacity>

                    {/* <TouchableOpacity onPress={this.navigateToScreen('UserPreference')}>
                        <View style={styles.screenStyle}>
                            <Icon size={25} name="user" style={{ color: '#000000', width: wp('8%') }} />
                            <Text style={{ color: '#000000', marginLeft: 20 }}>{USERPREFERENCE}</Text>
                        </View>
                    </TouchableOpacity> */}
                    <TouchableOpacity onPress={this.navigateToScreen('UserCompletedProjects')}>
                        <View style={styles.screenStyle}>
                            <Image style={{ width: wp('6%'), height: hp('3%') }} source={require('../Images/completed.png')} />

                            <Text style={{ color: '#000000', marginLeft: 20 }}>{COMPLETEDPROJECTS}</Text>
                        </View>
                    </TouchableOpacity>

                    {/* <TouchableOpacity onPress={this.navigateToScreen('Updates')}>
                        <View style={styles.screenStyle}>
                            <Icon size={25} name="history" style={{ color: '#000000', width: wp('8%') }} />
                            <Text style={{ color: '#000000', marginLeft: 20 }}>{UPDATES}</Text>
                        </View>
                    </TouchableOpacity> */}
                    <TouchableOpacity onPress={this.logOutOption.bind(this)}>
                        <View style={styles.screenStyle}>
                            <Image style={{ width: wp('6%'), height: hp('3%') }} source={require('../Images/logout.png')} />
                            <Text style={{ color: '#00000', marginLeft: 20 }}>{LOGOUT}</Text>
                        </View>
                    </TouchableOpacity>



                </View>
            </ScrollView>

        )
    }
}

const styles = StyleSheet.create({
    container: {

        backgroundColor: '#fff',
        height: Dimensions.get('window').height,


    },
    headerContainer: {
        ///  height: 150,
        height: hp('21%')
    },
    headerText: {
        color: '#fff8f8',
    },
    screenContainer: {
        paddingTop: 20,

    },
    screenStyle: {
        //   height: 30,
        marginTop: 2,
        flexDirection: 'row',
        alignItems: 'center',
        borderWidth: 1,
        borderColor: 'grey',
        padding: 10,
        height: hp('7%'),
        borderLeftWidth: 0,
        borderRightWidth: 0,
        borderBottomWidth: 0,



    },
    screenTextStyle: {
        fontSize: 23,
        marginLeft: 40

    },

});