/*
FileName:ReportUser.js
Version:1.0.0
Purpose:Reports List 
Devloper:Mahesh
*/
import React, { Component } from 'react';
import { Platform, StyleSheet, Image, Text, View, Dimensions, TouchableOpacity, FlatList, LayoutAnimation, UIManager, TextInput, Alert, ToastAndroid } from 'react-native';
import { Icon, Title, Button, Container, Content, Header, Right, Left, Body, Tab, Tabs, TabHeading, Footer, Item, Input, FooterTab } from 'native-base';
import { widthPercentageToDP as wp, heightPercentageToDP as hp } from 'react-native-responsive-screen';
// import Icon from 'react-native-vector-icons/FontAwesome';
import { Collapse, CollapseHeader, CollapseBody } from "accordion-collapse-react-native";
import UserBacklogPending from '../UserComponents/UserBacklogPending';
import UserBacklogActive from '../UserComponents/UserBacklogActive';
import ReportUserSprintVelocity from './ReportUserSprintVelocity';
import ReportUserIndiVelocity from './ReportUserIndiVelocity';
import ReportUserIndiWorkload from './ReportUserIndiWorkload';
import ReportUserEpicVelocity from './ReportUserEpicVelocity';
// import DropDownPicker from 'react-native-dropdown-picker';
import ModalSelector from 'react-native-modal-selector';
import Modal from "react-native-simple-modal";
import jwt_decode from "jwt-decode";
import AsyncStorage from '@react-native-community/async-storage';
import { API } from "../WebServices/RestClient";
import NetInfo from '@react-native-community/netinfo';
import Snackbar from 'react-native-snackbar';
import Toast from 'react-native-whc-toast';
import log from '../LogFile/Log';
import { NavigationEvents } from 'react-navigation';
import Moment from 'moment';

import {
    BallIndicator,
    BarIndicator,
    DotIndicator,
    MaterialIndicator,
    PacmanIndicator,
    PulseIndicator,
    SkypeIndicator,
    UIActivityIndicator
} from 'react-native-indicators';
import { SUBTASK, TITLE, DESCRIPTION, ADDMAINTASK, TARGETTIME, TASKSTATUS, ASSIGNEDON, STATUS, ASSIGNED_BY, UPDATEDON, TIMELEFT, MODIFY, UPDATESTATUS, TARGET_DATE, ASSIGNED_TO } from '../CommonComponents/Header';

export default class ReportUser extends Component {
    static navigationOptions = () => {
        return {
            tabBarOnPress({ navigation, defaultHandler }) {
                navigation.state.params.onTabFocus();
                defaultHandler();
                this.onRefresh();
            }
        };
    }

    constructor(props) {
        super(props);
        props.navigation.setParams({
            onTabFocus: this.handleTabFocus
        });
        this.state = {
            isLoading: true,
            dataSource: [],
            isFetching: false,
            open: false,
            
            getInvolved: [],
            unassignedTasks: [],
            currentsprint: [],
            manageTasks: [],
            resource: [],
            data2:[],
            
            itemPressedDisabled: false,
        };
       

        AsyncStorage.getItem("cropcode", (err, res) => {
            this.setState({ squadName: res });
           
        });
        this.arrayholder = [];

    }
    handleTabFocus = () => {
        this.onRefresh();
    };


    componentDidMount() {
        AsyncStorage.getItem("cropcode", (err, res) => {
            this.setState({ cropcode: res });
            console.warn(this.state.cropcode);
        });
      
       
        this.GetStatus();
      

        AsyncStorage.getItem("userToken", (err, res) => {
            this.setState({ empId: res });

            // console.warn(this.state.empId);
        });

    }

   

   
  
    //get project list dropdown data
    GetStatus() {
        log("Info", "UserProfile:GetStatus() method is used to get status of employee");
        AsyncStorage.getItem("userToken", (err, res) => {
            const empId = res;
            NetInfo.fetch().then(state => {
                if (state.type == "none" || state.type == 'unknown' || state.type == 'undefined') {
                    // console.log(state.type);
                    Snackbar.show({
                        title: 'No Internet Connection',
                        backgroundColor: 'red',
                        duration: Snackbar.LENGTH_LONG,
                    });
                    this.getAgileProjects()//For Getting Project List in Offline
                } else {

                    fetch(API + 'squads.php', {
                        method: 'POST',
                        headers: {
                            Accept: 'application/json',
                            'Content-Type': 'application/json',
                        },
                        body: JSON.stringify({

                            empId: empId,
                            action: 'get_squads',


                        })
                    })
                        .then((response) => response.json())
                        .then((responseJson) => {
                            console.warn(responseJson)
                            // alert(JSON.stringify(responseJson))
                            if (responseJson.status == 'True') {
                                // this.addAgileProjects(responseJson.data) //Project list store in offline
                                // this.setState({
                                //     isLoading: false,
                                //     dataSource: [...responseJson.data],
                                // }, function () {
                                //     // In this block you can do something with new state.
                                // });


                                var dataSource = [];
                                responseJson.data.map((epics) => {
                                    return (
                                        dataSource.push({
                                            'key': epics.value, 'label': epics.value
                                        })
                                    );
                                })

                                this.setState({
                                    dataSource: dataSource
                                });

                                // const data2 = [];

                                // responseJson.data.map(x => {
                                //     data2.push({ label: x.value, value: x.value })
                                // })
                                // this.setState({
                                //     data2: data2,
                                // })
                                // console.warn("Hello" + JSON.stringify(data2))

                                // this.setState({
                                //     data2: responseJson.data
                                // });
                                // console.warn(this.state.data2);
                            } else {
                                this.setState({
                                    dataSource: dataSource
                                });
                                log("Warn", "status of employee is not available");
                            }
                        })
                        .catch((error) => {
                            console.error(error);
                            log("Error", "error in  getting status of employee");
                        });
                }
            });
        });

    }

    // Update Status of Employee
    UpdateStatus(squadName) {
        // const { squadName } = this.state;
        log("Info", "UserProfile:UpdateStatus(status) method is used to update status of employee");
        console.warn("project" + JSON.stringify(squadName));

        AsyncStorage.getItem("userToken", (err, res) => {
            const empId = res;
            console.log(res);

            AsyncStorage.getItem("projectId", (err, res) => {
                const projectId = res;



                // console.log(cropcode);
                NetInfo.fetch().then(state => {
                    if (state.type == "none" || state.type == 'unknown' || state.type == 'undefined') {
                        console.log(state.type);
                        Snackbar.show({
                            title: 'No Internet Connection',
                            backgroundColor: 'red',
                            duration: Snackbar.LENGTH_LONG,
                        });
                        //for offline project switching start
                        this.setState({
                            squadName: squadName
                        });
                        AsyncStorage.setItem('cropcode', squadName);
                        this.getArchiveList()
                        //for offline project switching end
                    } else {

                        fetch(API + 'squad_login.php', {
                            method: 'POST',
                            headers: {
                                Accept: 'application/json',
                                'Content-Type': 'application/json',
                            },
                            body: JSON.stringify({
                                username: empId,
                                corp: squadName,
                                projectId: projectId
                            })
                        })
                            .then((response) => response.json())
                            .then((responseJson) => {
                                console.warn(JSON.stringify(responseJson))

                                if (responseJson.status == 'TRUE') {
                                    AsyncStorage.setItem('auth', responseJson.jwt) //store the token information  with exp
                                    const tokenDetails = jwt_decode(responseJson.jwt);
                                    console.log(tokenDetails.data)
                                    AsyncStorage.setItem('roleCount', tokenDetails.data.roleCount)
                                    // dispatch(setCurrentUser(tokenDetails.data)); //store the user information
                                    AsyncStorage.setItem('status', tokenDetails.data.empStatus)


                                    AsyncStorage.setItem('userToken', tokenDetails.data.empId);
                                    AsyncStorage.setItem('userName', tokenDetails.data.userName);
                                    AsyncStorage.setItem('emp_role', tokenDetails.data.role);
                                    AsyncStorage.setItem('cropcode', tokenDetails.data.corp);
                                    AsyncStorage.setItem('projectId', tokenDetails.data.projectId);
                                    // this.props.navigation.navigate('UserProfile');
                                    // console.warn("HI" + empstatus)
                                    this.setState({

                                        squadName: tokenDetails.data.corp,

                                    });
                                    //  alert("Project Changed Successfully")
                                    this.getModules();

                                } else {
                                    //    alert("user already exist");
                                    log("Warn", "status of employee is not able to update");
                                }

                            })
                            .catch((error) => {
                                console.warn(error);
                                log("Error", "error in updating status of employee");
                            });
                    }
                });
            });
        });

    }




   


    onRefresh() {
      
        this.setState({

        })
       
        this.GetStatus();
       

    }
   
   

    //list seperator
    FlatListItemSeparator = () => {
        return (
            <View
                style={{
                    //  height: .5,
                    width: "100%",
                    backgroundColor: "#000",
                }}
            />
        );
    }
    //List data for Empty
    _listEmptyComponent = () => {
        return (
            <View style={{ width: '90%', height: '80%' }}>
                <Text></Text>
            </View>
        )
    }




    render() {
        // if (this.state.isLoading) {
        //     return (
        //         <View style={{ flex: 1, alignItems: 'center', justifyContent: 'center' }}>
        //             <DotIndicator color='#00A2C1' />
        //         </View>
        //     );

        // }



        // const manageTasks = backlogs;
        return (
            <Container style={{ height: Dimensions.get('window').height }}>
                <NavigationEvents
                    onDidFocus={() => this.onRefresh()}
                />

                <Header
                    androidStatusBarColor="#00A2C1"
                    style={{
                        backgroundColor: '#00A2C1',
                        height: 60,
                        width: Dimensions.get('window').width,
                        borderBottomColor: '#ffffff',
                        justifyContent: 'space-between',
                    }}>
                    <View style={{ marginTop: 20 }}>
                        <Icon name="md-menu" size={25} style={{ color: 'white', }} onPress={() =>
                            this.props.navigation.toggleDrawer()} />
                    </View>


                    <View style={{ width: 300, borderRadius: 20, height: 45, marginTop: 5, flexDirection: 'row' }}>

                        <ModalSelector
                            style={{ width: 260, backgroundColor: 'transparent', borderColor: 'transparent', marginLeft: 60 }}
                            data={this.state.dataSource}
                            initValue={this.state.squadName}
                            optionContainerStyle={{ backgroundColor: 'white' }}
                            onChange={(itemValue) => { this.UpdateStatus(itemValue.label) }} >
                            <View style={{ width: 300, borderRadius: 20, backgroundColor: '#00A2C1', height: 45, flexDirection: 'row' }}>
                                <Text style={{ marginTop: 15, color: 'white', width: 80 }}>PROJECT : </Text>

                                <Text style={{ marginTop: 15, color: 'white', width: 120, }}>{this.state.squadName}</Text>

                                <Icon name="md-chevron-down-outline" size={25} style={{ color: 'white', marginTop: 10, }}
                                />
                            </View>

                        </ModalSelector>
                    </View>

                </Header>


                <Tabs tabBarUnderlineStyle={{ borderBottomWidth: 0 }}>
                    <Tab options={{ unmountOnBlur: true }} heading={<TabHeading style={{ backgroundColor: '#00A2C1' }}><Text style={{ color: '#fff' }}>Sprint Velocity</Text></TabHeading>}>
                        <ReportUserSprintVelocity navigation={this.props.navigation} />

                    </Tab>
                    <Tab options={{ unmountOnBlur: true }} heading={<TabHeading style={{ backgroundColor: '#00A2C1' }}><Text style={{ color: '#fff' }}>Individual Velocity</Text></TabHeading>}>
                        <ReportUserIndiVelocity navigation={this.props.navigation} />

                    </Tab>

                    <Tab options={{ unmountOnBlur: true }} heading={<TabHeading style={{ backgroundColor: '#00A2C1' }}><Text style={{ color: '#fff' }}>Epic Velocity</Text></TabHeading>}>
                        <ReportUserEpicVelocity navigation={this.props.navigation} />

                    </Tab>
                    <Tab options={{ unmountOnBlur: true }} heading={<TabHeading style={{ backgroundColor: '#00A2C1' }}><Text style={{ color: '#fff' }}>Individual Workload</Text></TabHeading>}>
                        <ReportUserIndiWorkload navigation={this.props.navigation} />

                    </Tab>
                    




                </Tabs>





            </Container>
        );
    }
}
