import React, { Component } from 'react';
import {
  Platform, StyleSheet, TextPropTypes, Picker, Text, View, Image, StatusBar, Dimensions, TextInput, Alert,
  KeyboardAvoidingView,
  TouchableWithoutFeedback,
  Keyboard
} from 'react-native';
// import { Chart, VerticalAxis, HorizontalAxis, Line } from 'react-native-responsive-linechart'
import { Icon, Title, Container, Content, Header, Right, Left, Body } from 'native-base';
import { widthPercentageToDP as wp, heightPercentageToDP as hp } from 'react-native-responsive-screen';
import { TouchableOpacity } from 'react-native-gesture-handler';
import AsyncStorage from '@react-native-community/async-storage';
import { ReportsAPI } from "../WebServices/RestClient";
import { API } from "../WebServices/RestClient";
import NetInfo from '@react-native-community/netinfo';
import Snackbar from 'react-native-snackbar';
import log from '../LogFile/Log';
import ProffileOffline from '../OfflineDB/Profile';
const db = new ProffileOffline();
import Main from '../Maintenance/Main';
import jwt_decode from "jwt-decode";
import ModalSelector from 'react-native-modal-selector';
const check = new Main()
import {
  DotIndicator,
} from 'react-native-indicators';
// import { LineChart, BarChart } from "react-native-chart-kit";
import { ScrollView } from 'react-native-gesture-handler';
import { PROFILE, CHANGEPASSWORD, EMPLOYEEID, USERNAME, EMAIL, MOBILE, FULLNAME1, DESIGNATION, TEAM, ROLE, FMANAGER, RMANAGER, STATUS1 } from '../CommonComponents/Header';
import SearchableDropdown from 'react-native-searchable-dropdown';
import PureChart from 'react-native-pure-chart';

export default class ReportUserIndiWorkload extends Component {

  constructor(props) {
    super(props);

    this.state = {
      isLoading: false,
      isVisibleB: false,
      sprintVelocity: [],
      sprint: [],
      indVelocity: [],
      indWorkload: [],
      epicVelocity:[],
      selectedIndVelocity: [],
      // indWorkload: [],
      dataSource: [],
      dataSource1: [],

      assignedName: 'Select Squad Name',
      sprintName: 'Select Sprint Name',
      epicName: 'Select Epic',
      resource: [],
      resource1: [],
      resource2:[],
      burnUpChart: [],


    }
    AsyncStorage.getItem("cropcode", (err, res) => {
      this.setState({ squadName: res });
      console.warn("squadname" + this.state.squadName);
    });
  }



  componentDidMount() {
    this.getEmployees();
   
    this.GetStatus();
 
  }

  //getting the Employees list for addind maintask
  getEmployees() {
    log("Info", " getEmployees(cropcode) is used for getting the Employees list for addind maintask");
    const { ModuleId } = this.state;
    const { ideaid } = this.state;

    AsyncStorage.getItem("cropcode", (err, res) => {
      const cropcode = res;
      AsyncStorage.getItem("projectId", (err, res) => {
        const projectId = res;
        NetInfo.fetch().then(state => {
          if (state.type == "none") {
            console.log(state.type);
            log("Warn", "No internet connection");
            Snackbar.show({
              title: 'No Internet Connection',
              backgroundColor: 'red',
              duration: Snackbar.LENGTH_LONG,
            });
          } else {
            fetch(API + 'agile_squads.php',
              {
                method: 'POST',
                headers: {
                  Accept: 'application/json',
                  'Content-Type': 'application/json',
                },
                body: JSON.stringify({
                  crop: cropcode,
                  projectId: projectId
                })
              })
              .then((response) => response.json())
              .then((responseJson) => {
                if (responseJson.status === 'True') {

                  var empList = [];
                  responseJson.data.map((employee) => {
                    return (
                      empList.push({
                        'id': employee.id, 'name': employee.name
                      })
                    );
                  })
                  //  alert("Employee Data"+JSON.stringify(responseJson))
                  // this.Network1()
                  this.setState({
                    resource: responseJson.data
                  });
                }
              })
              .catch((error) => {
                console.error(error);
                log("Error", "requested projects error");
              });
          }
        });
      });
    });
  }


   //Getting the indVelocity
   Network1(id) {

    // alert("adding id"+id)
    AsyncStorage.getItem("cropcode", (err, res) => {
      const cropcode = res;
      console.warn(cropcode);
      AsyncStorage.getItem("projectId", (err, res) => {
        const projectId = res;

      AsyncStorage.getItem("userToken", (err, res) => {
        const empId = res;
        console.warn(empId);
        // console.warn(item)
        NetInfo.fetch().then(state => {
          if (state.type == "none") {
            Snackbar.show({
              title: 'No Internet Connection',
              backgroundColor: 'red',
              duration: Snackbar.LENGTH_LONG,
            });
          } else {

            // fetch(ReportsAPI + '/api/sprint?databaseName=' + cropcode, {
            fetch(ReportsAPI +'individualWorkload',{ 

              method: 'POST',
              headers: {
                'Accept': 'application/json',
                'Content-Type': 'application/json',
              },
              body: JSON.stringify({
                assigned_to:id,
                project_id: projectId, 
              })

            }).then((response) => response.json())
              .then((responseJson) => {
                // console.warn("Sprint" + JSON.stringify(responseJson));
                //  alert(JSON.stringify(responseJson))

                this.setState({
                  indWorkload: responseJson

                },

                  function () {

                  });
              }).catch((error) => {
                check.Maintenance();
                console.error(error);
                log("Error", "Error in getting profile data");

              });
          }
        });
      });
  });
    });
  }

  //Getting the indVelocity
  Network2(id) {
    // alert(id)
    // this.Network3(item);
    AsyncStorage.getItem("cropcode", (err, res) => {
      const cropcode = res;
      console.warn(cropcode);
      AsyncStorage.getItem("userToken", (err, res) => {
        const empId = res;
        AsyncStorage.getItem("projectId", (err, res) => {
          const projectId = res;
          console.warn(empId);
          NetInfo.fetch().then(state => {
            if (state.type == "none") {
              Snackbar.show({
                title: 'No Internet Connection',
                backgroundColor: 'red',
                duration: Snackbar.LENGTH_LONG,
              });
            } else {

              fetch(ReportsAPI + `individualSprintVelocity`, {
                method: 'POST',
                headers: {
                  'Accept': 'application/json',
                  'Content-Type': 'application/json',
                },
                body: JSON.stringify({
                  corp: cropcode,
                  sprint_id: id,
                })

              }).then((response) => response.json())
                .then((responseJson) => {
                  // alert("individualSprintVelocity" + JSON.stringify(responseJson));
                  //alert(JSON.stringify(responseJson))

                  this.setState({
                    indVelocity: responseJson

                  },

                    function () {

                    });
                }).catch((error) => {
                  check.Maintenance();
                  console.error(error);
                  log("Error", "Error in getting profile data");

                });
            }
          });
        });
      });
    });
  }
  //get project list dropdown data
  GetStatus() {
    log("Info", "UserProfile:GetStatus() method is used to get status of employee");
    AsyncStorage.getItem("userToken", (err, res) => {
      const empId = res;
      NetInfo.fetch().then(state => {
        if (state.type == "none" || state.type == 'unknown' || state.type == 'undefined') {
          // console.log(state.type);
          Snackbar.show({
            title: 'No Internet Connection',
            backgroundColor: 'red',
            duration: Snackbar.LENGTH_LONG,
          });
          this.getAgileProjects()//For Getting Project List in Offline
        } else {

          fetch(API + 'squads.php', {
            method: 'POST',
            headers: {
              Accept: 'application/json',
              'Content-Type': 'application/json',
            },
            body: JSON.stringify({

              empId: empId,
              action: 'get_squads',


            })
          })
            .then((response) => response.json())
            .then((responseJson) => {
              console.warn(responseJson)
              // alert(JSON.stringify(responseJson))
              if (responseJson.status == 'True') {
                // this.addAgileProjects(responseJson.data) //Project list store in offline
                // this.setState({
                //     isLoading: false,
                //     dataSource: [...responseJson.data],
                // }, function () {
                //     // In this block you can do something with new state.
                // });


                var dataSource = [];
                responseJson.data.map((epics) => {
                  return (
                    dataSource.push({
                      'key': epics.value, 'label': epics.value
                    })
                  );
                })

                this.setState({
                  dataSource: dataSource
                });

                // const data2 = [];

                // responseJson.data.map(x => {
                //     data2.push({ label: x.value, value: x.value })
                // })
                // this.setState({
                //     data2: data2,
                // })
                // console.warn("Hello" + JSON.stringify(data2))

                // this.setState({
                //     data2: responseJson.data
                // });
                // console.warn(this.state.data2);
              } else {
                this.setState({
                  dataSource: dataSource
                });
                log("Warn", "status of employee is not available");
              }
            })
            .catch((error) => {
              console.error(error);
              log("Error", "error in  getting status of employee");
            });
        }
      });
    });

  }

  render() {
    if (this.state.isLoading) {
      return (
        <View style={{ flex: 1, alignItems: 'center', justifyContent: 'center' }}>
          <DotIndicator color='#00A2C1' />
        </View>
      );

    }

    var individualDataX = [];
    var individualDataY = [];
    this.state.indVelocity.map((x) => {
      return (
        individualDataX.push({ 'x': x.fullname, 'y': parseInt(x.estimated) })
      );
    })
    this.state.indVelocity.map((x) => {
      return (
        individualDataY.push({ 'x': x.fullname, 'y': parseInt(x.completed) })
      );
    })


    const individualVelocity = [
      {
        seriesName: 'series1',
        color: 'grey',
        label: "Committed",
        // data: this.state.indVelocity.map(x => x.estimated)
        data: individualDataX
      },

      {
        seriesName: 'series2',
        color: 'green',

        label: "Completed",
        // data: this.state.indVelocity.map(x => x.completed)
        data: individualDataY

      }
    ]

  

    var workloadDataX = [];
    var workloadDataY = [];
    this.state.indWorkload.map((x) => {
      return (
        workloadDataX.push({ 'x': x.sprintName, 'y': parseInt(x.estimated) })
      );
    })
    this.state.indWorkload.map((x) => {
      return (
        workloadDataY.push({ 'x': x.sprintName, 'y': parseInt(x.completed )})
      );
    })
// alert(JSON.stringify(workloadDataX))
    const individualWorkload = [
      {
        seriesName: 'series1',
        color: 'grey',
        label: "Committed",
        // data: this.state.indWorkload.map(x => x.estimated)
        data: workloadDataX
      },

      {
        seriesName: 'series2',
        color: 'green',

        label: "Completed",
        // data: this.state.indWorkload.map(x => x.completed)
        data: workloadDataY

      }
    ]


    return (
      <KeyboardAvoidingView
        style={{ flex: 1 }}
        behavior={Platform.OS === "ios" ? "padding" : "height"}
      >
        <Container>
         
          <Content>
            {/* Individual Workload */}
            <View style={{ flex: 1, marginTop: 10, marginBottom: 10, width: '100%' }}>
              <Text style={{ padding: 10, fontWeight: 'bold' }}>Individual Workload</Text>

              <View style={{ paddingTop: 20, }}>
                <SearchableDropdown
                  placeholderTextColor='black'
                  placeholder={this.state.assignedName}
                  onTextChange={text => console.log(text)}
                  // onItemSelect={(item) => this.setState({ assignedto: item.id, assignedName: item.name })}
                  placeholderTextColor='black'
                  onItemSelect={(item) => { this.Network1(item.id), this.setState({ assignedName: item.name }) }}
                  containerStyle={{
                    paddingLeft: "2%",
                    width: '96%'

                  }}
                  textInputStyle={{
                    padding: 12,
                    borderWidth: 1,
                    borderColor: '#ccc',
                    backgroundColor: '#fff',
                    borderRadius: 20
                  }}
                  placeholderTextColor='black'
                  itemStyle={{
                    padding: 10,
                    marginTop: 2,
                    backgroundColor: '#FAF9F8',
                    borderColor: '#bbb',
                    borderWidth: 1,
                    borderRadius: 20
                  }}
                  itemTextStyle={{
                    color: '#222',
                  }}
                  items={this.state.resource}
                  defaultIndex={2}
                  resetValue={false}
                  underlineColorAndroid="transparent"
                />
                <Text style={{ color: 'red' }}>{this.state.error3}</Text>
              </View>
              <View style={{ flexDirection: 'row', flex: 1, alignContent: 'center', justifyContent: 'center' }}>
                <View style={{ width: 30, height: 8, backgroundColor: 'grey', marginTop: 15 }} />
                <Text style={{ padding: 10, }}>Committed</Text>
                <View style={{ width: 30, height: 8, backgroundColor: 'green', marginTop: 15 }} />
                <Text style={{ padding: 10, }}>Completed</Text>
              </View>
              <ScrollView horizontal={true} style={{ marginRight: 2, marginLeft: 2 }}>

                <PureChart data={individualWorkload} type='bar'
                  width={'100%'}
                  height={200}
                  showEvenNumberXaxisLabel={false}
                  defaultColumnWidth={100}
                />

              </ScrollView>
            </View>




          </Content>

        </Container>
      </KeyboardAvoidingView>
    );
  }
}

const styles = StyleSheet.create({
  submit: {
    flex: 1,
    ...Platform.select({
      ios: {
        color: 'white', paddingTop: 3, fontSize: 15, width: 100,
        height: 30, backgroundColor: '#00A2C1',
        textAlign: 'center', borderRadius: 10
      },
      android: {
        color: 'white', paddingTop: 3, fontSize: 15, width: 100,
        height: 30, backgroundColor: '#00A2C1',
        textAlign: 'center', borderRadius: 70
      },
    }),
  },
  mobile: {
    flex: 1,
    ...Platform.select({
      ios: {
        marginTop: 12
      },
      android: {

      },
    }),
  },
  role: {
    flex: 1,
    ...Platform.select({
      ios: {
        flexDirection: 'row', marginTop: 10
      },
      android: {
        flexDirection: 'row',
        paddingTop: 10,

      },
    }),
  },

});
const pickerSelectStyles = StyleSheet.create({
  inputIOS: {
    fontSize: 2,
    paddingVertical: 12,
    paddingHorizontal: 10,
    borderWidth: 1,
    borderColor: 'blue',
    borderRadius: 4,
    color: 'black',
    paddingRight: 30, // to ensure the text is never behind the icon
  },
  inputAndroid: {
    fontSize: 3,
    paddingHorizontal: 10,
    paddingVertical: 8,
    borderWidth: 0.5,
    borderColor: 'purple',
    borderRadius: 8,
    color: 'black',
    paddingRight: 30, // to ensure the text is never behind the icon
  },
});