import React, { Component } from 'react';
import {
  Platform, StyleSheet, TextPropTypes, Picker, Text, View, Image, StatusBar, Dimensions, TextInput, Alert,
  KeyboardAvoidingView,
  TouchableWithoutFeedback,
  Keyboard
} from 'react-native';
// import { Chart, VerticalAxis, HorizontalAxis, Line } from 'react-native-responsive-linechart'
import { Icon, Title, Container, Content, Header, Right, Left, Body } from 'native-base';
import { widthPercentageToDP as wp, heightPercentageToDP as hp } from 'react-native-responsive-screen';
import { TouchableOpacity } from 'react-native-gesture-handler';
import AsyncStorage from '@react-native-community/async-storage';
import { ReportsAPI } from "../WebServices/RestClient";
import { API } from "../WebServices/RestClient";
import NetInfo from '@react-native-community/netinfo';
import Snackbar from 'react-native-snackbar';
import log from '../LogFile/Log';
import ProffileOffline from '../OfflineDB/Profile';
const db = new ProffileOffline();
import Main from '../Maintenance/Main';
import jwt_decode from "jwt-decode";
import ModalSelector from 'react-native-modal-selector';
const check = new Main()
import {
  DotIndicator,
} from 'react-native-indicators';
// import { LineChart, BarChart } from "react-native-chart-kit";
import { ScrollView } from 'react-native-gesture-handler';
import { PROFILE, CHANGEPASSWORD, EMPLOYEEID, USERNAME, EMAIL, MOBILE, FULLNAME1, DESIGNATION, TEAM, ROLE, FMANAGER, RMANAGER, STATUS1 } from '../CommonComponents/Header';
import SearchableDropdown from 'react-native-searchable-dropdown';
import PureChart from 'react-native-pure-chart';

export default class ReportUserSprintVelocity extends Component {

  constructor(props) {
    super(props);

    this.state = {
      isLoading: false,
      isVisibleB: false,
      sprintVelocity: [],
      sprint: [],
      selectedIndVelocity: [],
      // indWorkload: [],
      dataSource: [],
      dataSource1: [],
  
      resource: [],
      resource1: [],
      resource2:[],
     


    }
   
  }



  componentDidMount() {
 
    this.Network();
 
  }

  

  //Getting the Srpint velocity
  Network() {

    AsyncStorage.getItem("cropcode", (err, res) => {
      const cropcode = res;
      console.warn(cropcode);
      AsyncStorage.getItem("userToken", (err, res) => {
        const empId = res;
        AsyncStorage.getItem("projectId", (err, res) => {
          const projectId = res;
          // alert(projectId);
          NetInfo.fetch().then(state => {
            if (state.type == "none") {
              Snackbar.show({
                title: 'No Internet Connection',
                backgroundColor: 'red',
                duration: Snackbar.LENGTH_LONG,
              });
            } else {

              fetch(ReportsAPI + 'sprintVelocity', {
                method: 'POST',
                headers: {
                  'Accept': 'application/json',
                  'Content-Type': 'application/json',
                },
                body: JSON.stringify({
                  corp: cropcode,
                  project_id: projectId
                })


              }).then((response) => response.json())
                .then((responseJson) => {
                  // alert("Sprint Velocity" + JSON.stringify(responseJson));
                  // alert("Sprint Velocity1" + sprintVelocity);
                //   alert(JSON.stringify(responseJson))

                  this.setState({
                    sprintVelocity: responseJson

                  },

                    function () {

                    });
                }).catch((error) => {
                  check.Maintenance();
                  console.error(error);
                  log("Error", "Error in getting profile data");

                });
            }
          });
        });
      });

    });
  }


  render() {
    if (this.state.isLoading) {
      return (
        <View style={{ flex: 1, alignItems: 'center', justifyContent: 'center' }}>
          <DotIndicator color='#00A2C1' />
        </View>
      );

    }
    var sprintDataX = [];
    var sprintDataY = [];
    // alert(JSON.stringify(this.state.sprintVelocity))
    this.state.sprintVelocity.map((x) => {
      return (
        sprintDataX.push({ 'x': x.sprint, 'y': parseInt(x.estimated) })
      );

    })
    // alert(JSON.stringify(sprintDataX))
    this.state.sprintVelocity.map((x) => {
      return (
        sprintDataY.push({ 'x': x.sprint, 'y': parseInt(x.completed) })
      );
    })

// alert(JSON.stringify(sprintDataX))

    const sprintData = [

      {
        seriesName: 'series1',
        color: 'grey',


        data: sprintDataX

        // data: this.state.sprintVelocity.map(x => x.estimated)
        // data: [{x:this.state.sprintVelocity.map(x => x.sprint),y:this.state.sprintVelocity.map(y => y.estimated)}],
        // data1:this.state.sprintVelocity.map(y => y.sprint)
      },

      {
        seriesName: 'series2',
        color: 'green',
        labelWidth: 200,
        label: "Completed",
        data: this.state.sprintVelocity.map(x => parseInt(x.completed)),
        // data: [{x:this.state.sprintVelocity.map(x => x.sprint),y:this.state.sprintVelocity.map(y => y.completed)}],

      }
    ]

    

    return (
      <KeyboardAvoidingView
        style={{ flex: 1 }}
        behavior={Platform.OS === "ios" ? "padding" : "height"}
      >
        <Container>
   
          <Content>

            {/* Sprint Velocity */}
            <View style={{ flex: 1, marginTop: 10, marginBottom: 10 }}>
              <Text style={{ padding: 10, fontWeight: 'bold' }}>Sprint Velocity</Text>
              <View style={{ flexDirection: 'row', flex: 1, alignContent: 'center', justifyContent: 'center' }}>
                <View style={{ width: 30, height: 8, backgroundColor: 'grey', marginTop: 15 }} />
                <Text style={{ padding: 10, }}>Committed</Text>
                <View style={{ width: 30, height: 8, backgroundColor: 'green', marginTop: 15 }} />
                <Text style={{ padding: 10, }}>Completed</Text>
              </View>
              <ScrollView horizontal={true} style={{ marginRight: 2, marginLeft: 2 }}>

                <PureChart data={sprintData} 
                   type='bar'
                  showEvenNumberXaxisLabel={false}
                  width={'100%'}
                  labelColor={'black'}
                  defaultColumnWidth={105}
                />


              </ScrollView>
            </View>

            





          </Content>

        </Container>
      </KeyboardAvoidingView>
    );
  }
}

const styles = StyleSheet.create({
  submit: {
    flex: 1,
    ...Platform.select({
      ios: {
        color: 'white', paddingTop: 3, fontSize: 15, width: 100,
        height: 30, backgroundColor: '#00A2C1',
        textAlign: 'center', borderRadius: 10
      },
      android: {
        color: 'white', paddingTop: 3, fontSize: 15, width: 100,
        height: 30, backgroundColor: '#00A2C1',
        textAlign: 'center', borderRadius: 70
      },
    }),
  },
  mobile: {
    flex: 1,
    ...Platform.select({
      ios: {
        marginTop: 12
      },
      android: {

      },
    }),
  },
  role: {
    flex: 1,
    ...Platform.select({
      ios: {
        flexDirection: 'row', marginTop: 10
      },
      android: {
        flexDirection: 'row',
        paddingTop: 10,

      },
    }),
  },

});
const pickerSelectStyles = StyleSheet.create({
  inputIOS: {
    fontSize: 2,
    paddingVertical: 12,
    paddingHorizontal: 10,
    borderWidth: 1,
    borderColor: 'blue',
    borderRadius: 4,
    color: 'black',
    paddingRight: 30, // to ensure the text is never behind the icon
  },
  inputAndroid: {
    fontSize: 3,
    paddingHorizontal: 10,
    paddingVertical: 8,
    borderWidth: 0.5,
    borderColor: 'purple',
    borderRadius: 8,
    color: 'black',
    paddingRight: 30, // to ensure the text is never behind the icon
  },
});