/*
FileName:UserApprovedProjects.js
Version:1.0.0
Purpose:Getting the List of ApprovedProjects and also verify the project by role and Add RO
Devloper:Mahesh
*/
import React, { Component } from 'react';
import Icon from 'react-native-vector-icons/FontAwesome';
import { Platform, StyleSheet, Text, View, Dimensions, FlatList, TextInput,TouchableHighlight, Image, TouchableOpacity, Alert } from 'react-native';
import { Left, Button, Container, Header, Content, Item, Input } from 'native-base';
import AsyncStorage from '@react-native-community/async-storage';
import { widthPercentageToDP as wp, heightPercentageToDP as hp } from 'react-native-responsive-screen';
import Modal from "react-native-simple-modal";
import Toast from 'react-native-whc-toast';
import SearchableDropdown from 'react-native-searchable-dropdown';
import { API } from "../WebServices/RestClient";
import NetInfo from '@react-native-community/netinfo';
import Snackbar from 'react-native-snackbar';
import log from '../LogFile/Log';
import { NavigationEvents } from 'react-navigation';
import Main from '../Maintenance/Main';
const check = new Main()
import ApprovedProjectsListOffline from '../OfflineDB/ApprovedProjects';
const db = new ApprovedProjectsListOffline();
import {
  BallIndicator,
  BarIndicator,
  DotIndicator,
  MaterialIndicator,
  PacmanIndicator,
  PulseIndicator,
  SkypeIndicator,
  UIActivityIndicator
} from 'react-native-indicators';
import { PROJECTNO, TITLE,ADDPROJECT, REQUESTED_BY ,RELEASEOWNER,PROJECTSTATUS,RO,VERIFY,DELETE} from '../CommonComponents/Header';


class ListItem extends React.Component {

  // to verify the project in user based like approver 
  // it just validation 
  ProjectVerify() {
    log("Info", "ProjectVerify() method is used to give alert");
    const { item } = this.props;

    Alert.alert(
      'Alert..!',
      'Do you want to Verify Task',
      [
        {
          text: 'Cancel',
          onPress: () => console.log('Cancel Pressed'),
          style: 'cancel',
        },
        { text: 'OK', onPress: () => this.ProjectVerification(item.idea_id) },
      ],
      { cancelable: false },
    );

  }

  //to verify the project in user based projects
  ProjectVerification(projectid) {
    log("Info", "ProjectVerification(projectid) method is used to verify approved project");
    AsyncStorage.getItem("cropcode", (err, res) => {
      const cropcode = res;
      NetInfo.fetch().then(state => {
        if (state.type == "none" || state.type == 'unknown' || state.type == 'undefined') {
          console.log(state.type);
          Snackbar.show({
            title: 'No Internet Connection',
            backgroundColor: 'red',
            duration: Snackbar.LENGTH_LONG,
          });
        } else {
          fetch(API + 'manageIdeas.php',
            {
              method: 'POST',
              headers: {
                Accept: 'application/json',
                'Content-Type': 'application/json',
              },
              body: JSON.stringify({
                crop: cropcode,
                idea_id: projectid,
                action: 'verify'

              })
            })
            .then((response) => response.json())
            .then((responseJson) => {
              if (responseJson.status == 'True') {

              } else if (responseJson.status == 'false') {

                Alert.alert(responseJson.message);

              } else { }
            })
            .catch((error) => {
              console.error(error);
              log("Error", "ProjectVerification Error");
            });
        }
      });
    });
  }

  render() {
    // const { item } = this.props;
    const { item } = this.props;
    const { emp_role } = this.props;
    let button3;
    // AsyncStorage.getItem("emp_role", (err, res) => {
    if (item.ideaStatus === "finalized" && emp_role === "Approver") {

      button3 =

        <TouchableOpacity onPress={() => { this.ProjectVerify() }} style={{ width: 60, backgroundColor: 'green',marginRight:15 }}><Text style={{ color: '#fff', textAlign: 'center' }}>{VERIFY}</Text></TouchableOpacity>

    } else {
      button3 = null;


    }
    let button4
    if (item.ideaStatus === "finalized") {

      button4 =

        <View style={{ flexDirection: 'row', paddingRight: 55 }}>
          <Text style={styles.listgap} >{PROJECTSTATUS}:</Text>
          <Text style={[styles.signUpText3,styles.signUpText0003]} >Completed</Text>
        </View>
    } else {
      button4 =
        <View style={{ flexDirection: 'row', paddingRight: 55 }}>
          <Text style={styles.listgap} >{PROJECTSTATUS}:</Text>
          <Text style={[styles.signUpText3,styles.signUpText003]} >Pending</Text>
        </View>


    }
    return (

      <View style={Number(item.taskStatus) === 1 ? styles.buttonContainer : styles.buttonContainer1}>
        <TouchableOpacity onPress={this.props.Module}>
          <View style={styles.signup}>

            <View style={[styles.buttonContainer, styles.signupButton]} >
              <View style={styles.box}>
                <View style={{ flexDirection: 'row', width: wp('75%') }}>
                  <Text style={styles.signUpText0} >{PROJECTNO} : </Text>

                  <Text style={styles.signUpText1} >{item.idea_id}</Text>

                </View>
                <Text style={styles.signUpText2} > {item.acceptedDate}</Text>
              </View>
              <View
                style={{
                  borderBottomColor: '#C0C0C0',
                  borderBottomWidth: 0.3,
                }}
              />

              {/* <View style={{ flexDirection: 'row', paddingRight: 25, }}>
                <Text style={styles.signUpText4} >Title:</Text>
                <Text style={styles.signUpText3} >{item.idea_title}</Text>
                <View >
                  <Text style={styles.signUpText4} >ReleaseOwner:</Text>
                  <Text style={styles.signUpText3} >{item.idea_title}</Text>
                </View>

              </View> */}

              <View style={{ flexDirection: 'row', paddingRight: 25, }}>
                {/* <View style={{width:'45%'}}> */}
                <Text style={styles.signUpText4} >Epic Name:</Text>
                <Text style={styles.signUpText9} >{item.idea_title}</Text>
                {/* </View> */}
                <Text style={styles.listgap} >{RELEASEOWNER} :</Text>
                <Text style={styles.signUpText3} >{item.releaseOwner}</Text>
              </View>


              <View style={{ flexDirection: 'row', paddingRight: 25, }}>
              
              <Text style={styles.signUpText4} >{REQUESTED_BY}:</Text>
              <Text style={styles.signUpText99} >{item.userName}</Text>
       
              {button4}
             
             
            </View>

{/* {button4} */}
              <View style={{ flexDirection: 'row', justifyContent: 'flex-end', alignItems: 'center' }}>
              {button3}
             
              <TouchableOpacity onPress={() => this.props.ModifyProject()} style={{ margin:2, backgroundColor: 'black' }}>
              <Text style={{color:'white'}}>Modify</Text>
</TouchableOpacity>
              {/* <Icon style={{ paddingLeft: 18, paddingTop: 14, backgroundColor: '#fff', borderWidth: 1, borderRadius: 30, width: 60, height: 60 }} name="pencil" size={30} color="black" onPress={() =>
            this.openModal()}   /> */}
                {/* <TouchableOpacity onPress={() => { this.ProjectVerify() }} style={{ width: 60, backgroundColor: 'green' }}><Text style={{ color: '#fff', textAlign: 'center' }}>VERIFY</Text></TouchableOpacity> */}
                {/* <TouchableOpacity onPress={() => { this.props.ReleaseOwner() }} style={{ width: 40, backgroundColor: 'black', marginLeft: 10,marginRight:20 }}><Text style={{ color: '#fff', textAlign: 'center' }}>{RO}</Text></TouchableOpacity> */}

              </View>

            </View>
            <View style={{ backgroundColor: '#fff', height: 5 }}>

            </View>
          </View>
        </TouchableOpacity>
      </View>

    )
  }
}
export default class Aproved extends Component {
  // static navigationOptions = () => {
  //   return {
  //     tabBarOnPress({ navigation, defaultHandler }) {
  //       navigation.state.params.onTabFocus();
  //       defaultHandler();
  //       this.onRefresh();
  //     }
  //   };
  // }
  constructor(props) {

    super(props);
    props.navigation.setParams({
      onTabFocus: this.handleTabFocus
    });
    this.state = {
      isLoading: true,
      dataSource: [],
      isFetching: false,
      ProjectTitle:'',
      ProjectDescription:'',
      open: false,
      resource: [],
      ideaid: '',
      error1:'',
      error2:'',

    }
    this.arrayholder = [];
  }
  // handleTabFocus = () => {
  //   this.onRefresh();
  // };
  moveUp = () => this.setState({ offset: -110 });

  resetPosition = () => this.setState({ offset: 0 });

  openModal = () => this.setState({ open: true });

  closeModal = () => {
    //this.props.navigation.goBack();
    this.setState({ open: false });
  }

  //lifecycle method to call api methods 
  componentDidMount() {
    log("Debug", "User Approved projects screen is loaded");
    NetInfo.fetch().then(state => {
      if (state.type == "none" || state.type == 'unknown' || state.type == 'undefined') {
        console.log(state.type);
        Snackbar.show({
          title: 'No Internet Connection',
          backgroundColor: 'red',
          duration: Snackbar.LENGTH_LONG,
        });
        this.getApprovedProjectsListOffline() //Offline Approved Projects List
      } else {
        //userApprovedProjects getting
        this.userApprovedProjects()
      }
    });
    AsyncStorage.getItem("emp_role", (err, res) => {
      this.setState({ emp_role: res });

      console.warn("Emp role" + this.state.emp_role)
    });

    this.getResource()


  }

  //For Approved Projects from offline
  getApprovedProjectsListOffline() {
    db.getApprovedProjectsListOffline().then((data) => {
      console.warn("completedManageTaskData" + JSON.stringify(data))
      // console.warn(data[0].empid)/
      this.setState({
        dataSource: data,
        isLoading: false,
      });
      this.arrayholder = data;
    }).catch((err) => {
      console.log(err);
      this.setState = {
        isLoading: false
      }
    })
  }

  //For store Approved Projects list from offline
  addApprovedProjectsListOffline(data) {
    // console.warn("hello"+JSON.stringify(data));
    db.addApprovedProjectsListOffline(data).then((result) => {
      this.setState({
        isLoading: false,
      });
    }).catch((err) => {
      console.log(err);
      this.setState({
        isLoading: false,
      });
    })
  }

  //to get the user approved projects in to the list 
  getResource() {
    log("Info", "UserApprovedProjects:getResource() method is used to get all employee list");
    const { ModuleId } = this.state;
    const { ideaid } = this.state;

    AsyncStorage.getItem("cropcode", (err, res) => {
      const cropcode = res;
      NetInfo.fetch().then(state => {
        if (state.type == "none" || state.type == 'unknown' || state.type == 'undefined') {
          console.log(state.type);
          Snackbar.show({
            title: 'No Internet Connection',
            backgroundColor: 'red',
            duration: Snackbar.LENGTH_LONG,
          });
        } else {
          fetch(API + 'getEmployees.php',
            {
              method: 'POST',
              headers: {
                Accept: 'application/json',
                'Content-Type': 'application/json',
              },
              body: JSON.stringify({
                crop: cropcode
              })
            })
            .then((response) => response.json())
            .then((responseJson) => {
              if (responseJson.status === 'True') {
                this.setState({
                  resource: responseJson.data
                });
              }
            })
            .catch((error) => {
              console.error(error);
              log("Error", "error in listing employees");
            });
        }
      });
    });
  }

  //to refreshthe data in user apprroved projects
  onRefresh() {
    this.setState({
      dataSource: [],
    })
    NetInfo.fetch().then(state => {
      if (state.type == "none" || state.type == 'unknown' || state.type == 'undefined') {
        console.log(state.type);
        Snackbar.show({
          title: 'No Internet Connection',
          backgroundColor: 'red',
          duration: Snackbar.LENGTH_LONG,
        });
        this.getApprovedProjectsListOffline() //Offline Approved Projects List
      } else {
        //userApprovedProjects getting
        this.userApprovedProjects()
      }
    });
  }

  isValid() {
    const { ProjectTitle, ProjectDescription } = this.state;
    let valid = false;

    if (ProjectTitle.length === 0) {
      this.setState({ error1: 'Enter Project Title ' });
      log("Warn", "project title should not be empty");
      // alert("project title should not be empty ");

    }
    else if (ProjectDescription.length === 0) {
      this.setState({ error2: 'Enter Project Description ' });
      log("Warn", "project description should not be empty");
      // alert("project description should not be empty");
    }

    else {
      valid = true;
    }
    return valid;
  }//isValid method end

  //to add the new project from user 
  addProject = () => {
    log("Info", "addProject() method is used to add new project at user side");
    NetInfo.fetch().then(state => {
      if (state.type == "none" || state.type=="unknown" || state.type == 'undefined') {
        console.log(state.type);
        Snackbar.show({
          title: 'No Internet Connection',
          backgroundColor: 'red',
          duration: Snackbar.LENGTH_LONG,
        });
      }
      else {
        const { ProjectTitle,ProjectDescription } = this.state;
        if (this.isValid()) {
          this.setState({ itemPressedDisabled: true })
          AsyncStorage.multiGet(["cropcode", "userToken", "emp_role"], (err, response) => {
            const cropcode = response[0][1];
            const userToken = response[1][1];
            console.warn("userToken"+userToken)
            const role = response[2][1];
            fetch(API + 'manageIdeas.php', {
              method: 'POST',
              headers: {
                'Accept': 'application/json',
                'Content-Type': 'application/json',
              },
              body: JSON.stringify({
                proj_title: this.state.ProjectTitle,
                proj_desc: this.state.ProjectDescription,
                empId:userToken, //Async
                action: "add",
                crop: cropcode //Async
              })
            }).then((response) => response.json())
              .then((responseJson) => {
                console.log(JSON.stringify(responseJson));
                console.log(responseJson);

                if (responseJson.status === 'True') {
                  this.refs.toast.showBottom('Epic Added Succesfully');
                  this.setState({ itemPressedDisabled: false })
                  console.log("done")
                  this.setState({
                    open: false,
                    ProjectTitle: '',
                    ProjectDescription: ''
                  })
                  this.userApprovedProjects()

                }
              }).catch((error) => {
                console.error(error);
                log("Error", "error in project adding");
              });
          });
          this.closeModal();
        }
      }

    });

  };

  //Set the RO
  setRO(ideaid) {
    log("Info", "UserApprovedProjects:setRO(ideaid) method is used to set release owner");
    AsyncStorage.multiGet(["cropcode", "userToken", "emp_role"], (err, response) => {
      const cropcode = response[0][1];
      const userToken = response[1][1];
      const role = response[2][1];
      // alert(cropcode+userToken+role)
      NetInfo.fetch().then(state => {
        if (state.type == "none" || state.type == 'unknown' || state.type == 'undefined') {
          console.log(state.type);
          Snackbar.show({
            title: 'No Internet Connection',
            backgroundColor: 'red',
            duration: Snackbar.LENGTH_LONG,
          });
        } else {
          fetch(API + 'manageIdeas.php',
            {
              method: 'POST',
              headers: {
                Accept: 'application/json',
                'Content-Type': 'application/json',
              },
              body: JSON.stringify({
                crop: cropcode,
                action: 'ro',
                empId: userToken,
                userType: role,
                ideaId: ideaid,
              })
            })
            .then((response) => response.json())
            .then((responseJson) => {
              //    alert(JSON.stringify(responseJson));
              console.log(responseJson)
              if (responseJson.setState == "True") {

                this.setState({ open: false });
                this.setState({
                  isLoading: false,

                  isFetching: false
                }, function () {

                });
              }


            })
            .catch((error) => {
              console.error(error);
              log("Error", "error in Release owner setting");
            });
        }
      });
    });
  }

  componentWillReceiveProps(nextProps) {

    this.userApprovedProjects();
  }
  //userApprovedProjects getting
  userApprovedProjects() {
    log("Info", "UserApprovedProjects:setRO(userApprovedProjects() method is used to list the user approved projects");
    AsyncStorage.multiGet(["cropcode", "userToken", "emp_role"], (err, response) => {
      const cropcode = response[0][1];
      const userToken = response[1][1];
      const role = response[2][1];
      // console.warn(userToken)
      // alert(cropcode+userToken+role)
      NetInfo.addEventListener(state => {
        if (state.type == "none" || state.type == 'unknown' || state.type == 'undefined') {
          console.log(state.type);
          Snackbar.show({
            title: 'No Internet Connection',
            backgroundColor: 'red',
            duration: Snackbar.LENGTH_LONG,
          });
        } else {
          fetch(API + 'getIdeas.php',
            {
              method: 'POST',
              headers: {
                Accept: 'application/json',
                'Content-Type': 'application/json',
              },
              body: JSON.stringify({
                crop: cropcode,
                // action: 'approved',
                action:'getIdeas',
                empId: userToken,
                userType: role
              })
            })
            .then((response) => response.json())
            .then((responseJson) => {
              //  alert(JSON.stringify(responseJson));
              console.warn(JSON.stringify(responseJson));
              if (responseJson.dbconnect === 'dbconnected') {
                if (responseJson.status === 'True') {
                  this.addApprovedProjectsListOffline(responseJson.data) //Store Approved Projects List Offline
                  this.setState({
                    isLoading: false,
                    dataSource: responseJson.data,
                    isFetching: false
                  }, function () {

                  });
                  //  console.warn(responseJson.taskStatus);
                  this.arrayholder = responseJson.data;
                } else {
                  this.arrayholder = [];
                  this.setState({
                    isLoading: false,
                  })
                  Snackbar.show({
                    title: 'No UserApproved Projects',
                    backgroundColor: '#3BB9FF',
                    duration: Snackbar.LENGTH_LONG,
                  });
                }
              }
              else {
                this.props.navigation.navigate('Maintenance');
              }
            })
            .catch((error) => {
              check.Maintenance();
              console.error(error);
              log("Error", "error in listing approved projects at user side");
            });
        }
      });
    });
  }



  //Relese the owner Navigation
  ReleaseOwner = (item, index) => {
    log("Info", "UserApprovedProjects:ReleaseOwner = (item, index) method used to navigate to Release owner screen");
    this.props.navigation.navigate('ReleaseOwner', { idea_id: item.idea_id });

  }

  //Navigate to AddModule sctreen
  Module = (item, index) => {
    log("Info", "UserApprovedProjects:Module() method is used to move module listing screen");
    console.log(item);
    console.log(index);
    this.props.navigation.navigate("AddModule", { idea_id: item.idea_id, idea_title: item.idea_title });

  }

  //Navigate to Project Modify Screen
  ModifyProject(item, index) {
    console.log(item);
    console.log(index);
    log("Info", "UserModifyProject() method is used to move Add Module to Add UserModifyProject screen");
    this.props.navigation.navigate('UserModifyProject', { action: 'modify', idea_id: item.idea_id, idea_title:item.idea_title,idea_description:item.idea_description,});

  }
  //list seperator
  FlatListItemSeparator = () => {
    return (
      <View
        style={{
          //  height: .5,
          width: "100%",
          backgroundColor: "#000",
        }}
      />
    );
  }
  //List data for Empty
  _listEmptyComponent = () => {
    return (
      <View style={{ width: '90%', height: '80%' }}>
        <Text></Text>
      </View>
    )
  }


  //to filter the search in put by user 
  SearchFilterFunction(text) {
    log("Info", "UserApprovedProjects:SearchFilterFunction(text) method is used for search functionality");
    console.log(text);
    const newData = this.arrayholder.filter(function (item) {
      const idea_id = item.idea_id.toUpperCase()
      const idea_id1 = text.toUpperCase()
      // const created_on = item.created_on.toUpperCase()
      // const created_on1 = text.toUpperCase()
      const idea_title = item.idea_title.toUpperCase()
      const idea_title1 = text.toUpperCase()
      const userName = item.userName.toUpperCase()
      const userName1 = text.toUpperCase()

      return idea_id.indexOf(idea_id1) > -1 ||
        idea_title.indexOf(idea_title1) > -1 ||
        //  created_on.indexOf(created_on1) > -1 ||
        userName.indexOf(userName1) > -1

    })
    this.setState({
      dataSource: newData,
      text: text
    })
  }

  render() {
    if (this.state.isLoading) {
      return (
        <View style={{ flex: 1, alignItems: 'center', justifyContent: 'center' }}>
          <DotIndicator color='#00A2C1' />
        </View>
      );

    }
    return (
      <Container style={{ height: Dimensions.get('window').height }}>
        {/* <NavigationEvents
            onDidFocus={() => this.onRefresh()}
          /> */}
        <Item>
          <Input placeholder="Search"
            onChangeText={(text) => this.SearchFilterFunction(text)} />
          <Icon size={20} name="search" />
        </Item>
        <View>
        <Toast ref="toast" />
          <View style={{ height: '92%' }}>

            <FlatList

              extraData={this.state}
              keyExtractor={this._keyExtractor}
              renderItem={this._renderItem}

              data={this.state.dataSource}

              onRefresh={() => this.onRefresh()}
              refreshing={this.state.isFetching}

              ItemSeparatorComponent={this.FlatListItemSeparator}
              renderItem={({ item, index }) =>
                <View>

                  <ListItem
                    item={item}
                    ModifyProject={() => this.ModifyProject(item, index)}//For Modify Project
                    emp_role={this.state.emp_role}
                    Module={() => this.Module(item, index)}
                    ReleaseOwner={() => this.ReleaseOwner(item, index)}

                  />
                </View>
              }
              keyExtractor={item => item.id}
              ListEmptyComponent={this._listEmptyComponent}
            />

          </View>

          <View>



          </View>



          <TouchableOpacity onPress={this.openModal} style={styles.bottomView}>
            <View style={styles.bottomView} >
              <Icon

                name='lightbulb-o'
                color='white'
                type='MaterialCommunityIcons'
                size={30}
              />

              <Text style={styles.textStyle}>{ADDPROJECT}</Text>


            </View>
          </TouchableOpacity>
          <Modal
            // offset={this.state.offset}
            open={this.state.open}
            modalDidOpen={this.modalDidOpen}
            modalDidClose={this.modalDidClose}
            style={{ alignItems: "center" }} >

            <View style={{ alignItems: "center", paddingBottom: 40 }}>

              <Text>Epic Info</Text>

              <TextInput placeholder='Epic Title'
                style={{ height: 40, borderBottomWidth: 1, borderBottomColor: 'black', width: 300, marginTop: 10 }}
                maxLength={50}
                onChangeText={(text) => this.setState({ ProjectTitle: text })}
                value={this.state.ProjectTitle} />
              <Text style={{ color: 'red', alignItems: 'flex-start', alignSelf: 'flex-start', justifyContent: 'flex-start', marginLeft: 25 }}>{this.state.error1}</Text>


              <TextInput placeholder='Description'
                style={{ height: 40, borderBottomWidth: 1, borderBottomColor: 'black', width: 300, marginTop: 30 }}
                maxLength={1024}
                onChangeText={(text) => this.setState({ ProjectDescription: text })}
                value={this.state.ProjectDescription} />
              <Text style={{ color: 'red', alignItems: 'flex-start', alignSelf: 'flex-start', justifyContent: 'flex-start', marginLeft: 25 }}>{this.state.error2}</Text>
 



            </View>
            <View style={{ flexDirection: 'row', marginTop: 20, alignItems: 'center', justifyContent: 'center', alignSelf: 'center', }}>

              <TouchableOpacity style={styles.opensave} onPress={this.addProject} disabled={this.state.itemPressedDisabled}>
                <Text style={{ color: 'white' }}>SAVE</Text>

              </TouchableOpacity>
              <TouchableOpacity style={styles.opencancel} onPress={this.closeModal}>
                <Text style={{ color: 'white' }}>CANCEL</Text>
              </TouchableOpacity>

            </View>
          </Modal>

          {/* <Modal
            offset={this.state.offset}
            open={this.state.open}
            modalDidOpen={this.modalDidOpen}
            modalDidClose={this.modalDidClose}
            style={{ alignItems: "center", }}
          >

            <View style={{ alignItems: "center", paddingBottom: 40 }}>

              <View style={{ marginTop: 30, marginLeft: 10, width: '100%', }}>
                <Text >Select Resources</Text>
                <View style={{ justifyContent: 'center', marginRight: 15 }}>

                  <SearchableDropdown
                    onTextChange={text => console.log(text)}
                    //On text change listner on the searchable input
                    onItemSelect={item => console.log(text)}
                    //onItemSelect called after the selection from the dropdown
                    containerStyle={{ padding: 5 }}
                    //suggestion container style
                    textInputStyle={{
                      //inserted text style
                      padding: 12,
                      borderWidth: 1,
                      borderColor: '#ccc',
                      backgroundColor: '#FAF7F6',
                    }}
                    itemStyle={{
                      //single dropdown item style
                      padding: 10,
                      marginTop: 2,
                      backgroundColor: '#FAF9F8',
                      borderColor: '#bbb',
                      borderWidth: 1,
                    }}
                    itemTextStyle={{
                      //text style of a single dropdown item
                      color: '#222',
                    }}
                    itemsContainerStyle={{
                      //items container style you can pass maxHeight
                      //to restrict the items dropdown hieght
                      // maxHeight: '60%',
                    }}
                    items={this.state.resource}
                    //mapping of item array
                    defaultIndex={0}
                    //default selected item index
                    placeholder="select RO"
                    //place holder for the search input
                    resetValue={false}
                    //reset textInput Value with true and false state
                    underlineColorAndroid="transparent"
                  //To remove the underline from the android input
                  />
                </View>
              </View>

              <View style={{ flexDirection: 'row', marginTop: 30, justifyContent: "space-between" }}>
                <TouchableOpacity style={styles.opencancel} onPress={this.closeModal}>
                  <Text style={{ color: 'white' }}>CANCEL</Text>
                </TouchableOpacity>
                <TouchableOpacity onPress={() => { this.setRO(this.state.ideaid) }} style={styles.opensave} >
                  <Text style={{ color: 'white' }}>SAVE</Text>
                </TouchableOpacity>
              </View>

            </View>
          </Modal> */}

        </View>
      </Container>
    );
  }
}
//Styles for UI
const styles = StyleSheet.create({
  container: {
    flex: 1,
    width: '100%',
    backgroundColor: '#f8f8f8',
    // paddingLeft: hp('1%'),
  },
  container1: {
    flex: 1,
    width: '98%',
    backgroundColor: '#BEF29F',

  },

  bottomView: {
    flexDirection: 'row',
    justifyContent: 'center',
    position: 'absolute',
    height: FOOTER_MAX_HEIGHT,
    bottom: 0,
    left: 0,
    right: 0,
    backgroundColor: 'black',
    alignItems: 'center'
  },

  textStyle: {

    color: '#fff',
    fontSize: 22,
    justifyContent: 'center',
    backgroundColor: '#00A2C1',
    paddingBottom: 5,
    paddingLeft: 5,
    paddingRight: 5,
    paddingTop: 5,
    borderRadius: 5,
    marginLeft: 5


  },
  footer: {
    position: 'absolute',
    flex: 0.1,
    left: 0,
    right: 0,
    bottom: -10,
    backgroundColor: 'green',
    flexDirection: 'row',
    height: 80,
    alignItems: 'center',
  },
  bottomButtons: {
    alignItems: 'center',
    justifyContent: 'center',
    flex: 1,
  },
  footerText: {
    color: 'white',
    // fontWeight: 'bold',
    alignItems: 'center',
    fontSize: 18,
  },
  buttonContainer: {
    width: wp('98%'),
    alignSelf: 'baseline',
    marginBottom: 10,
    color: '#d2691e',
    marginLeft: 4,



  },
  buttonContainer1: {
    width: wp('98%'),
    alignSelf: 'baseline',
    marginBottom: 10,
    // backgroundColor: '#BEF29F',
    marginLeft: 4,



  },
  signupButton: {

    backgroundColor: '#ffffff',
  },
  subcontainer: {
    flex: 2,
    flexDirection: 'row',
    paddingTop: 40
  },
  signUpText0: {
    fontSize: 13,
    color: 'green',
    paddingTop: 10,
    // fontWeight:"bold",

  },
  signUpText1: {
    fontSize: 13,
    color: 'green',
    paddingTop: 10,
    // fontWeight:"bold",
    paddingLeft: 10,
  },
  end: {

    alignItems: 'flex-end',

  },
  end1: {
    flex: 2,
    height: '50%',
    paddingTop: 20,
    justifyContent: 'space-between',

    flexDirection: 'row',
  },
  s: {
    justifyContent: 'center',

    backgroundColor: '#ed7070',
    shadowOffset: { width: 50, height: 50 },
    alignItems: 'center',
    width: wp('40%'),
    height: hp('12%'),

  },
  signUpText2: {
    fontSize: 13,
    //marginLeft: 200,
    // fontSize: 13,
    color: 'black',
    paddingTop: 10,

    //  marginRight: 10,
    //textAlign: "right"

  },
  listgap: {
    fontSize: 13,
    paddingTop: 10,
    // paddingLeft: 130,


    alignItems: 'center',
  },
  signUpText03: {
    width: '25%',
    fontSize: 13,
    paddingTop: 10,
    paddingLeft: 10,

    alignItems: 'center',
  },
  signUpText3: {

    fontSize: 13,
    paddingTop: 10,
    paddingLeft: 10,
    // fontWeight:"bold",
    alignItems: 'center',
  },
  signUpText4: {
    fontSize: 13,
    paddingTop: 10,

    color: 'black',
    // fontWeight:"bold",
    alignItems: 'center',
  },
  signUpText9: {
    fontSize: 13,
    paddingTop: 10,
    width: wp('45%'),
    color: 'black',
    // fontWeight:"bold",
    alignItems: 'center',
  },
  signUpText99: {
    fontSize: 13,
    paddingTop: 10,
    width: wp('35%'),
    color: 'black',
    // fontWeight:"bold",
    alignItems: 'center',
  },

  signup: {
    //paddingTop:20,
    color: "#FFF",

  },
  boxone: {
    flex: 1,
    marginTop: 5,

  },
  boxtwo: {
    flex: 1,

  },
  boxthree: {
    flex: 1,

  },
  box: {
    flexDirection: 'row',
    position: 'relative',
    marginBottom: 10,


  },
  signUpText: {
    fontSize: 13,
    justifyContent: 'center',


    color: 'white',
    alignSelf: 'center',
  },
  //Based ON Platform
  opencancel: {
    flex: 1,
    ...Platform.select({
      ios: {
        backgroundColor: 'red', margin: 20, height: 30, alignItems:
          "center", justifyContent: 'center'
      },
      android: {
        backgroundColor: 'red', margin: 20, height: 30, alignItems:
          "center", justifyContent: 'center'
      },
    }),
  },
  opensave: {
    flex: 1,
    ...Platform.select({
      ios: {
        backgroundColor: 'green', margin: 20, height: 30, alignItems:
          "center", justifyContent: 'center'
      },
      android: {
        backgroundColor: 'green', margin: 20, height: 30, alignItems:
          "center", justifyContent: 'center'
      },
    }),
  },
});
