/*
FileName:UserArchive.js
Version:1.0.0
Purpose:View user complted Sprints
Devloper:Mahesh 
*/
import React, { Component } from 'react';
import { Platform, StyleSheet, Text, View, Dimensions, FlatList, TouchableHighlight, Picker, Image, TouchableOpacity, TextInput, Alert } from 'react-native';
import { Left, Button, Container, Header, Body, Title, Content, Item, Input, Right,Icon } from 'native-base';
import AsyncStorage from '@react-native-community/async-storage';
import { widthPercentageToDP as wp, heightPercentageToDP as hp } from 'react-native-responsive-screen';
import Modal from "react-native-simple-modal";
// import Icon from 'react-native-vector-icons/FontAwesome';
import { API } from "../WebServices/RestClient";
import NetInfo from '@react-native-community/netinfo';
import jwt_decode from "jwt-decode";
import Snackbar from 'react-native-snackbar';
import Toast from 'react-native-whc-toast';
// import DropDownPicker from 'react-native-dropdown-picker';
import ModalSelector from 'react-native-modal-selector';
// import { Dropdown } from 'react-native-material-dropdown';
import log from '../LogFile/Log';
import {
  BallIndicator,
  BarIndicator,
  DotIndicator,
  MaterialIndicator,
  PacmanIndicator,
  PulseIndicator,
  SkypeIndicator,
  UIActivityIndicator
} from 'react-native-indicators';

import { MODULES, TITLE, MODULEID, MODIFY, DELETE } from '../CommonComponents/Header';
import UserDatabase from '../OfflineDB/UserDatabase';
const db = new UserDatabase();

FOOTER_MAX_HEIGHT = 50
FOOTER_MIN_HEIGHT = 40

class ListItem extends React.Component {

  constructor(props) {
    super(props)

    this.state = {

      deletevisibility: false
    }
  }

  componentDidMount() {
    log("Debug", "Add Module screen is loaded");
    this.VisibleActions();
  }
  //Visable actions based on role start
  async VisibleActions() {

    AsyncStorage.getItem("emp_role", (err, res) => {

      //Alert.alert(res);

      if (res == 'Emp' || res == 'Manager' || res == 'Approver') {

        this.setState({ deletevisibility: true });
      } else {

        this.setState({ deletevisibility: false });
      }

    });

  }
  //Visable actions based on role close

  render() {
    const { item } = this.props;

    let button;

    if (this.state.deletevisibility === false) {
      button =
        <TouchableOpacity onPress={() => this.props.deleteAction()} style={{ margin: 2, backgroundColor: 'red', marginLeft: 5 }}>
          <Text style={{ color: '#fff', textAlign: 'center' }}>{DELETE}</Text></TouchableOpacity>
    } else {
      button = null;
    }

    let button2;
    const { usertype } = this.props;
    if (item.assignbyId === usertype) {
      button2 =
        <View style={{ flexDirection: 'row', justifyContent: 'flex-end', alignItems: 'center' }}>
          <TouchableOpacity style={{ margin: 2, backgroundColor: 'red', paddingRight: 10, justifyContent: 'center' }} onPress={this.props.deleteAction}>
            <Text style={{ color: '#fff', textAlign: 'center', justifyContent: 'center', alignItems: 'center', marginLeft: 10 }}>{DELETE}</Text></TouchableOpacity>

        </View>

    } else {
      button2 = null;


    }
    return (

      <View style={Number(item.average) === 100 ? styles.container1 : styles.container}>
        <TouchableOpacity onPress={this.props.MainTask}>

          <View style={styles.box}>

            <View style={{ flexDirection: 'row', width: wp('60%') }}>
              <Text style={styles.signUpText0} >{MODULEID}:</Text>
              <Text style={styles.signUpText1} >{item.s_id}</Text>
             
            </View>
            <Text style={styles.signUpText2} > {item.created_date}</Text>

          </View>
          <View
            style={{
              borderBottomColor: '#C0C0C0',
              borderBottomWidth: 0.3,
            }}
          />

          <View style={{ flexDirection: 'row', paddingRight: 25, }}>
            <Text style={styles.signUpText4} >{TITLE}:</Text>
            <Text style={styles.signUpText3} >{item.sprint_desc}</Text>
          </View>
          <View style={{ flexDirection: 'row', paddingRight: 25, }}>
            <Text style={styles.signUpText4} >Sprint Time:</Text>
            <Text style={styles.signUpText3} >[{item.start_date} - {item.target_date}]</Text>
          </View>


          {/* <View style={{ flexDirection: 'row', justifyContent: 'flex-end', alignItems: 'center', paddingBottom: 10 }}>
            <TouchableOpacity onPress={() => this.props.ModifyModule()} style={{ margin: 2, backgroundColor: 'black' }}>
              <Text style={{ color: '#fff', textAlign: 'center' }}>{MODIFY}</Text></TouchableOpacity>

              {button}
            {button2}
          </View> */}




        </TouchableOpacity>

      </View>

    )
  }
}

export default class UserArchive extends React.Component {

  constructor(props) {
    super(props);
    this.state = {
      open: false,
      modulename: '',
      role: '',
      userToken: '',
      isLoading: true,
      dataSource: [],
      empstatus: '',
      dataSource1: [],
      isFetching: false,
      modalVisible: false,
      //   idea_id: this.props.navigation.state.params.idea_id,
      //   idea_title: this.props.navigation.state.params.idea_title,
      action: '',
      moduleid: '',
      error1: '',
      itemPressedDisabled: false,
      squadName: '',
    };

    AsyncStorage.getItem("cropcode", (err, res) => {
      this.setState({ squadName: res });
      console.warn("squadname" + this.state.squadName);
    });

  }
  //open the Modal 
  modalDidOpen = () => console.log("Modal did open.");
  //close the Modal
  modalDidClose = () => {

    this.setState({ open: false }); this.setState({ open: false });
    console.log("Modal did close.");

  };

  //Dialog Actions start
  moveUp = () => this.setState({ offset: -100 });

  resetPosition = () => this.setState({ offset: 0 });

  openModal = () => this.setState({ open: true });

  //close dialog
  closeModal = () => {
    this.setState({
      open: false, error1: ''
    });
    this.setState({ modulename: '' })
  }
  //Dialog Actions close

  componentDidMount() {
    log("Debug", " getModules screen is loaded");
    NetInfo.fetch().then(state => {
      if (state.type == "none" || state.type == 'unknown' || state.type == 'undefined') {
        console.log(state.type);
        Snackbar.show({
          title: 'No Internet Connection',
          backgroundColor: 'red',
          duration: Snackbar.LENGTH_LONG,
        });
        this.GetStatus();
        this.getArchiveList() //Offline Approved Projects List
      } else {
        this.getModules();
        this.GetStatus();
      }
    });
    AsyncStorage.getItem("userToken", (err, res) => {
      this.setState({ usertype: res });
      console.warn(this.state.usertype);
    });

    // this.setModalVisible(!this.state.modalVisible);
  }

  //list of Modules getting
  add() {

    this.getModules();
  }

  //refresh data
  onRefresh() {
    this.setState({ isFetching: true }, function () { this.add() });
  }

  // componentWillReceiveProps(nextProps) {
  //   console.log(nextProps);
  //   console.log("re loading...........")
  //   this.getModules();
  // }
  componentWillReceiveProps(nextProps) {
    NetInfo.fetch().then(state => {
      if (state.type == "none" || state.type == 'unknown' || state.type == 'undefined') {
        console.log(state.type);
        Snackbar.show({
          title: 'No Internet Connection',
          backgroundColor: 'red',
          duration: Snackbar.LENGTH_LONG,
        });
        this.getModules(); //For pending subtaskslist from offline
      } else {
        this.getModules();
      }
    });

  }
  //For store Agile projects for offline Start
  addAgileProjects(data) {
    console.warn("hello naveen" + JSON.stringify(data));
    db.addAgileProjects(data).then((result) => {
      console.log(result);
    }).catch((err) => {
      console.log(err);
    })
  }
  //For store Agile projects for offline End
  //For Getting offline Project List Start
  getAgileProjects() {
    db.getAgileProjects().then((data) => {
      console.warn("AgileProjectsList" + JSON.stringify(data))
      this.setState({
        data2: data,
      });
    }).catch((err) => {
    })
  }
  //For Getting offline Project List End

  //For Archives List from offline
  getArchiveList() {
    AsyncStorage.getItem("cropcode", (err, res) => {
      const projectName = res;
      db.getArchiveList(projectName).then((data) => {
        console.warn("Approved ProjectList" + JSON.stringify(data))
        this.setState({
          dataSource: data,
          isLoading: false,
        });
        this.arrayholder = data;
      }).catch((err) => {
        console.log(err);
        this.setState = {
          isLoading: false
        }
      })
    });
  }

  //For store Archives list from offline
  addArchivesList(data, cropcode) {
    console.warn("addarchives" + JSON.stringify(data))
    db.addArchivesList(data, cropcode).then((result) => {
      this.setState({
        isLoading: false,
      });
    }).catch((err) => {

      this.setState({
        isLoading: false,
      });
    })
  }


  //get project list dropdown data
  GetStatus() {
    log("Info", "UserProfile:GetStatus() method is used to get status of employee");
    AsyncStorage.getItem("userToken", (err, res) => {
      const empId = res;
      NetInfo.fetch().then(state => {
        if (state.type == "none" || state.type == 'unknown' || state.type == 'undefined') {
          // console.log(state.type);
          Snackbar.show({
            title: 'No Internet Connection',
            backgroundColor: 'red',
            duration: Snackbar.LENGTH_LONG,
          });
          this.getAgileProjects(); //Get offline Project List
        } else {

          fetch(API + 'squads.php', {
            method: 'POST',
            headers: {
              Accept: 'application/json',
              'Content-Type': 'application/json',
            },
            body: JSON.stringify({

              empId: empId,
              action:'get_squads',


            })
          })
            .then((response) => response.json())
            .then((responseJson) => {
              console.warn(responseJson)
              if (responseJson.status == 'True') {
                // this.setState({
                //     isLoading: false,
                //     dataSource1: [...responseJson.data],
                // }, function () {
                //     // In this block you can do something with new state.
                // });
                console.log("Testing" + JSON.stringify(responseJson.data))
                const data2 = [];
                this.addAgileProjects(responseJson.data) //Project list store in offline

                responseJson.data.map(x => {
                  data2.push({ label: x.value, value: x.value })
                })
                this.setState({
                  data2: data2,
                })
                console.warn("Hello" + JSON.stringify(data2))

                // this.setState({
                //     data2: responseJson.data
                // });
                console.warn(this.state.data2);
              } else {
                log("Warn", "status of employee is not available");
              }
            })
            .catch((error) => {
              console.error(error);
              log("Error", "error in  getting status of employee");
            });
        }
      });
    });

  }

  // Update Status of Employee
  UpdateStatus(squadName) {
    // const { squadName } = this.state;
    log("Info", "UserProfile:UpdateStatus(status) method is used to update status of employee");
    console.warn("project" + JSON.stringify(squadName));

    AsyncStorage.getItem("userToken", (err, res) => {
      const empId = res;
      console.log(res);

      AsyncStorage.getItem("projectId", (err, res) => {
        const projectId = res;



      // console.log(cropcode);
      NetInfo.fetch().then(state => {
        if (state.type == "none" || state.type == 'unknown' || state.type == 'undefined') {
          console.log(state.type);
          Snackbar.show({
            title: 'No Internet Connection',
            backgroundColor: 'red',
            duration: Snackbar.LENGTH_LONG,
          });
          //for offline project switching start
          this.setState({
            squadName: squadName
          });
          AsyncStorage.setItem('cropcode', squadName);
          this.getArchiveList()
          //for offline project switching end
        } else {

          fetch(API + 'squad_login.php', {
            method: 'POST',
            headers: {
              Accept: 'application/json',
              'Content-Type': 'application/json',
            },
            body: JSON.stringify({
              username: empId,
              corp: squadName,
              projectId:projectId
            })
          })
            .then((response) => response.json())
            .then((responseJson) => {
              console.warn(JSON.stringify(responseJson))
              alert(JSON.stringify(responseJson))

              if (responseJson.status == 'TRUE') {
                AsyncStorage.setItem('auth', responseJson.jwt) //store the token information  with exp
                const tokenDetails = jwt_decode(responseJson.jwt);
                console.log(tokenDetails.data)
                AsyncStorage.setItem('roleCount', tokenDetails.data.roleCount)
                // dispatch(setCurrentUser(tokenDetails.data)); //store the user information
                AsyncStorage.setItem('status', tokenDetails.data.empStatus)


                AsyncStorage.setItem('userToken', tokenDetails.data.empId);
                AsyncStorage.setItem('userName', tokenDetails.data.userName);
                AsyncStorage.setItem('emp_role', tokenDetails.data.role);
                AsyncStorage.setItem('cropcode', tokenDetails.data.corp);
                AsyncStorage.setItem('projectId', tokenDetails.data.projectId);
                // this.props.navigation.navigate('UserProfile');
                // console.warn("HI" + empstatus)
                this.setState({

                  squadName: tokenDetails.data.corp,

                });
                //  alert("Project Changed Successfully")
                this.getModules();

              } else {
                //    alert("user already exist");
                log("Warn", "status of employee is not able to update");
              }

            })
            .catch((error) => {
              console.warn(error);
              log("Error", "error in updating status of employee");
            });
        }
      });
    });
  });

  }





  //get Module list start
  getModules() {

    const { idea_id } = this.state;

    console.log(idea_id);

    AsyncStorage.getItem("cropcode", (err, res) => {

      const cropcode = res;
      AsyncStorage.getItem("emp_role", (err, res) => {

        AsyncStorage.getItem("projectId", (err, res) => {
          const projectId = res;
        const role = res;
        AsyncStorage.getItem("userToken", (err, res) => {
          const empId = res;
          NetInfo.fetch().then(state => {
            if (state.type == "none") {
              console.log(state.type);
              log("Warn", "No internet connection");
              Snackbar.show({
                title: 'No Internet Connection',
                backgroundColor: 'red',
                duration: Snackbar.LENGTH_LONG,
              });
            } else {
              fetch(API + 'archive.php',
                {
                  method: 'POST',
                  headers: {
                    Accept: 'application/json',
                    'Content-Type': 'application/json',
                  },
                  body: JSON.stringify({
                    action: 'getCompletedSprints',
                    // empId: empId,
                    // userType: role,
                    // idea_id: idea_id,
                    crop: cropcode,
                    projectId:projectId,
                  })
                })
                .then((response) => response.json())
                .then((responseJson) => {
                  //  alert(JSON.stringify(responseJson));
                  console.log("Hello" + JSON.stringify(responseJson))
                  // console.warn("Hello"+typeof(100.00));
                  // console.warn(Number(100.00));
                  if (responseJson.status === 'True') {
                    this.addArchivesList(responseJson.data, cropcode) //Store Approved Projects List Offline

                    this.setState({
                      isLoading: false,
                      dataSource: responseJson.data,
                      isFetching: false
                    }, function () {

                    });
                    this.arrayholder = responseJson.data;
                  }

                  else {
                    this.arrayholder = [];
                    this.setState({
                      isLoading: false,
                      dataSource: [],
                    })
                    Snackbar.show({
                      title: 'No Sprints',
                      backgroundColor: '#3BB9FF',
                      duration: Snackbar.LENGTH_LONG,
                    });
                  }
                })

                .catch((error) => {
                  this.setState({
                    isLoading: false,
                  })
                  console.error(error);
                  log("Error", "Add Module error");
                });
            }
          });
        });
      });
    });
  });
  }
  //get Module list end

  //Validatios
  isValid() {
    const { modulename } = this.state;
    let valid = false;

    if (modulename.length === 0) {
      log("Warn", "module name should not be empty");
      // ToastAndroid.showWithGravity('"Enter sub Task', ToastAndroid.SHORT,ToastAndroid.CENTER);
      this.setState({ error1: 'Module Title ' });
    }

    else {
      valid = true;
    }
    return valid;
  }
  //Add the new Module
  //   addModule() {

  //     const { modulename } = this.state;
  //     const { idea_id } = this.state;
  //     console.log("idea_id" + idea_id);
  //     console.log("modulename" + modulename);

  //     //getting cropcode,usertoken(emp id)
  //     AsyncStorage.multiGet(["cropcode", "userToken"], (err, response) => {
  //       const cropcode = response[0][1];
  //       const userToken = response[1][1];
  //       console.log("userToken" + userToken);
  //       console.log("cropcode" + cropcode);
  //       NetInfo.fetch().then(state => {
  //         if (state.type == "none") {
  //           console.log(state.type);
  //           log("Warn", "No internet connection");
  //           Snackbar.show({
  //             title: 'No Internet Connection',
  //             backgroundColor: 'red',
  //             duration: Snackbar.LENGTH_LONG,
  //           });
  //         }
  //         else{

  //           if(this.isValid()){
  //             this.setState({ itemPressedDisabled: true })
  //       fetch(API+'manageModule.php',
  //         {
  //           method: 'POST',
  //           headers: {
  //             Accept: 'application/json',
  //             'Content-Type': 'application/json',
  //           },
  //           body: JSON.stringify({
  //             action: 'add',
  //             idea_id: idea_id,
  //             crop: cropcode,
  //             module_Name: modulename,
  //             empId: userToken

  //           })
  //         })
  //         .then((response) => response.json())
  //         .then((responseJson) => {
  //           console.warn(responseJson)
  //           this.refs.toast.show('Module Added', Toast.Duration.long, Toast.Position.center);
  //           if (responseJson.status == 'True') {
  //             this.setState({ itemPressedDisabled: false })
  //             this.setState({ open: false,error1: '', });
  //             this.getModules();
  //           }

  //         })
  //         .catch((error) => {
  //           console.error(error);
  //           log("Error", "error in project adding");
  //         });
  //         this.closeModal();
  //       }
  //     }
  //     });
  //     });

  //   }

  //delete Module Alert start
  deleteAction(item, index) {
    Alert.alert(
      'Alert..!',
      'Do you want to delete Module',
      [
        {
          text: 'NO',
          onPress: () => console.log('Cancel Pressed'),
          style: 'cancel',
        },
        { text: 'YES', onPress: () => this.deleteModule(item) },
      ],
      { cancelable: false },
    );
  }
  //delete Module  Alert end

  //delete the Module start
  deleteModule = (item) => {
    //cropcode getting
    AsyncStorage.getItem("cropcode", (err, res) => {
      const crop = res;
      //empid getting
      AsyncStorage.getItem("userToken", (err, res) => {
        const empId = res;
        // alert(item.moduleId + empId)
        NetInfo.fetch().then(state => {
          if (state.type == "none") {
            console.log(state.type);
            log("Warn", "No internet connection");
            Snackbar.show({
              title: 'No Internet Connection',
              backgroundColor: 'red',
              duration: Snackbar.LENGTH_LONG,
            });
          } else {
            fetch(API + 'manageModule.php', {
              method: 'POST',
              headers: {
                'Accept': 'application/json',
                'Content-Type': 'application/json',
              },
              body: JSON.stringify({
                moduleid: item.moduleId,
                empId: empId,
                action: "delete",
                crop: crop,
                idea_id: ideaId,
              })
            }).then((response) => response.json())
              .then((responseJson) => {
                console.log(JSON.stringify(responseJson));
                console.log(responseJson);
                if (responseJson.status === 'True') {
                  console.log("done")
                  this.setState({ open: false })
                  //   this.props.navigation.navigate("AddModule", { idea_id: this.state.idea_id });
                } else {
                  log("Warn", "You can't delete this module");
                  alert("Having maintasks,you cannot delete this module");
                }
              }).catch((error) => {
                console.error(error);
                log("Error", "error in delete Module ");
              });
          }
        });
      });
    });
  };
  //delete the Module start

  //Navigate to maintask screen
  MainTask(item, index) {

    console.log(item);
    console.log(index);

    console.log(item.ideaId + item.moduleId);
    log("Info", "MainTask() method is used to move Add Module to Add MainTask screen");
    this.props.navigation.navigate('AddMainTask1', { moduleId: item.sprint_id, empId: item.empId, idea_title: item.ideaTitle, ideaid: item.epic_id, moduledesc: item.moduleDesc, });

    // this.props.navigation.navigate('AddMainTask', { moduleId: item.moduleId,empId:item.empId,idea_title:item.ideaTitle, ideaid: item.ideaId,moduledesc:item.moduleDesc,idea_title:this.state.idea_title});

  }

  //Navigate to Module Modify Screen
  ModifyModule(item, index) {
    console.log(item);
    console.log(index);
    log("Info", "ModifyModule() method is used to move Add Module to Add ModuleAdd screen");
    this.props.navigation.navigate('ModuleAdd', { action: 'modify', startDate: item.startDate, targetDate: item.targetDate, moduleId: item.moduleId, idea_title: item.ideaTitle, ideaid: item.ideaId, moduledesc: item.moduleDesc });

  }

  //Seperate the list of data
  FlatListItemSeparator = () => {
    return (
      <View
        style={{
          //  height: .5,
          width: "100%",
          backgroundColor: "#000",
        }}
      />
    );
  }


  //For empty data(No list available)
  _listEmptyComponent = () => {
    return (
      <View style={{ width: '90%', height: '80%' }}>
        <Text></Text>
      </View>
    )
  }


  //to filter the search in put by user 
  SearchFilterFunction(text) {
    log("Info", "UserApprovedProjects:SearchFilterFunction(text) method is used for search functionality");
    console.log(text);
    const newData = this.arrayholder.filter(function (item) {
      const sprint_id = item.sprint_id.toUpperCase()
      const sprint_id1 = text.toUpperCase()
      const start_date = item.start_date.toUpperCase()
      const start_date1 = text.toUpperCase()
      const target_date = item.target_date.toUpperCase()
      const target_date1 = text.toUpperCase()
      const sprint_desc = item.sprint_desc.toUpperCase()
      const sprint_desc1 = text.toUpperCase()
      //   const createdBy = item.createdBy.toUpperCase()
      //   const createdBy1 = text.toUpperCase()
      //   const created_on = item.created_on.toUpperCase()
      //   const created_on1 = text.toUpperCase()



      return sprint_id.indexOf(sprint_id1) > -1 ||
      start_date.indexOf(start_date1) > -1 ||
      target_date.indexOf(target_date1) > -1 ||
      sprint_desc.indexOf(sprint_desc1) > -1


    })
    this.setState({
      dataSource: newData,
      text: text
    })
  }

  render() {
    if (this.state.isLoading) {
      return (
        <View style={{ flex: 1, alignItems: 'center', justifyContent: 'center' }}>
          <DotIndicator color='#00A2C1' />
        </View>
      );

    }
    return (
      <Container style={{ height: Dimensions.get('window').height }}>
        {/* <NavigationEvents
          onDidFocus={() => this.onRefresh()}
        /> */}

        <Header
          androidStatusBarColor="#00A2C1"
          style={{
            backgroundColor: '#00A2C1',
            height: 60,
            width: Dimensions.get('window').width,
            borderBottomColor: '#ffffff',
            justifyContent: 'space-between',
          }}>
          <View style={{ marginTop: 20 }}>
            <Icon name="md-menu" size={25} style={{ color: 'white', }} onPress={() =>
              this.props.navigation.toggleDrawer()} />
          </View>

          {/* <View style={{backgroundColor:'white',width:200,borderRadius:20,paddingBottom:10}}>
                  
                  <Dropdown
     label={this.state.squadName}
      data={this.state.dataSource1}
      style={{width:200,marginBottom:10}}
      onChangeText={(itemValue) => { this.UpdateStatus(itemValue) }}
      value={this.state.squadName}

    />
    </View> */}
          {/* <View style={{ flexDirection: 'row', marginLeft: 15 }}> */}
          {/* <View style={{backgroundColor:'white',width:300,borderRadius:20,height:50,marginTop:5}}> */}
          <View style={{ width: 300, borderRadius: 20, height: 45, marginTop: 5, flexDirection: 'row' }}>

          <ModalSelector
            style={{ width: 260, backgroundColor: 'transparent', borderColor: 'transparent', marginLeft: 60 }}
            data={this.state.data2}
            optionContainerStyle={{ backgroundColor: 'white' }}
            initValue={this.state.squadName}
            onChange={(itemValue) => { this.UpdateStatus(itemValue.label) }} >
            <View style={{ width: 300, borderRadius: 20, backgroundColor: '#00A2C1', height: 45, flexDirection: 'row' }}>
              <Text style={{ marginTop: 15, color: 'white', width: 80 }}>PROJECT : </Text>

              <Text style={{ marginTop: 15, color: 'white', width: 120, }}>{this.state.squadName}</Text>

              <Icon name="md-chevron-down-outline" size={25} style={{ color: 'white', marginTop: 10, }}
              />
            </View>

          </ModalSelector>
</View>
          {/* <DropDownPicker
          label={this.state.data2}
          items={this.state.data2}
          placeholder={this.state.squadName}

          onChangeItem={(itemValue) => { this.UpdateStatus(itemValue) }}
          value={this.state.squadName}

          containerStyle={{ height: 40, width: 300, paddingLeft: 10, marginTop: 10, marginLeft: 30 }}
          style={{ backgroundColor: '#fafafa' }}
          itemStyle={{
            justifyContent: 'flex-start',
            // height:'2%'
          }}
          // defaultValue={this.state.data2}
          dropDownStyle={{ backgroundColor: '#fafafa', height: 80 }}

        /> */}
          {/* <Picker
                    
                     style={pickerSelectStyles.inputAndroid}
                        selectedValue={this.state.squadName}
                        // onChangeText={(itemValue) => { this.UpdateStatus(itemValue) }}
                        

                        // onValueChange={(itemValue, itemIndex) => this.setState({ squadName: itemValue })} >

                         onValueChange={(itemValue, itemIndex) => this.UpdateStatus(itemValue)} >

                        {this.state.dataSource1.map((item, key) => (
                            <Picker.Item label={item.value} value={item.value} key={key} />)
                        )}

                    </Picker> */}
        </Header>
        <Item>
          <Input placeholder="Search"
            onChangeText={(text) => this.SearchFilterFunction(text)} />
          <Icon size={20} name="search" />
        </Item>
        <View style={styles.MainContainer}>
          <Toast ref="toast" />
          <View style={{ height: '100%' }}>

            <FlatList

              extraData={this.state}
              keyExtractor={this._keyExtractor}
              renderItem={this._renderItem}

              data={this.state.dataSource}

              onRefresh={() => this.onRefresh()}
              refreshing={this.state.isFetching}

              ItemSeparatorComponent={this.FlatListItemSeparator}
              renderItem={({ item, index }) =>
                <View>

                  <ListItem navigation={this.props.navigation}
                    item={item}
                    usertype={this.state.usertype}
                    MainTask={() => this.MainTask(item, index)}//For Add Maintask
                    // openModal={() => this.openModal(item, index)}//For Add Module
                    ModifyModule={() => this.ModifyModule(item, index)}//For Modify Module
                    deleteAction={() => this.deleteAction(item, index)}//For delete module
                  />
                </View>
              }
              keyExtractor={item => item.id}
              ListEmptyComponent={this._listEmptyComponent}
            />

          </View>
          {/* <View style={{height:hp('15%')}}></View> */}
          {/* <View style={styles.bottomView} >
          <TouchableOpacity onPress={this.openModal} >
            <Text style={styles.textStyle}>ADD MODULE</Text>
            </TouchableOpacity>
          </View> */}

          <Modal
            offset={this.state.offset}
            open={this.state.open}
            modalDidOpen={this.modalDidOpen}
            modalDidClose={this.modalDidClose}
            closeOnTouchOutside={false}
            style={{ alignItems: "center" }} >

            <View style={{ alignItems: "center", paddingBottom: 40 }}>

              <Text>MODULE INFO</Text>

              <TextInput placeholder='Module Title'
                style={{ height: 40, borderBottomWidth: 1, borderBottomColor: 'black', width: 300, marginTop: 10 }}
                onChangeText={(text) => this.setState({ modulename: text })}
                value={this.state.modulename} />
              <Text style={{ color: 'red', alignItems: 'flex-start', alignSelf: 'flex-start', justifyContent: 'flex-start', marginLeft: 25 }}>{this.state.error1}</Text>


            </View>
            {/* <View style={{flexDirection:'row',marginTop:20,alignItems:'center',justifyContent:'center',alignSelf:'center',}}>
          <TouchableOpacity style={styles.opensave} onPress={this.addModule.bind(this)}  disabled={this.state.itemPressedDisabled}>
                <Text style={{ color: 'white' }}>SAVE</Text>
              </TouchableOpacity>
              <TouchableOpacity style={styles.opencancel} onPress={this.closeModal} >
                <Text style={{ color: 'white' }}>CANCEL</Text>
              </TouchableOpacity>
              
            </View> */}

          </Modal>


        </View>
        {/* <Content> */}



        {/* </Content> */}
      </Container>


    );

  }

}
//Styles for UI
const styles = StyleSheet.create(
  {
    MainContainer:
    {
      flex: 1,
      width: Dimensions.get('window').width,
      height: Dimensions.get('window').height,
      backgroundColor: '#f8f8f8'
    },
    bottomView: {
      flexDirection: 'row',
      justifyContent: 'center',
      position: 'absolute',
      height: FOOTER_MAX_HEIGHT,
      bottom: 0,
      left: 0,
      right: 0,
      backgroundColor: 'black',
      alignItems: 'center'
    },

    textStyle: {
      color: '#fff',
      fontSize: 18,
      // backgroundColor:'#00a2c1',
      paddingLeft: 10,
      paddingRight: 10,
      paddingBottom: 5,
      paddingTop: 5,
      borderRadius: 5,

    },
    container: {
      flex: 1,
      width: '100%',
      backgroundColor: '#fff'

    },
    container1: {
      flex: 1,
      width: '100%',
      backgroundColor: '#BEF29F',

    },
    footer: {
      position: 'absolute',
      flex: 0.1,
      left: 0,
      right: 0,
      bottom: -10,
      backgroundColor: 'green',
      flexDirection: 'row',
      height: 80,
      alignItems: 'center',
    },
    bottomButtons: {
      alignItems: 'center',
      justifyContent: 'center',
      flex: 1,
    },
    footerText: {
      color: 'white',
      fontWeight: 'bold',
      alignItems: 'center',
      fontSize: 18,
    },
    buttonContainer: {
      width: wp('90%'),
      alignSelf: 'baseline',
      marginBottom: 25,
      color: '#d2691e',
      marginLeft: 4,
      backgroundColor: '#f8f8f8',



    },
    signupButton: {

      backgroundColor: '#f8f8f8',
    },
    subcontainer: {
      flex: 2,
      flexDirection: 'row',
      paddingTop: 40
    },
    signUpText0: {
      fontSize: 13,
      color: 'green',
      paddingTop: 10,
      paddingLeft: 5,
      fontWeight: "bold",

    },
    signUpText1: {
      fontSize: 13,
      color: 'green',
      paddingTop: 10,
      fontWeight: "bold",
      // width: '70%'
    },
    end: {

      alignItems: 'flex-end',

    },
    end1: {
      flex: 2,
      height: '50%',
      paddingTop: 20,
      justifyContent: 'space-between',

      flexDirection: 'row',
    },
    s: {
      justifyContent: 'center',

      backgroundColor: '#ed7070',
      shadowOffset: { width: 50, height: 50 },
      alignItems: 'center',
      width: wp('40%'),
      height: hp('12%'),

    },
    signUpText2: {
      fontSize: 10,
      fontSize: 13,
      color: 'black',
      paddingTop: 10,


    },
    signUpText3: {

      fontSize: 12,
      paddingTop: 10,
      paddingLeft: 10,

      alignItems: 'center',
    },
    signUpText4: {
      fontSize: 12,
      paddingTop: 10,
      paddingLeft: 5,
      // backgroundColor:'#f8f8f8',


      alignItems: 'center',
    },
    signup: {

      color: "#FFF",

    },
    boxone: {
      flex: 1,


    },
    boxtwo: {
      flex: 1,

    },
    boxthree: {
      flex: 1,

    },
    box: {
      flexDirection: 'row'



    },
    signUpText: {
      fontSize: 20,
      justifyContent: 'center',


      color: 'white',
      alignSelf: 'center',
    },
    opencancel: {
      flex: 1,
      ...Platform.select({
        ios: {
          backgroundColor: 'red', margin: 20, height: 30, alignItems:
            "center", justifyContent: 'center'
        },
        android: {
          backgroundColor: 'red', margin: 20, height: 30, alignItems:
            "center", justifyContent: 'center'
        },
      }),
    },
    opensave: {
      flex: 1,
      ...Platform.select({
        ios: {
          backgroundColor: 'green', margin: 20, height: 30, alignItems:
            "center", justifyContent: 'center'
        },
        android: {
          backgroundColor: 'green', margin: 20, height: 30, alignItems:
            "center", justifyContent: 'center'
        },
      }),
    },
  });
const pickerSelectStyles = StyleSheet.create({
  inputIOS: {
    fontSize: 2,
    paddingVertical: 12,
    paddingHorizontal: 10,
    borderWidth: 1,
    borderColor: 'blue',
    borderRadius: 4,
    color: 'black',
    paddingRight: 30, // to ensure the text is never behind the icon
  },
  inputAndroid: {
    fontSize: 3,
    paddingHorizontal: 10,
    paddingVertical: 8,
    borderWidth: 0.5,
    borderColor: 'black',
    borderRadius: 8,
    color: 'black',
    paddingRight: 30, // to ensure the text is never behind the icon
    // backgroundColor:'pink'
  },
});
