/*
FileName:UserNlotification.js
Version:1.0.0
Purpose:Notification
Devloper:Mahesh Reddy
*/
import React, { Component } from 'react';
import { Platform, StyleSheet, Text, View, Image, StatusBar, Dimensions, TextInput, Alert } from 'react-native';
import { Title, Button, Container, Content, Header, Right, Left, Body, Tab, Tabs, TabHeading, Footer, Item, Input, FooterTab } from 'native-base';
import { widthPercentageToDP as wp, heightPercentageToDP as hp } from 'react-native-responsive-screen';
import { TouchableOpacity } from 'react-native-gesture-handler';
import AsyncStorage from '@react-native-community/async-storage';
// import DropDownPicker from 'react-native-dropdown-picker';
import jwt_decode from "jwt-decode";
import { API } from "../WebServices/RestClient";
import NetInfo from '@react-native-community/netinfo';
import Snackbar from 'react-native-snackbar';
import log from '../LogFile/Log';
import Icon from 'react-native-vector-icons/FontAwesome';
import ModalSelector from 'react-native-modal-selector';

export default class UserNotification extends Component {

    constructor(props) {
        super(props);

        this.state = {
            isLoading: true,

            name: '',

        }
        AsyncStorage.getItem("cropcode", (err, res) => {
            this.setState({ squadName: res });
            console.warn("squadname" + this.state.squadName);
        });
    }


    componentDidMount() {

        this.GetStatus();


    }



    //get project list dropdown data
    GetStatus() {
        log("Info", "UserProfile:GetStatus() method is used to get status of employee");
        AsyncStorage.getItem("userName", (err, res) => {
            const userName = res;
            NetInfo.fetch().then(state => {
                if (state.type == "none" || state.type == 'unknown' || state.type == 'undefined') {
                    // console.log(state.type);
                    Snackbar.show({
                        title: 'No Internet Connection',
                        backgroundColor: 'red',
                        duration: Snackbar.LENGTH_LONG,
                    });
                } else {

                    fetch(API + 'squadsList.php', {
                        method: 'POST',
                        headers: {
                            Accept: 'application/json',
                            'Content-Type': 'application/json',
                        },
                        body: JSON.stringify({

                            username: userName,


                        })
                    })
                        .then((response) => response.json())
                        .then((responseJson) => {
                            console.warn(responseJson)
                            if (responseJson.status == 'True') {
                                // this.setState({
                                //     isLoading: false,
                                //     dataSource1: [...responseJson.data],
                                // }, function () {
                                //     // In this block you can do something with new state.
                                // });
                                console.log("Testing" + JSON.stringify(responseJson.data))
                                const data2 = [];

                                responseJson.data.map(x => {
                                    data2.push({ label: x.value, value: x.value })
                                })
                                this.setState({
                                    data2: data2,
                                })
                                console.warn("Hello" + JSON.stringify(data2))

                                // this.setState({
                                //     data2: responseJson.data
                                // });
                                console.warn(this.state.data2);
                            } else {
                                log("Warn", "status of employee is not available");
                            }
                        })
                        .catch((error) => {
                            console.error(error);
                            log("Error", "error in  getting status of employee");
                        });
                }
            });
        });

    }

    // Update Status of Employee
    UpdateStatus(squadName) {
        // const { squadName } = this.state;
        log("Info", "UserProfile:UpdateStatus(status) method is used to update status of employee");
        console.warn("project" + JSON.stringify(squadName));

        AsyncStorage.getItem("userName", (err, res) => {
            const userName = res;
            console.log(res);



            // console.log(cropcode);
            NetInfo.fetch().then(state => {
                if (state.type == "none" || state.type == 'unknown' || state.type == 'undefined') {
                    console.log(state.type);
                    Snackbar.show({
                        title: 'No Internet Connection',
                        backgroundColor: 'red',
                        duration: Snackbar.LENGTH_LONG,
                    });
                } else {

                    fetch(API + 'squadLogin.php', {
                        method: 'POST',
                        headers: {
                            Accept: 'application/json',
                            'Content-Type': 'application/json',
                        },
                        body: JSON.stringify({
                            username: userName,
                            crop: squadName,

                        })
                    })
                        .then((response) => response.json())
                        .then((responseJson) => {
                            console.warn(JSON.stringify(responseJson))

                            if (responseJson.status == 'TRUE') {
                                AsyncStorage.setItem('auth', responseJson.jwt) //store the token information  with exp
                                const tokenDetails = jwt_decode(responseJson.jwt);
                                console.log(tokenDetails.data)
                                AsyncStorage.setItem('roleCount', tokenDetails.data.roleCount)
                                // dispatch(setCurrentUser(tokenDetails.data)); //store the user information
                                AsyncStorage.setItem('status', tokenDetails.data.empStatus)


                                AsyncStorage.setItem('userToken', tokenDetails.data.empId);
                                AsyncStorage.setItem('userName', tokenDetails.data.userName);
                                AsyncStorage.setItem('emp_role', tokenDetails.data.role);
                                AsyncStorage.setItem('cropcode', tokenDetails.data.corp);

                                // this.props.navigation.navigate('UserProfile');
                                // console.warn("HI" + empstatus)
                                this.setState({

                                    squadName: tokenDetails.data.corp,

                                });
                                //  alert("Project Changed Successfully")
                                //   this.getRequestedIdeas();

                            } else {
                                //    alert("user already exist");
                                log("Warn", "status of employee is not able to update");
                            }

                        })
                        .catch((error) => {
                            console.warn(error);
                            log("Error", "error in updating status of employee");
                        });
                }
            });
        });

    }



    render() {

        return (
            <Container>

<Header
                    androidStatusBarColor="#00A2C1"
                    style={{
                        backgroundColor: '#00A2C1',
                        height: 80,
                        width: Dimensions.get('window').width,
                        borderBottomColor: '#ffffff',
                        justifyContent: 'space-between',
                    }}>
                    <View style={{ marginTop: 20 }}>
                        <Icon name="bars" size={25} style={{ color: 'white', }} onPress={() =>
                            this.props.navigation.toggleDrawer()} />
                    </View>
                    {/* <View style={{ flexDirection: 'row', marginLeft: 15 }}> */}
                    <View style={{ width: 300, borderRadius: 20, height: 45, marginTop: 5, flexDirection: 'row' }}>


                        <ModalSelector
                            style={{ width: 260, backgroundColor: 'transparent', borderColor: 'transparent',marginLeft:60 }}
                            data={this.state.data2}
                            initValue={this.state.squadName}
                            optionContainerStyle={{backgroundColor:'white'}}
                            onChange={(itemValue) => { this.UpdateStatus(itemValue.label) }} >
                            <View style={{ width: 300, borderRadius: 20, height: 45, marginTop: 5, flexDirection: 'row' }}>
                            <Text style={{ marginTop: 15, color: 'white',   }}>PROJECT : </Text>

                                <Text style={{ marginTop: 15, color: 'white', width: 120,  }}>{this.state.squadName}</Text>

                                <Icon name="chevron-down" size={25} style={{ color: 'white', marginTop: 10,  }}
                                />
                            </View>

                        </ModalSelector>
                        </View>

                </Header>

                <Content>
                    <View style={{ flex: 1, textAlign: 'center', marginTop: '50%', height: '100%', justifyContent: 'center', alignItems: 'center' }}>
                        <Text>Notification Page </Text>
                        <Text>Coming Soon ...</Text>
                    </View>
                </Content>
            </Container>
        );
    }
}